#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 200007;

struct line {
  int a, b, idx;

  line() {}
  line(int x, int y, int z): a(x), b(y), idx(z) {}
  
  bool operator <(const line &x) const {
    return b==x.b ? a<x.a : b>x.b;
  }
};

int n, l, optimal_idx, k;
pair < int, int > a[N];
line arr[N];
long long mx, ps[N], ans[N];
vector < line > v;

double cross_x(line l1, line l2) {
  return (double)(l2.a - l1.a) / (double)(l1.b - l2.b);
}

void add_line(line l) {
  while(v.size()>=2 && cross_x(v[v.size()-2], v[v.size()-1])<=cross_x(v[v.size()-2], l)) {
    v.pop_back();
  }

  v.push_back(l);
}

long long eval(line l, long long x) {
  return l.a + l.b*1ll*x;
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int i, j;

  scanf("%d %d", &n, &l);
  for(i=1;i<=n;i++) {
    scanf("%d %d", &a[i].first, &a[i].second);
    mx = max(mx, a[i].first + a[i].second * 1ll * (l - 1));
  }

  sort(a + 1, a + 1 + n);
  reverse(a + 1, a + 1 + n);

  for(i=1;i<=n;i++) {
    ps[i] = ps[i-1] + a[i].first;
    arr[i] = line(a[i].first, a[i].second, i);
  }

  for(i=1;i<=n;i++) {
    add_line(arr[i]);
  }

  ans[1] = mx;

  optimal_idx = 0;

  for(k=2;k<=l && k<=n;k++) {
    if(k==l) {
      ans[k] = ps[k];
      continue;
    }

    int x = l - k;

    while(optimal_idx+1<(int)(v.size()) && eval(v[optimal_idx + 1], x)>eval(v[optimal_idx], x)) {
      ++optimal_idx;
    }

    for(int idxi=max(0, optimal_idx - 4);idxi<optimal_idx+4 && idxi<(int)(v.size());idxi++) {
      for(int idxj=idxi+1;idxj<optimal_idx+4 && idxj<(int)(v.size());idxj++) {
        i = min(v[idxi].idx, v[idxj].idx);
        j = max(v[idxi].idx, v[idxj].idx);

        long long curr = a[i].first + 0ll + a[i].second*1ll*x + a[j].first + 0ll + a[j].second*1ll*x;

        int to = k-2;

        curr += ps[to];
        if(to>=i) {
          curr -= a[i].first;
          curr += a[++to].first;
        }
        if(to>=j) {
          curr -= a[j].first;
          curr += a[++to].first;
        }

        ans[k] = max(ans[k], curr);
      }
    }
  }

  for(i=1;i<=n;i++) {
    printf("%lld\n", ans[i]);
  }

  return 0;
}
