#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#define pb push_back
#define mp make_pair
using namespace std;
const int N = 1e5 +  5;

int n, L;
struct person{

    long long a, b;

}p[N];

long long prefix[N];

bool by_a(person x, person y)
{
    if(x.a != y.a)
        return x.a > y.a;
    return x.b > y.b;
}

long long only_a(int k)
{
    long long res = 0;
    long long mx[2] = {0, 0};
    for(int i = 1; i <= k; i++)
        res += p[i].a;

    for(int i = 1; i <= k; i++)
    {
        if(p[i].b >= mx[0])
        {
            mx[1] = mx[0];
            mx[0] = p[i].b;
        }
        else
        {
            if(p[i].b >= mx[1])
                mx[1] = p[i].b;
        }
    }

    res += (L - k) * (mx[0] + mx[1]);

    return res;
}

long long two_b(int k)
{
    if(k >= n - 1)
        return 0;

    long long res = 0;
    long long mx[2] = {0, 0};

    for(int i = 1; i <= k - 2; i++)
        res += p[i].a;

    for(int i = k + 1; i <= n; i++)
    {
        long long eval = p[i].b * (L - k) + p[i].a;
        if(eval >= mx[0])
        {
            mx[1] = mx[0];
            mx[0] = eval;
        }
        else
        {
            if(eval >= mx[1])
                mx[1] = eval;
        }
    }

    res += mx[0] + mx[1];

    return res;
}

long long max_B_in_a(int k)
{
    long long best = 0;
    for(int i = 1; i <= k - 1; i++) /// remove last of A
        best = max(best, p[i].b);

    return best;
}

long long eval_max_b(int k)
{
    long long mx_b = 0;

    for(int i = k + 1; i <= n; i++)
    {
        long long eval = p[i].b * (L - k) + p[i].a;
        if(eval >= mx_b)
            mx_b = eval;
    }

    return mx_b;
}

long long one_each(int k)
{
    if(k == 1 || k == n)
        return 0;

    long long res = 0, res1 = 0, res2 = 0;
    long long mx_b = eval_max_b(k);

    res1 += mx_b;
    res2 += mx_b;


    long long best = max_B_in_a(k);
    res1 += prefix[k - 1];
    res1 += best * (L - k);

    res2 += prefix[k - 2];
    res2 += p[k].b * (L - k) + p[k].a;

    res = max(res1, res2);
    return res;
}


long long ans[N];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);

    cin >> n >> L;
    for(int i = 1; i <= n; i++)
        cin >> p[i].a >> p[i].b;

    sort(p + 1, p + n + 1, by_a);

    for(int i = 1; i <= n; i++)
        prefix[i] = prefix[i - 1] + p[i].a;

    for(int i = 1; i <= n; i++)
       ans[1] = max(ans[1], p[i].b * (L - 1) + p[i].a);

    for(int k = 2; k <= min(n, L); k++)
    {
        ans[k] = max(ans[k], only_a(k));
        ans[k] = max(ans[k], two_b(k));
        ans[k] = max(ans[k], one_each(k));
    }

    for(int i = 1; i <= n; i++)
        cout << ans[i] << endl;


    return 0;
}

/*

3 2
1 2
3 4
5 6

*/

/*

3 3
1 2
3 4
5 100

*/
