#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <cassert>
#define pb push_back
#define mp make_pair
using namespace std;
const int N = 1e2 + 5;

int n, m, k;
char tab[N][N];
bool vis[N][N];

vector <pair <int, int> > ans_v;
vector <pair <int, int> > c[2]; /// black and white

bool cool(int x, int y)
{
    if(x < 1 || x > n || y < 1 || y > m)
        return false;
    return !vis[x][y];
}

bool clean()
{
    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= m; j++)
            if(tab[i][j] == '#')
                return false;
    return true;
}



int dx[8] = {1, 1, -1, -1, 2, 2, -2, -2};
int dy[8] = {2, -2, 2, -2, 1, -1, 1, -1};

int curk;
void DFS_clean(int x, int y, int span = 0)
{
    vis[x][y] = true;
    if(span == curk)
    {
        ans_v.pb({x, y});
        return;
    }

    for(int i = 0; i < 8; i++)
        if(cool(x + dx[i], y + dy[i]))
            DFS_clean(x + dx[i], y + dy[i], span + 1);
}

void solve_clean()
{
    if(c[0].size() > c[1].size())
        swap(c[0], c[1]);

    int sz_ans = 0;
    for(int i = 0; i <= k + 1; i++)
    {
        int id = (i & 1);
        sz_ans += c[id].size();
    }

    printf("%d\n", sz_ans);
    for(int i = 0; i <= k + 1; i++)
    {
        int id = (i & 1);
        for(auto x: c[id])
        {
        //    cout << x.first - 1 << " " << x.second - 1 << endl;
            printf("%d %d\n", x.first - 1, x.second - 1);
        }
    }


 /*   for(int i = 0; i < ans_v.size(); i++)
    {
        ans_v[i].first--;
        ans_v[i].second--;
    }

    cout << (int)ans_v.size() << endl;
    for(auto x: ans_v)
    {
        cout << x.first << " " << x.second << endl;
    } */
}

int main()
{
    //ios_base::sync_with_stdio(false);
   // cin.tie(nullptr); cout.tie(nullptr);

    cin >> n >> m >> k;
    for(int i = 1; i <= n; i++)
        for(int j = 1; j <= m; j++)
            cin >> tab[i][j];

   for(int i = 1; i <= n; i++)
    {
        int white;
        if(i & 1)
            white = 1;
        else
            white = 0;
        for(int j = 1; j <= m; j++)
        {
            //cerr << white << " ";

            if(tab[i][j] == '.')
                c[white].pb({i, j});
            white ^= 1;
        }
       // cerr << endl;
    }

    assert(clean());

    if(clean())
    {
        solve_clean();
        return 0;
    }

    solve_clean();



    return 0;
}

/*

3 3 1
...
...
...

*/
