#include <bits/stdc++.h>
#include "park.h"

#define int32_t int

void state_direction(const std::pair< int32_t, int32_t > &edge, bool direction);

bool get_xor(const std::vector< std::pair< int32_t, int32_t > > &edges);

void run(int32_t n) {
	state_direction({ 1, 2 }, 1);
	state_direction({ 1, 3 }, 1);
	state_direction({ 2 * n + 1, 2 * n + 2 }, 1);
	state_direction({ 2 * n, 2 * n + 2 }, 1);

	for(int32_t i = 2; i <= 2 * n - 1; i++) {
		state_direction({ i, i + 2 }, 1);
	}

	for(int32_t i = 2; i <= 2 * n; i++) {
		std::vector< std::pair< int32_t, int32_t > > edges = { { i, i + 1 } };
		bool dir = get_xor(edges);

		state_direction({ i, i + 1 }, dir);
	}
}

//#include "Lgrader.cpp"
