#include <bits/stdc++.h>
#include "park.h"
#define int32_t int

const int32_t MAX_N = 1e5;

void state_direction(const std::pair< int32_t, int32_t > &edge, bool direction);

bool get_xor(const std::vector< std::pair< int32_t, int32_t > > &edges);

int32_t dir[2 * MAX_N + 5], got[2 * MAX_N + 5];
void run(int32_t n) {
	state_direction({ 1, 2 }, 1);
	state_direction({ 1, 3 }, 1);
	state_direction({ 2 * n + 1, 2 * n + 2 }, 1);
	state_direction({ 2 * n, 2 * n + 2 }, 1);

	for(int32_t i = 2; i <= 2 * n - 1; i++) {
		state_direction({ i, i + 2 }, 1);
	}
	
	dir[1] = 1;
	memset(got, -1, sizeof(got));
	for(int32_t i = 1; i <= 2 * n - 1; i += 2) {
		if(got[i] == -1) {
			std::vector< std::pair< int32_t, int32_t > > edges = {
				{ i, i + 1 }, 
				{ i + 1, i + 2 }, 
				{ i + 2, i + 3 }
			};
	
			bool x = get_xor(edges);
			got[i] = x;
		}

		bool x = got[i];

		if(x == 1) {
			state_direction({ i + 2, i + 3 }, dir[i]);
			state_direction({ i + 1, i + 2 }, 1);
			dir[i + 2] = dir[i];
		}
		else {
			if(dir[i] == 0) {
				state_direction({ i + 2, i + 3 }, 1);
				dir[i + 2] = 1;

				state_direction({ i + 1, i + 2 }, 1);
			}
			else {
				if(i == 2 * n - 1) {
					state_direction({ i + 1, i + 2 }, 0);
					break;
				}

				std::vector< std::pair< int32_t, int32_t > > edges = {
					{ i + 2, i + 3 },
					{ i + 3, i + 4 },
					{ i + 4, i + 5 }
				};
				got[i + 2] = get_xor(edges);

				edges = {
					{ i + 1, i + 2 },
					{ i + 3, i + 4 }
				};
				x = get_xor(edges);

				if(got[i + 2] == 0) {
					if(x == 0) {
						edges = {
							{ i + 1, i + 2 };
						};

						bool p = get_xor(edges);
						
						if(p == 1) {
							state_direction({ i + 1, i + 2 }, 1);
							state_direction({ i + 2, i + 3 }, 0);
							state_direction({ i + 3, i + 4 }, 1);
							state_direction({ i + 4, i + 5 }, 1);
							dir[i + 4] = 1;
						}
						else {
							state_direction({ i + 1, i + 2 }, 0);
							state_direction({ i + 2, i + 3 }, 1);
							state_direction({ i + 3, i + 4 }, 0);
							state_direction({ i + 4, i + 5 }, 1);
							dir[i + 4] = 1;
						}
					}
					else {
						state_direction({ i + 1, i + 2 }, 0);
						state_direction({ i + 2, i + 3 }, 1);
						state_direction({ i + 3, i + 4 }, 1);
						state_direction({ i + 4, i + 5 }, 0);
						dir[i + 4] = 0;
					}
				}
				else {
					if(x == 0) {	
						state_direction({ i + 1, i + 2 }, 1);
						state_direction({ i + 2, i + 3 }, 0);
						state_direction({ i + 3, i + 4 }, 1);
						state_direction({ i + 4, i + 5 }, 0);
						dir[i + 4] = 0;
					}
					else {
						state_direction({ i + 1, i + 2 }, 0);
						state_direction({ i + 2, i + 3 }, 1);
						state_direction({ i + 3, i + 4 }, 1);
						state_direction({ i + 4, i + 5 }, 1);
						dir[i + 4] = 1;
					}
				}

				i += 2;
			}
		}
	}
}

//#include "Lgrader.cpp"
