#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 128;

struct state
{
    int x, y, z;
    state(){}
    state(int x, int y, int z)
    {
        this -> x = x;
        this -> y = y;
        this -> z = z;
    }
};

int dir[8][2] = {{+1, -2}, {+1, +2}, {-1, -2}, {-1, +2}, {+2, -1}, {+2, +1}, {-2, -1}, {-2, +1}};

int n, m, k;
int a[MAXN][MAXN];

long long dp[MAXN][MAXN][MAXN];

long long cnt = 0, ost = 0;
vector<state> v;

int main()
{
    cin >> n >> m >> k;
    for (int i = 0; i < n; ++ i)
    {
        for (int j = 0; j < m; ++ j)
        {
            char ch;
            cin >> ch;
            if (ch == '.')
            {
                a[i][j] = 0;
            }
            else a[i][j] = 1;
        }
    }

    for (int i = 0; i < n; ++ i)
    {
        for (int j = 0; j < m; ++ j)
        {
            if (a[i][j]) continue;

            bool is = 0;
            for (int d = 0; d < 8; ++ d)
            {
                int ni = i + dir[d][0];
                int nj = j + dir[d][1];

                if (ni >= 0 and nj >= 0 and ni < n and nj < m and a[ni][nj] == 0)
                {
                    is = true;
                    break;
                }
            }

            if (!is)
            {
                a[i][j] = 1;
                cnt++;
            }
            else
            {
                ost++;
                v.emplace_back(i, j, k);
            }
        }
    }

//    for (int i = 0; i < n; ++ i)
//    {
//        for (int j = 0; j < m; ++ j)
//        {
//            dp[i][j][0] = 1;
//        }
//    }
//
//    for (int kk = 1; kk <= k; ++ kk)
//    {
//        for (int i = 0; i < n; ++ i)
//        {
//            for (int j = 0; j < m; ++ j)
//            {
//                for (int d = 0; d < 8; ++ d)
//                {
//                    int ni = i + dir[d][0];
//                    int nj = j + dir[d][1];
//
//                    if (ni >= 0 and nj >= 0 and ni < n and nj < m and a[ni][nj] == 0)
//                    {
//                        dp[i][j][kk] += dp[ni][nj][k - 1];
//                    }
//                }
//            }
//        }
//    }

    cout << cnt + (ost * (k + 1)) << endl;
    return 0;
}
