#include <iostream>
#include <utility>
#include <algorithm>
#define endl '\n'
#define fi first
#define se second
using namespace std;

const int MAXN = 100005;

int n;
long long l;
pair<int, int> a[MAXN];
long long b[MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> l;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i].fi >> a[i].se;
    }

    sort(a + 1, a + n + 1);

    for (int i = 1; i <= n; ++ i)
    {
        b[i] = b[i - 1] + a[i].fi;
    }
}

void One()
{
    long long opt = 0;
    for (int i = 1; i <= n; ++ i)
    {
        if (a[i].fi + 1ll * a[i].se * (l - 1) > opt)
        {
            opt = a[i].fi + 1ll * a[i].se * (l - 1);
        }
    }

    cout << opt << endl;
}

pair<int, int> Two()
{
    if (n == 1)
    {
        return make_pair(-1, -1);
    }
    if (l == 1)
    {
        cout << 0 << endl;
        return make_pair(-1, -1);
    }

    long long opt = 0;
    int f, s;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = i + 1; j <= n; ++ j)
        {
            if ((a[i].fi + a[j].fi) + 1ll * (a[i].se + a[j].se) * (l - 2) > opt)
            {
                opt = (a[i].fi + a[j].fi) + 1ll * (a[i].se + a[j].se) * (l - 2);
                f = i;
                s = j;
            }
        }
    }

    cout << opt << endl;
    return make_pair(f, s);
}

inline long long Calc(int i, int j, int k)
{
    long long current = a[i].fi + a[j].fi, tmp = k - 2;
    if (j >= n - tmp + 1) {tmp++; current -= a[j].fi;}
    if (i >= n - tmp + 1) {tmp++; current -= a[i].fi;}
    current += b[n] - b[n - tmp] + 1ll * (a[i].se + a[j].se) * (l - k);
    return current;
}

int main()
{
    Init();
    One();
    auto t = Two();
    int f = t.fi, s = t.se;

    for (int k = 3; k <= n; ++ k)
    {
        if (k > l) cout << 0 << endl;
        else
        {
            long long opt = Calc(f, s, k);

            for (int i = 1; i <= n; ++ i)
            {
                if (i < f)
                {
                    if (Calc(i, f, k) > opt or Calc(i, s, k) > opt) opt = -1;
                }
                if (f < i and i < s)
                {
                    if (Calc(f, i, k) > opt or Calc(i, s, k) > opt) opt = -1;
                }
                if (s < i)
                {
                    if (Calc(f, i, k) > opt or Calc(s, i, k) > opt) opt = -1;
                }

                if (opt == -1) break;
            }

            if (opt != -1)
            {
                cout << opt << endl;
                continue;
            }

            for (int i = 1; i <= n; ++ i)
            {
                for (int j = i + 1; j <= n; ++ j)
                {
                    if (Calc(i, j, k) > opt)
                    {
                        opt = Calc(i, j, k);
                        f = i;
                        s = j;
                    }
                }
            }

            cout << opt << endl;
        }
    }

    return 0;
}

