#include<iostream>
#include<map>
#include<vector>
#include "park.h"
using namespace std;
//vector<pair<int,int> > v[100005];
map<pair<int,int>, int> mp;
int used[300005];
int m;
bool dfs (int pos)
{
    bool flag=false;
    used[pos]=-1;
    if (pos<m && mp[make_pair(pos,pos+1)]==1)
    {
        if (used[pos+1]==-1)
            flag=true;
        if (used[pos]==0)
            dfs(pos+1);
    }
    if (!flag && pos<m-1 && mp[make_pair(pos,pos+2)]==1)
    {
        if (used[pos+2]==-1)
            flag=true;
        if (used[pos+2]==0)
            dfs(pos+2);
    }
    if (!flag && pos>1 && mp[make_pair(pos-1,pos)]==0)
    {
        if (used[pos-1]==-1)
            flag=true;
        if (used[pos-1]==0)
            dfs(pos-1);
    }
    if (pos%2==0 && pos>2 && !flag && mp[make_pair(pos-2,pos)]==0)
    {
        if (used[pos-2]==-1)
            flag=true;
        if (used[pos-2]==0)
            dfs(pos-2);
    }
    used[pos]=0;
    return flag;
}
void run (int n)
{
    m=2*(n+1)
    state_direction(make_pair(1,2),1);
    state_direction(make_pair(1,3),1);
    state_direction(make_pair(m-1,m),1);
    state_direction(make_pair(m-2,m),1);
    for (int i=1; i<=m; i++)
    {
        if (i>1)
            mp[make_pair(i-1,i)]=-1;
        if (i>2)
            mp[make_pair(i-2,i)]=-1;
        if (i<m)
            mp[make_pair(m,m+1)]=-1;
        if (i<m-1)
            mp[make_pair(m,m+2)]=-1;
    }
    mp[make_pair(1,2)]=mp[make_pair(1,3)]=mp[make_pair(m-2,m)]=mp[make_pair(m-1,m)]=1;
    for (int i=2; i<m; i+=2)
    {
        vector<pair<int,int> > z;
        z.push_back(make_pair(i,i+1));
        mp[make_pair(i,i+1)]=get_xor(z);
        state_direction(make_pair(i,i+1),mp[make_pair(i,i+1)]);

        if (i!=m-2)
        {
            z.clear();
            z.push_back(make_pair(i,i+2));
            mp[make_pair(i,i+2)]=get_xor(z);
            state_direction(make_pair(i,i+2),mp[make_pair(i,i+2)]);
        }
    }
    for (int i=3; i<m-1; i+=2)
    {
        vector<pair<int,int> > z;
        z.push_back(make_pair(i,i+1));
        mp[make_pair(i,i+1)]=get_xor(z);
        state_direction(make_pair(i,i+1),mp[make_pair(i,i+1)]);
    }
    for (int i=3; i<m-1; i+=2)
    {
        //vsi4ki vlizat
        if (mp[make_pair(i-2,i)]==1 && mp[make_pair(i-1,i)]==1 && mp[make_pair(i,i+1)]==0)
        {
            mp[make_pair(i,i+2)]=1;
            state_direction(make_pair(i,i+2),1);
            continue;
        }
        if (mp[make_pair(i-2,i)]==0 && mp[make_pair(i-1,i)]==0 && mp[make_pair(i,i+1)]==1)
        {
            mp[make_pair(i,i+2)]=0;
            state_direction(make_pair(i,i+2),0);
            continue;
        }
        if (mp[make_pair(i,i+1)]==1 && mp[make_pair(i+1,i+2)]==1)
        {
            mp[make_pair(i,i+2)]=1;
            state_direction(make_pair(i,i+2),1);
            continue;
        }
        if (mp[make_pair(i,i+1)]==0 && mp[make_pair(i+1,i+2)]==0)
        {
            mp[make_pair(i,i+2)]=0;
            state_direction(make_pair(i,i+2),1);
            continue;
        }
        if (mp[make_pair(i,i+1)]==1 && mp[make_pair(i+1,i+3)]==1 && mp[make_pair(i+2,i+3)]==0)
        {
            mp[make_pair(i,i+2)]=1;
            state_direction(make_pair(i,i+2),1);
            continue;
        }
        if (mp[make_pair(i,i+1)]==0 && mp[make_pair(i+1,i+3)]==0 && mp[make_pair(i+2,i+3)]==1)
        {
            mp[make_pair(i,i+2)]=0;
            state_direction(make_pair(i,i+2),0);
            continue;
        }
        mp[make_pair(i,i+2)]=1;
        if (dfs(i))
            mp[make_pair(i,i+2)]=0;

        state_direction(make_pair(i,i+2),mp[make_pair(i,i+2)]);
    }
}
