#include <cstdio>
#include <vector>
#include "park.h"

using namespace std;

void run(int n);
bool get_xor(const vector <pair<int, int>>& edges);
void state_direction(const pair <int, int>& edge, bool direction);

void run(int n)
{
    int start = n * 2 + 1;
    int fin = start + 1;

    state_direction({1, 2}, 1);
    state_direction({1, 3}, 1);
    state_direction({fin - 1, fin}, 1);
    state_direction({fin - 2, fin}, 1);

    bool x;

    while(start != 1)
    {
        x = get_xor({{start - 2, start}, {start - 1, start}, {start - 1, start - 2}});

        if(x == 0)
        {
            x = get_xor({{start - 2, start}});
            if(x == 0)
            {
                state_direction({start - 2, start - 1}, 0);
                state_direction({start - 1, start}, 0);
                state_direction({start - 2, start}, 0);
            }
            else
            {
                x = get_xor({{start - 1, start}});
                if(x == 1)
                {
                    state_direction({start - 2, start}, 1);
                    state_direction({start - 1, start}, 1);
                    state_direction({start - 2, start - 1}, 0);
                }
                else
                {
                    state_direction({start - 2, start}, 1);
                    state_direction({start - 1, start}, 0);
                    state_direction({start - 2, start -1}, 1);
                }
            }
        }
        else
        {
            x = get_xor({{start - 2, start}});
            if(x == 1)
            {
                state_direction({start - 2, start}, 1);
                state_direction({start - 2, start - 1}, 1);
                state_direction({start - 1, start}, 1);
            }
            else
            {
                x = get_xor({{start - 1, start}});
                state_direction({start - 1, start}, x);
                state_direction({start - 2, start}, 0);
                if(x == 1)
                {
                    state_direction({start - 2, start - 1}, 0);
                }
                else
                {
                    state_direction({start - 2, start - 1}, 1);
                }
            }
        }
        start -= 2;
    }
    x = get_xor({{2, 3}});
    state_direction({2, 3}, x);

    start = 2;
    while(start != fin - 2)
    {
        x = get_xor({{start, start + 2}});

        state_direction({start, start + 2}, x);

        start += 2;
    }
}
