#include <cstdio>
#include <algorithm>

using namespace std;

const int MAXN = 1e2 * 2;

struct person
{
    int a, b, s;

    int get_cost()
    {
        return (a + (b * s));
    }
};

bool cmp(person f, person s)
{
    return f.get_cost() > s.get_cost();
}

int n, l;
person a[MAXN];

void read_input()
{
    scanf("%d %d", &n, &l);

    for(int i = 0; i < n; i++)
    {
        scanf("%d %d", &a[i].a, &a[i].b);
    }
}

int T[MAXN][MAXN];

void solve_for(int index)
{
    if(index == 1)
    {
        printf("%d\n", a[0].a + (a[0].b * (l - 1)));
        return;
    }
    for(int i = 0; i < l; i++)
    {
        for(int j = 0; j < n; j++)
        {
            T[i][j] = 0;
        }
    }
    T[0][0] = a[0].a;

    for(int i = 1; i < l; i++)
    {
        for(int j = 1; j < index; j++)
        {
            for(int z = 0; z < i; z++)
            {
                T[i][j] = max(T[i][j], T[z][j - 1] + a[j].a + ((a[j - 1].b + a[j].b) * (i - z - 1)));
            }
        }
    }

    printf("%d\n", T[l - 1][index - 1]);
}

void solve()
{
    for(int i = 1; i <= n; i++)
    {
        if(i > l)
        {
            printf("0\n");
            continue;
        }
        for(int j = 0; j < n; j++)
        {
            a[j].s = l - i;
        }
        sort(a, a + n, cmp);
        solve_for(i);
    }
}

int main()
{
    read_input();
    solve();

    return 0;
}

/*
3 2
1 2
3 4
5 6
*/
