#include <bits/stdc++.h>
#define ll long long
using namespace std;

int dx[8] = {2, 2, -2, -2, 1, 1, -1, -1};
int dy[8] = {1, -1, 1, -1, 2, -2, 2, -2};
const int N = 105;
char s[N][N];
bool used[N][N];
int n, m, k;

vector<pair<int, int>> path;

int dfs(int x, int y)
{
    used[x][y] = 1;
    path.push_back({x, y});
    for (int i = 0; i < 8; i++)
    {
        int a = x + dx[i], b = y + dy[i];
        if (a >= 0 && a < n && b >= 0 && b < m && !used[a][b] && s[a][b] == '.')
            dfs(a, b);
    }
}

void ETable() // Empty Table
{
    if (n == 1 && m == 1)
    {
        printf("1\n0 0\n");
        return;
    }
    int w = n * m / 2, b = n * m - w;

    int g = 1 + (k + 1) / 2 + (k + 2) / 2;

    printf("%d\n", w * (1 + (k + 1) / 2) + b * ((k + 2) / 2));

    for (int i = 0; i < g; i++)
    {
        int q = 1 - i % 2;
        for (int x = 0; x < n; x++)
        {
            for (int y = 0; y < m; y++)
            {
                if ((x + y) % 2 == q)
                    printf("%d %d\n", x, y);
            }
            int n, m, k;
        }
    }
}
int main()
{
#ifdef HOME
#endif

    scanf("%d%d%d", &n, &m, &k);

    bool free = true;
    for (int i = 0; i < n; i++)
    {
        scanf(" %s", s[i]);
        for (int j = 0; j < m; j++)
        {
            if (s[i][j] == '#')
                free = false;
        }
    }

    if (m == 2)
    {
        vector<pair<int, int>> t;
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j< m; j++)
            {
                if (!used[i][j] && s[i][j] == '.')
                {
                    path.clear();
                    dfs(i, j);
                    if (path.size() == 1)
                    {
                        t.push_back(path[0]);
                        continue;
                    }
                    int w = path.size() / 2, b = path.size() - w,
                        g = 1 + (k + 1) / 2 + (k + 2) / 2;

                    for (int z = 0; z < g; z++)
                    {
                        int q = 1 - z % 2;
                        for (int h = 0; h < path.size(); h++)
                        {
                            if (h % 2 == q)
                                t.push_back(path[h]);
                        }
                    }
                }
            }
        }

        printf("%d\n", t.size());

        for (auto p : t)
        {
            printf("%d %d\n", p.first, p.second);
        }
        return 0;
    }

    if (free)
    {
        ETable();
        return 0;
    }
    return 0;
}
