#include <cstdio>
#include <algorithm>

#define fin stdin
#define fout stdout
//FILE *fin = fopen("a.in", "r"), *fout = fopen("a.out", "w");

#define ll long long

#define INF 1000000000000000000LL

#define MAXN 100009
#define MAXP 265000

int aint[1][MAXP];
ll best1, best2, ans[MAXN], sa[MAXN], best;
struct myc {
    int a, b;
    inline bool operator < (const myc &u) const {
        return a < u.a;
    }
} v[MAXN];
struct mom {
    int x, y;
} maxb[MAXN];
int n, u, start, q, left, right, val, poz;

inline bool better(int p, int a, int b) {
    return v[a].a + 1LL * p * v[a].b > v[b].a + 1LL * p * v[b].b;
}

void update(int p, int st, int dr) {
    if (left <= st && dr <= right) {
        if (better(st + start, val, aint[q][p]))
            std::swap(val, aint[q][p]);
        if (st != dr) {
            int m = (st + dr) / 2;
            if (better(m + start, val, aint[q][p])) {
                std::swap(val, aint[q][p]);
                update(2 * p, st, m);
            } else
                update(2 * p + 1, m + 1, dr);
        }
    } else {
        int m = (st + dr) / 2;
        if (left <= m)
            update(2 * p, st, m);
        if (m < right)
            update(2 * p + 1, m + 1, dr);
    }
}

void query(int p, int st, int dr) {
    best = std::max(best, v[aint[q][p]].a + 1LL * poz * v[aint[q][p]].b);
    if (st != dr) {
        int m = (st + dr) / 2;
        if (poz <= m)
            query(2 * p, st, m);
        else
            query(2 * p + 1, m + 1, dr);
    }
}

inline void baga(int p) {
    u++;
    best1 = best2 = -INF;
    for (int i = 1; i <= p; i++) {
        ll cost = v[i].a + 1LL * u * v[i].b;
        if (cost > best1) {
            best2 = best1;
            best1 = cost;
        } else if (cost > best2)
            best2 = cost;
    }
    left = start;
    right = start + n;
    val = p;
    update(1, start, start + n);
    best = -INF;
    poz = u;
    query(1, start, start + n);
    best1 = best;
}

int main() {
    int l;
    fscanf(fin, "%d%d", &n, &l);

    for (int i = 1; i <= n; i++) {
        fscanf(fin, "%d%d", &v[i].a, &v[i].b);
        ans[1] = std::max(ans[1], v[i].a + 1LL * v[i].b * (l - 1));
    }

    std::sort(v + 1, v + n + 1);

    for (int i = 1; i <= n + 1; i++)
        sa[i] = sa[i - 1] + v[i].a;
    for (int i = n; i >= 0; i--) {
        maxb[i] = maxb[i + 1];
        if (v[i].b > maxb[i].x) {
            maxb[i].y = maxb[i].x;
            maxb[i].x = v[i].b;
        } else if (v[i].b > maxb[i].y)
            maxb[i].y = v[i].b;
    }

    start = u = l - n;
    for (int i = n; i > 1; i--) {
        if (i <= l) {
            ans[i] = sa[n] - sa[n - i] + 1LL * u * (maxb[n - i + 1].x + maxb[n - i + 1].y);
            if (i < n) {
                ans[i] = std::max(ans[i], std::max(sa[n] - sa[n - i + 1] + best1 + 1LL * u * maxb[n - i + 2].x, sa[n] - sa[n - i + 2] + v[n - i + 1].a + best1 + 1LL * u * std::max(v[n - i + 1].b, maxb[n - i + 3].x)));
                if (i < n - 1)
                    ans[i] = std::max(ans[i], sa[n] - sa[n - i + 2] + best1 + best2);
            }
        }
        baga(n - i + 1);
    }

    for (int i = 1; i <= n; i++)
        fprintf(fout, "%lld\n", ans[i]);

    fclose(fin);
    fclose(fout);
    return 0;
}
