#include <bits/stdc++.h>

using namespace std;

typedef long long I64;

const int NMAX = 1e5;
const int LMAX = 2e5;

struct Guy
{
    I64 seat, gain, ind;

    bool operator < (const Guy& oth) const
    {
        return seat < oth.seat;
    }
};


bool cmp_seat(const Guy& a, const Guy& b)
{
    return a.seat < b.seat;
}

Guy v[NMAX+2];
pair<int,int> best_two[NMAX+2];
int where[NMAX+2];
I64 sum_seat[NMAX+2];
int N, L;

set<Guy> people;  /// tine seaterii descrescator dupa gain

inline I64 func(int ind, I64 mult)
{
    return v[ind].seat + mult * v[ind].gain;
}

void considera(pair<int,int>& hold, Guy cineva, I64 in_tren)
{
    if( hold.first == 0 || func(cineva.ind, L - in_tren) >= func(hold.first, L - in_tren) ) {
        hold.second = hold.first;
        hold.first = cineva.ind;
        return ;
    }
    if( hold.second == 0 || func(cineva.ind, L - in_tren) >= func(hold.second, L - in_tren) ) {
        hold.second = cineva.ind;
        return ;
    }
}

int main()
{
    cin >> N >> L;
    for( int i = 1;  i <= N;  ++i ) {
        cin >> v[i].seat >> v[i].gain;
    }
    sort( v+1, v+N+1, cmp_seat );
    reverse(v+1, v+N+1);
    for( int i = 1;  i <= N;  ++i ) {
        sum_seat[i] = sum_seat[i - 1];
        v[i].ind = i;

        for( int j = 0;  j <= N;  ++j )
            considera(best_two[j], v[i], j);
    }

    I64 sum_seat_people = 0;

    for( int cati = 1;  cati <= N;  ++cati ) {
        if( cati > L ) {
            cout << "0\n";
            continue;
        }

        sum_seat_people += v[cati].seat;
        /// sum_seat_ppl = suma celor mai buni [cati] seateri
        /// au indici de la 1 la cati

        people.insert(v[cati]);

        assert(people.size() == cati);


        if( cati == 1 ) {
            int cine = best_two[cati].first;
            I64 scor = v[cine].seat + v[cine].gain * (L - cati);
            cout << scor << '\n';
            continue;
        }


        /// get smallest seaters
        int smallest = cati;
        int second_smallest = cati - 1;

        /// get biggest gainers
        int biggest = best_two[cati].first;
        int second_biggest = best_two[cati].second;

        I64 scor = 0;

        /// replace 0
        auto it = people.begin();
        int a = it->ind;
        ++it;
        int b = it->ind;
        scor = max(scor, sum_seat_people + (L - cati) * (v[a].gain + v[b].gain));

        /// replace 1
        if( biggest > cati ) {
            scor = max(scor, sum_seat_people - v[smallest].seat + v[biggest].seat +
                             (L - cati) * (v[biggest].gain + v[a].gain));
        }

        /// replace 2
        if( biggest > cati && second_biggest > cati ) {
            scor = max(scor, sum_seat_people - v[smallest].seat - v[second_smallest].seat +
                             (L - cati) * (v[biggest].gain + v[second_biggest].gain) );
        }

        cout << scor << '\n';
    }

    return 0;
}
