#include <bits/stdc++.h>

using namespace std;

typedef long long I64;

const I64 NMAX = 2e5;
const I64 LMAX = 2e5;

struct Guy
{
    I64 seat, gain, ind;

    bool operator < (const Guy& oth) const
    {
        return gain > oth.gain;
    }
};


bool cmp_seat(const Guy& a, const Guy& b)
{
    return a.seat < b.seat;
}

Guy v[NMAX+2];
pair<I64,I64> best_two[NMAX+2];
I64 where[NMAX+2];
I64 sum_seat[NMAX+2];
I64 N, L;

set<Guy> people;  /// tine seaterii descrescator dupa gain

inline I64 func(I64 ind, I64 mult)
{
    return v[ind].seat + mult * v[ind].gain;
}

void considera(pair<I64,I64>& hold, Guy cineva, I64 in_tren)
{
    if( hold.first == 0 || func(cineva.ind, L - in_tren) > func(hold.first, L - in_tren) ) {
        hold.second = hold.first;
        hold.first = cineva.ind;
        return ;
    }
    if( hold.second == 0 || func(cineva.ind, L - in_tren) > func(hold.second, L - in_tren) ) {
        hold.second = cineva.ind;
        return ;
    }
}

int main()
{
    cin >> N >> L;
    for( I64 i = 1;  i <= N;  ++i ) {
        cin >> v[i].seat >> v[i].gain;
    }
    sort( v+1, v+N+1, cmp_seat );
    reverse(v+1, v+N+1);
    for( I64 i = 1;  i <= N;  ++i ) {
        sum_seat[i] = sum_seat[i - 1] + v[i].seat;
        v[i].ind = i;

        for( I64 j = 0;  j <= N;  ++j ) {
            if( L - j >= 0 )
                considera(best_two[j], v[i], j);
        }
    }


    for( I64 cati = 1;  cati <= N;  ++cati ) {
        if( cati > L ) {
            cout << "0\n";
            continue;
        }

        if( cati == 1 ) {
            I64 best = 0;
            for( I64 i = 1;  i <= N;  ++i ) {
                I64 meh = sum_seat[cati - (i <= cati)] + v[i].seat;
                I64 gain = (L - cati) * v[i].gain;
                best = max(best, meh + gain);
            }
            cout << best << '\n';
            continue;
        }

        I64 scor = 0;

        for( I64 i = 1;  i <= N;  ++i ) {
            for( I64 j = i + 1;  j <= N;  ++j ) {
                I64 nr = cati - 2;

                if( j <= nr )
                    --nr;
                if( i <= nr )
                    nr--;


                I64 meh = sum_seat[nr] + v[i].seat + v[j].seat;
                I64 gain = (L - cati) * (v[i].gain + v[j].gain);
                scor = max(scor, meh + gain);
            }
        }

        cout << scor << '\n';
    }

    return 0;
}
