#include <bits/stdc++.h>

using namespace std;

typedef long long I64;

const I64 NMAX = 2e5;
const I64 LMAX = 2e5;

struct Guy
{
    I64 seat, gain, ind;

    bool operator < (const Guy& oth) const
    {
        return gain > oth.gain;
    }
};


bool cmp_seat(const Guy& a, const Guy& b)
{
    return a.seat < b.seat;
}

Guy v[NMAX+2];
pair<I64,I64> best_two[NMAX+2];
I64 where[NMAX+2];
I64 sum_seat[NMAX+2];
I64 N, L;

set<Guy> people;  /// tine seaterii descrescator dupa gain

inline I64 func(I64 ind, I64 mult)
{
    return v[ind].seat + mult * v[ind].gain;
}

void considera(pair<I64,I64>& hold, Guy cineva, I64 in_tren)
{
    if( hold.first == 0 || func(cineva.ind, L - in_tren) > func(hold.first, L - in_tren) ) {
        hold.second = hold.first;
        hold.first = cineva.ind;
        return ;
    }
    if( hold.second == 0 || func(cineva.ind, L - in_tren) > func(hold.second, L - in_tren) ) {
        hold.second = cineva.ind;
        return ;
    }
}

I64 sum_seat_people = 0;

I64 query(int cati)
{
    assert(people.size() > 1);

    auto it = people.begin();
    I64 a = it->ind;
    ++it;
    I64 b = it->ind;
    return sum_seat_people + (L - cati) * (v[a].gain + v[b].gain);
}

int smallest, second_smallest;

int incearca(int id, int afara = 0)
{
    if( !id ) return 0;

    int scos = 0;

    if( people.find(v[id]) != people.end() )
        return 0;

    if( afara ) {
        assert(people.find(v[afara]) != people.end());
        people.erase(v[afara]);
        scos = afara;
    }
    else {
        if( people.find(v[smallest]) != people.end() ) {
            people.erase(v[smallest]);
            scos = smallest;
        }
        else if( people.find(v[second_smallest]) != people.end() ) {
            people.erase(v[second_smallest]);
            scos = second_smallest;
        }
    }

    people.insert(v[id]);
    return scos;
}

int main()
{
    cin >> N >> L;
    for( I64 i = 1;  i <= N;  ++i ) {
        cin >> v[i].seat >> v[i].gain;
    }
    sort( v+1, v+N+1, cmp_seat );
    reverse(v+1, v+N+1);
    for( I64 i = 1;  i <= N;  ++i ) {
        sum_seat[i] = sum_seat[i - 1];
        v[i].ind = i;

        for( I64 j = 0;  j <= N;  ++j ) {
            if( L - j >= 0 )
                considera(best_two[j], v[i], j);
        }
    }



    for( I64 cati = 1;  cati <= N;  ++cati ) {
        if( cati > L ) {
            cout << "0\n";
            continue;
        }

        sum_seat_people += v[cati].seat;
        /// sum_seat_ppl = suma celor mai buni [cati] seateri
        /// au indici de la 1 la cati

        people.insert(v[cati]);

        assert(people.size() == cati);


        if( cati == 1 ) {
            I64 cine = best_two[cati].first;
            I64 scor = v[cine].seat + v[cine].gain * (L - cati);
            cout << scor << '\n';
            continue;
        }


        /// get smallest seaters
        smallest = cati;
        second_smallest = cati - 1;

        /// get biggest gainers
        I64 biggest = best_two[cati].first;
        I64 second_biggest = best_two[cati].second;

        /// replace 0
        I64 ans = 0;

        ans = max(ans, query(cati));

        /// replace 1
        int last = incearca(biggest);
        ans = max(ans, query(cati));
        incearca(last, biggest);

        /// replace 2
        last = incearca(biggest);
        int last2 = incearca(second_biggest);
        ans = max(ans, query(cati));
        incearca(last2, second_biggest);
        incearca(last, biggest);

        cout << ans << '\n';
    }

    return 0;
}
