#include <bits/stdc++.h>
using namespace std;

const int DIM = 105;
const int dx[8] = {-2, -2, -1, 1, 2, 2, 1, -1};
const int dy[8] = {-1, 1, 2, 2, 1, -1, -2, -2};

string str[DIM];
bitset<DIM> oki[DIM][DIM];
vector<pair<int, int> > sol;
deque<tuple<int, int, int> > que;

int main(void) {
    freopen("chess.in", "r", stdin);
    freopen("chess.out", "w", stdout);
    int n, m, k; cin >> n >> m >> k;
    for (int i = 0; i < n; ++i) {
        cin >> str[i];
        for (int j = 0; j < m; ++j) {
            if (str[i][j] == '.') {
                oki[i][j][0] = true;
                sol.push_back(make_pair(i, j));
                que.push_back(make_tuple(i, j, 0));  } } }
    for (; que.size(); que.pop_front()) {
        int x, y, p; tie(x, y, p) = que.front();
        for (int d = 0; d < 4; ++d) {
            int xx = x + dx[d], yy = y + dy[d];
            if (xx >= 0 && xx < n && yy >= 0 && yy < m && p != k &&
                !oki[xx][yy][p + 1] && str[xx][yy] == '.') {

                oki[xx][yy][p + 1] = true;
                sol.push_back(make_pair(xx, yy));
                que.push_back(make_tuple(xx, yy, p + 1)); } } }
    cout << sol.size() << "\n";
    for (auto pr : sol) {
        cout << pr.first << " " << pr.second << "\n"; }
    return 0; }
