#include "park.h"
#include <bits/stdc++.h>

using namespace std;

const int nmax = 2e5 + 5;
static int grd[nmax + 1];
static bool scos[nmax + 1];
static vector<int> g[nmax + 1];

static void trage_muchie (int x, int y) {
    g[x].push_back(y);
    g[y].push_back(x);
}

void run (int n) {
    for (int i = 1; i <= 2 * n; i += 2) {
        trage_muchie(i, i + 2);
        trage_muchie(i + 1, i + 3);
    }

    for (int i = 1; i <= 2 * n + 1; ++ i)
        trage_muchie(i, i + 1);

    for (int i = 1; i <= 2 * n + 2; ++ i)
        grd[i] = g[i].size();

    queue<int> q;

    state_direction({1, 2}, 1);
    state_direction({1, 3}, 1);

    q.push(2);
    q.push(3);
    scos[1] = 1;

    grd[1] = 0;
    -- grd[2];
    -- grd[3];

    while (q.size() == 2) {
        int a = q.front(); q.pop();
        int b = q.front(); q.pop();

        if (a > b)
            swap(a, b);

        vector<pair<int, int>> aux;
        aux.push_back({a, b});
        if (get_xor(aux) == 0) {
            swap(a, b);
        }

        scos[a] = 1;
        for (auto i : g[a]) {
            if (scos[i] == 0) {
                -- grd[i];
                if (grd[i] == 1)
                    q.push(i);

                state_direction({a, i}, (a < i));
            }
        }
    }
}
