#include "park.h"
#include <bits/stdc++.h>

using namespace std;

const int nmax = 2e5 + 5;

int N;
static int stare[2 * nmax + 1];
static bool incoada[nmax + 1];
static int ind;
static int grd[nmax + 1];
static bool scos[nmax + 1];
static vector<pair<int, int>> g[nmax + 1];

static void trage_muchie (int x, int y) {
    ++ ind;
    stare[ind] = -1;
    g[x].push_back({y, ind});
    g[y].push_back({x, ind});
}

int pleaca (int x, int y) {
    if (x > y)
        swap(x, y);

    int nr = 0;
    if (x == y - 2)
        nr = x;
    else
        nr = x + 2 * N;

    if (stare[nr] == -1) {
        stare[nr] = get_xor({{x, y}});
        state_direction({x, y}, stare[nr]);
    }
    return stare[nr] == 1 ? x : y;
}

void afirma (int nr, pair<int, int> e, int dir) {
    if (stare[nr] == -1) {
        stare[nr] = dir;
        state_direction(e, stare[nr]);
    }
}

void run (int n) {
    N = n;
    for (int i = 1; i <= 2 * n - 1; i += 2) {
        trage_muchie(i, i + 2);
        trage_muchie(i + 1, i + 3);
    }

    for (int i = 1; i <= 2 * n + 1; ++ i)
        trage_muchie(i, i + 1);

    for (int i = 1; i <= 2 * n + 2; ++ i)
        grd[i] = g[i].size();

    queue<int> q;

    state_direction({1, 2}, 1);
    state_direction({1, 3}, 1);

    q.push(2);
    q.push(3);
    scos[1] = 1;

    grd[1] = 0;
    -- grd[2];
    -- grd[3];

    srand(time(0));

    while (q.size() >= 2) {
        vector<int> v;
        while (!q.empty()) {
            v.push_back(q.front());
            incoada[q.front()] = 0;
            q.pop();
        }


        random_shuffle(v.begin(), v.end());
        int a = -1;
        int pozv = 0;

        for (auto nod : v) {
            bool ok = 1;
            for (auto i : v) {
                if (abs(nod - i) > 2 || i == nod)
                    continue;

                if (pleaca(nod, i) == i) {
                    ok = 0;
                    break;
                }
            }

            if (ok == 1) {
                a = nod;
                break;
            }
            ++ pozv;
        }

        //cerr << a << "\n";
        swap(v.back(), v[pozv]);
        v.pop_back();

        for (auto i : v) {
            q.push(i);
            incoada[i] = 1;
        }

        scos[a] = 1;
        for (auto i : g[a]) {
            if (scos[i.first] == 0) {
                afirma(i.second, {a, i.first}, (a < i.first));

                if (incoada[i.first] == 0) {
                    q.push(i.first);
                    incoada[i.first] = 1;
                }
            }
        }
    }
}
