#include "park.h"
#include <bits/stdc++.h>

using namespace std;

const int nmax = 2e5 + 5;

int N;

int first, last;
int q[nmax + 1];
static int stare[2 * nmax + 1];
static bool incoada[nmax + 1];
static int ind;
static bool scos[nmax + 1];
static vector<pair<int, int>> g[nmax + 1];

static void trage_muchie (int x, int y) {
    ++ ind;
    stare[ind] = -1;
    g[x].push_back({y, ind});
    g[y].push_back({x, ind});
}

int pleaca (int x, int y) {
    if (x > y)
        swap(x, y);

    int nr = 0;
    if (x == y - 2)
        nr = x;
    else
        nr = x + 2 * N;

    if (stare[nr] == -1) {
        stare[nr] = get_xor({{x, y}});
        state_direction({x, y}, stare[nr]);
    }
    return stare[nr] == 1 ? x : y;
}

void afirma (int nr, pair<int, int> e, int dir) {
    if (stare[nr] == -1) {
        stare[nr] = dir;
        state_direction(e, stare[nr]);
    }
}

void modifica (int &k, int x, int y) {
    if (y <= x + 5)
        ++ k;
    else {
        k += rand() % 2 + 1;
    }
}

void run (int n) {
    N = n;
    for (int i = 1; i <= 2 * n - 1; i += 2) {
        trage_muchie(i, i + 2);
        trage_muchie(i + 1, i + 3);
    }

    for (int i = 1; i <= 2 * n + 1; ++ i)
        trage_muchie(i, i + 1);

    state_direction({1, 2}, 1);
    state_direction({1, 3}, 1);

    first = 0; last = -1;
    q[++ last] = 2;
    q[++ last] = 3;
    scos[1] = 1;

    srand(time(0));

    while (first <= last) {
        random_shuffle(q + first, q + last);
        int a = -1;

        for (int j = first; j <= last; ++ j) {
            int nod = q[j];

            bool ok = 1;
            for (int k = first; k <= last; modifica(k, first, last)) {
                int i = q[k];

                if (nod < i - 2 || nod > i + 2 || i == nod)
                    continue;

                if (pleaca(nod, i) == i) {
                    ok = 0;
                    break;
                }
            }

            if (ok == 1) {
                a = nod;
                swap(q[last], q[j]);
                -- last;
                break;
            }
        }

        //cerr << first << " " << last << "\n";
        //cerr << a << "\n";

        incoada[a] = 0;
        scos[a] = 1;
        for (auto i : g[a]) {
            if (scos[i.first] == 0) {
                afirma(i.second, {a, i.first}, (a < i.first));

                if (incoada[i.first] == 0) {
                    q[++ last] = i.first;
                    incoada[i.first] = 1;
                }
            }
        }
    }
}
