#include <bits/stdc++.h>

using namespace std;

//#define fin cin
//#define fout cout
ifstream fin ("x.in"); ofstream fout ("x.out");

const int nmax = 100 + 5;
const int dl[8] = {-2, -2, 1, 1, 2, 2, -1, -1};
const int dc[8] = {1, -1, 2, -2, 1, -1, 2, -2};

bool d[2][nmax + 1][nmax + 1];
string v[nmax + 1];

int main () {
    int n, m, k;
    fin >> n >> m >> k;

    for (int i = 0; i < n; ++ i) {
        fin >> v[i];
    }

    int acc = 0;
    for (int i = 0; i < n; ++ i)
        for (int j = 0; j < m; ++ j) {
            d[0][i][j] = (v[i][j] == '.');
            acc += d[0][i][j];
        }

    for (int i = 0; i < n; ++ i) {
        for (int j = 0; j < m; ++ j) {
            for (int dir = 0; dir < 8; ++ dir) {
                int x = i + dl[dir], y = j + dc[dir];

                if (!(0 <= x && x < n && 0 <= y && y < m))
                    continue;

                d[1][i][j] |= d[0][x][y];
            }
        }
    }

    if (m == 2) {
        int sa = 0, sb = 0;

        for (int i = 0; i < n; ++ i) {
            sa += d[1][i][0];
            sb += d[1][i][1];
        }

        cout << acc + min(sa, sb) << "\n";

        if (sa < sb) {
            for (int i = 0; i < n; ++ i) {
                if (d[0][i][0])
                    cout << i << " 0\n";
            }

            for (int i = 0; i < n; ++ i) {
                if (d[0][i][1])
                    cout << i << " 1\n";
            }

            for (int step = 0; step < k; ++ step) {
                for (int i = 0; i < n; ++ i) {
                    if (d[1][i][0])
                        cout << i << " 0\n";
                }
                for (int i = 0; i < n; ++ i) {
                    if (d[1][i][1])
                        cout << i << " 1\n";
                }
            }
            for (int i = 0; i < n; ++ i) {
                if (d[1][i][0])
                    cout << i << " 0\n";
            }
        } else {
            for (int i = 0; i < n; ++ i) {
                if (d[0][i][1])
                    cout << i << " 1\n";
            }

            for (int i = 0; i < n; ++ i) {
                if (d[0][i][0])
                    cout << i << " 0\n";
            }

            for (int step = 1; step < k; ++ step) {
                for (int i = 0; i < n; ++ i) {
                    if (d[1][i][1])
                        cout << i << " 1\n";
                }
                for (int i = 0; i < n; ++ i) {
                    if (d[1][i][0])
                        cout << i << " 0\n";
                }
            }
            for (int i = 0; i < n; ++ i) {
                if (d[1][i][1])
                    cout << i << " 1\n";
            }
        }
    }

    return 0;
}

