#include <bits/stdc++.h>

using namespace std;

const long long MAXN = 100005;

long long ans1[MAXN];
long long ans2[MAXN];
long long ans3[MAXN];
long long mp[MAXN];

struct Dreapta {
  long long a, b;

  bool operator < (const Dreapta& other) const {
    if (a == other.a)
      return b > other.b;
    return a > other.a;
  }

  long long eval(long long x) {
    return 1LL * a + 1LL * b * x;
  }
  long long eval1(long long x) {
    return 1LL * b * x;
  }
}v[MAXN];

long long stk[MAXN];
long long top;

bool scoate(long long i, long long j, long long k) {
  Dreapta a = v[i];
  Dreapta b = v[j];
  Dreapta c = v[k];
  return 1. * (a.a - c.a) / (c.b - a.b) <= 1. * (b.a - c.a) / (c.b - b.b);
}

void add(long long i) {
  while (top > 2 && scoate(stk[top - 1], stk[top], i))
    top--;
  while (top > 1 && v[i].a >= v[stk[top]].a && v[i].b >= v[stk[top]].b)
    top--;
  stk[++top] = i;
}

long long q(long long val) {
  while (top > 2 && v[stk[top]].eval(val) <= v[stk[top - 1]].eval(val))
    top--;
  return v[stk[top]].eval(val) + v[stk[top - 1]].eval(val);
}


void add1(long long i) {
  while (top > 1 && scoate(stk[top - 1], stk[top], i))
    top--;
  while (top && v[i].a >= v[stk[top]].a && v[i].b >= v[stk[top]].b)
    top--;
  if (top == 1 && v[i].a >= v[stk[top]].a && v[i].b >= v[stk[top]].b)
    stk[2] = stk[1], stk[1] = i, top = 2;
  else
    stk[++top] = i;
}

long long q1(long long val) {
  while (top > 1 && v[stk[top]].eval(val) <= v[stk[top - 1]].eval(val))
    top--;
  return v[stk[top]].eval(val);
}

int main() {
  //freopen("seats.in", "r", stdin);
  //freopen("seats.out", "w", stdout);

  long long n, l;
  scanf("%lld%lld", &n, &l);
  for (long long i = 1; i <= n; ++i) {
    scanf("%lld%lld", &v[i].a, &v[i].b);
    ans1[1] = max(ans1[1], 1LL * v[i].a + 1LL * v[i].b * (l - 1));
  }

  sort(v + 1, v + n + 1);

  for (long long i = n; i >= l; --i)
    add(i);

  long long s = 0;
  for (long long i = 1; i <= min(n, l) - 1; ++i)
    s += v[i].a;
  if (n < l)
    add(n);
  for (long long i = min(n, l) - 1; i >= 1; --i) {
    s -= v[i].a;
    add(i);
    ans1[i + 1] = s + q(l - i - 1);
  }

  for (long long i = 1; i <= min(n, l); ++i)
    mp[i] = max(mp[i - 1], (long long)v[i].b);

  top = 0;
  for (long long i = n; i >= l + 1; --i)
    add1(i);
  s = 0;
  for (long long i = 1; i <= min(n, l); ++i)
    s += v[i].a;
  for (long long i = min(n, l); i >= 2; --i) {
    s -= v[i].a;
    add(i);
    ans2[i] = s + q1(l - i) + mp[i - 1] * (l - i);
  }

  long long i1 = 1, i2 = 0;
  s = v[1].a;
  for (long long i = 2; i <= min(n, l); ++i) {
    s += v[i].a;
    if (v[i].b >= v[i1].b)
      i2 = i1, i1 = i;
    else if (v[i].b > v[i2].b)
      i2 = i;
    ans3[i] = s + 1LL * (l - i) * (v[i2].b + v[i1].b);
  }

  for (long long i = 1; i <= n; ++i)
    printf("%lld\n", max(ans3[i], max(ans1[i], ans2[i])));

  return 0;
}

