#include <bits/stdc++.h>
#define x first
#define y second
using namespace std;

using i64 = long long;
using f64 = double;
using pii = pair<int, int>;
using pll = pair<i64, i64>;

const int N = 1e5 + 5, L = 2e5 + 5;
const f64 INF = 1e12, EPS = 1e-9;
bool QTYPE;

static inline char nextch() {
	const int BMAX = 1 << 17;
	static char buff[BMAX];
	static int bp = BMAX;

	if (bp == BMAX) {
		fread(buff, 1, BMAX, stdin);
		bp = 0; }

	return buff[bp++]; }

static void get(int &x) {
	char ch;
	do {
		ch = nextch(); }
	while (ch < '0' || '9' < ch);
	x = 0;
	do {
		x = x * 10 + (ch - '0');
		ch = nextch(); }
	while ('0' <= ch && ch <= '9'); }

static void get(i64 &x) {
	char ch;
	do {
		ch = nextch(); }
	while (ch < '0' || '9' < ch);
	x = 0;
	do {
		x = x * 10 + (ch - '0');
		ch = nextch(); }
	while ('0' <= ch && ch <= '9'); }

struct Line {
	mutable i64 a, b;
	mutable f64 start, end;
	inline i64 operator () (const Line &u, i64 x) {
		return u.a * x + u.b; }

	inline Line(i64 _a = 0, i64 _b = -1e12, f64 _start = -INF, f64 _end = INF) {
		start = _start;
		end = _end;
		a = _a;
		b = _b; }; };

static inline bool operator < (const Line &u, const Line &v) {
	return (!QTYPE ? u.a > v.a : u.start < v.start); }

static inline i64 f(pll l, const i64 &pos) {
	return l.y * pos + l.x; }

static inline i64 f(Line l, const i64 &pos) {
	return l.a * pos + l.b; }

set<Line> fst_batch, snd_batch;

pll seats[N];
i64 dp1[L], dp2[L], dp3[L];

i64 l;
int n;


static i64 max3(const i64 &a, const i64 &b, const i64 &c) {
	return max(a, max(b, c)); }

static void particular1() { // k = 1
	int mx = 1;
	for (int i = 2; i <= n; ++i)
		if (f(seats[i], l - 1) > f(seats[mx], l - 1))
			mx = i;
	dp1[1] = dp2[1] = dp3[1] = f(seats[mx], l - 1); }

static void particular2() { // k = 2
	int mx1 = 1, mx2 = -1;
	for (int i = 2; i <= n; ++i)
		if (f(seats[i], l - 2) > f(seats[mx1], l - 2))
			mx1 = i;
	for (int i = 1; i <= n; ++i) if (i != mx1) {
		if (mx2 == -1 || (f(seats[i], l - 2) > f(seats[mx2], l - 2)))
			mx2 = i; }

	dp1[2] = (l - 2) * (seats[mx1].y + seats[mx2].y) + seats[mx1].x + seats[mx2].x;
	dp2[2] = dp3[2] = dp1[2]; }

static void case1() { // trivial
	i64 sum, max_slope1 = seats[1].y, max_slope2 = seats[2].y;

	sum = seats[1].x + seats[2].x;
	if (max_slope1 > max_slope2)
		swap(max_slope1, max_slope2);

	for (int i = 3; i <= n && i <= l; ++i) {
		if (max_slope1 <= seats[i].y) {
			max_slope2 = max_slope1;
			max_slope1 = seats[i].y; }
		else if (max_slope2 <= seats[i].y) {
			max_slope2 = seats[i].y; }
		sum+= seats[i].x;
		dp1[i] = sum + (l - i) * (max_slope1 + max_slope2); } }

static f64 intersect(const Line &u, const Line &v) {
	if (u.a == v.a)
		throw -1;
	return f64(u.b - v.b) / (v.a - u.a); }

static void baga_serios(const pll &my_boy) {
	QTYPE = false;
	if (snd_batch.empty()) {
		snd_batch.emplace(my_boy.y, my_boy.x, -INF, INF);
		return; }

	Line my_line(my_boy.y, my_boy.x);
	set<Line>::iterator it1, it2;
	f64 lstart, lend;

	it1 = snd_batch.lower_bound(my_line);
	if (it1 != end(snd_batch) && it1->a == my_line.a) {
		if (it1->b > my_line.a)
			return;
		it2 = next(it1);
		fst_batch.erase(it1);
		it1 = it2; }

	// kill in the front
	while (it1 != end(snd_batch)) {
		if (intersect(my_line, *it1) < it1->start + EPS)
			break;
		it2 = next(it1);
		snd_batch.erase(it1);
		it1 = it2; }

	// kill in the back
	it1 = snd_batch.lower_bound(my_line);
	bool flag = true;
	if (it1 == begin(snd_batch))
		flag = false;
	else
		it1 = prev(it1);
	while (flag) {
		if (it1 == begin(snd_batch))
			flag = false;
		else
			it2 = prev(it1);

		if (intersect(*it1, my_line) < it1->start + EPS)
			snd_batch.erase(it1);
		else
			break;

		if (flag)
			it1 = it2; }

	it1 = snd_batch.insert(my_line).first;
	it2 = next(it1);
	if (it2 == end(snd_batch))
		lend = INF;
	else {
		lend = intersect(my_line, *it2);
		it2->start = lend;
		it1->end = lend; }

	if (it1 == begin(snd_batch))
		it1->start = -INF;
	else {
		it2 = prev(it1);
		lstart = intersect(my_line, *it2);
		it2->end = lstart;
		it1->start = lstart; }

	if (lstart > lend) {
		lstart = intersect(*next(it1), *prev(it1));
		next(it1)->start = lstart;
		prev(it1)->end = lend;
		snd_batch.erase(it1); } }

static void baga(const pll &my_boy) {
	QTYPE = false;
	if (fst_batch.empty()) {
		fst_batch.emplace(my_boy.y, my_boy.x, -INF, INF);
		return; }

	Line my_line(my_boy.y, my_boy.x);
	set<Line>::iterator it1, it2;
	f64 lstart, lend;

	it1 = fst_batch.lower_bound(my_line);
	if (it1 != end(fst_batch) && it1->a == my_line.a) {
		if (it1->b > my_line.a)
			baga_serios(my_boy);
			return;
		it2 = next(it1);
		baga_serios(pll(it1->b, it1->a));
		fst_batch.erase(it1);
		it1 = it2; }

	// kill in the front
	while (it1 != end(fst_batch)) {
		if (intersect(my_line, *it1) < it1->start + EPS)
			break;
		it2 = next(it1);
		baga_serios(pll(it1->b, it1->a));
		fst_batch.erase(it1);
		it1 = it2; }

	// kill in the back
	it1 = fst_batch.lower_bound(my_line);
	bool flag = true;
	if (it1 == begin(fst_batch))
		flag = false;
	else
		it1 = prev(it1);
	while (flag) {
		if (it1 == begin(fst_batch))
			flag = false;
		else
			it2 = prev(it1);

		if (intersect(*it1, my_line) < it1->start + EPS) {
			baga_serios(pll(it1->b, it1->a));
			fst_batch.erase(it1); }
		else
			break;

		if (flag)
			it1 = it2; }

	it1 = fst_batch.insert(my_line).first;
	it2 = next(it1);
	if (it2 == end(fst_batch))
		lend = INF;
	else {
		lend = intersect(my_line, *it2);
		it2->start = lend;
		it1->end = lend; }

	if (it1 == begin(fst_batch))
		it1->start = -INF;
	else {
		it2 = prev(it1);
		lstart = intersect(my_line, *it2);
		it2->end = lstart;
		it1->start = lstart; }

	if (lstart > lend) {
		lstart = intersect(*next(it1), *prev(it1));
		next(it1)->start = lstart;
		prev(it1)->end = lend;
		fst_batch.erase(it1);
		baga_serios(my_boy); } }

static i64 query_serios(const i64 &pos) {
	set<Line>::iterator it;
	QTYPE = true;
	it = snd_batch.lower_bound(pos);
	return f(*it, pos); }

static i64 query(const i64 &pos) {
	set<Line>::iterator it;
	QTYPE = true;
	it = fst_batch.lower_bound(pos);
	return f(*it, pos); }

static i64 almost_query(const i64 &pos) {
	set<Line>::iterator it1, it2;
	i64 rval = 0;

	QTYPE = true;
	it1 = prev(fst_batch.lower_bound(pos));

	it2 = next(it1);
	if (it2 != end(fst_batch))
		rval = max(rval, f(*it2, pos));
	if (it1 != begin(fst_batch)) {
		it2 = prev(it1);
		rval = max(rval, f(*it1, pos)); }

	if (!snd_batch.empty()) {
		it1 = prev(snd_batch.lower_bound(pos));
		rval = max(rval, f(*it1, pos)); }

	return rval; }

static void case2() { // trivial + batch
	i64 my_max_slope, len, sum;

	my_max_slope = seats[1].y;
	sum = seats[1].x;
	for (int i = 2; i <= n - 1; ++i) {
		my_max_slope = max(my_max_slope, seats[i].y);
		sum+= seats[i].x;
		len = l - i - 1;
		dp2[i + 1] = my_max_slope * len + sum; }

	for (int i = n; i >= 3; --i) {
		baga_serios(seats[i]);
		len = l - i;
		dp2[i]+= query_serios(len); } }

static void case3() { // double bitch
	i64 len, sum, folks;

	fst_batch.clear();
	snd_batch.clear();
	sum = 0;

	for (int i = 1; i <= n - 2; ++i) {
		sum+= seats[i].x;
		dp3[i + 2] = sum; }

	baga(seats[n]);
	for (int i = n - 1; i > 1; --i) {
		baga(seats[i]);
		folks = n - i + 2;
		dp3[n - i + 2]+= query(l - folks) + almost_query(l - folks); } }

int main() {
#ifdef HOME
	freopen("seats.in", "r", stdin);
	freopen("seats.out", "w", stdout);
#else
	#error BOULE
#endif

	get(n), get(l);
	for (int i = 1; i <= n; ++i)
		get(seats[i].x), get(seats[i].y);
	sort(seats + 1, seats + 1 + n);
	reverse(seats + 1, seats + 1 + n);

	particular1();
	if (n > 1)
		particular2();
	if (n > 2) {
		case1();
		case2();
		case3(); }

//	for (int i = 1; i <= n && i <= l; ++i)
//		printf("%9lld%9lld%9lld\n", dp1[i], dp2[i], dp3[i]);

	for (int i = 1; i <= n && i <= l; ++i)
		printf("%lld\n", max3(dp1[i], dp2[i], dp3[i]));
	for (int i = l + 1; i <= n; ++i)
		puts("0");

	return 0; }

