#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 100000;
int a[MAX_N], b[MAX_N];
int poz[MAX_N];

bool cmp(int x, int y) {
  return a[x] > a[y];
}

bool cmpDreapta(int x, int y, int spaces) {
  if(y == -1)
    return true;
  else {
    long long valx = (long long)b[x] * spaces + a[x],
              valy = (long long)b[y] * spaces + a[y];
    return valx > valy || (valx == valy && a[x] < a[y]);
  }
}

int main() {
  int n, l;
  scanf("%d%d", &n, &l);
  for(int i = 0; i < n; ++i) {
    scanf("%d%d", &a[i], &b[i]);
    poz[i] = i;
  }

  std::sort(poz, poz + n, cmp);

  for(int i = 1; i <= min(n, l); ++i) {
    long long val = 0LL;
    int spaces = l - i;
    int s1, s2;
    s1 = s2 = -1;
    for(int i = 0; i < n; ++i) {
      if(cmpDreapta(i, s1, spaces)) {
        s2 = s1;
        s1 = i;
      } else if(cmpDreapta(i, s2, spaces))
        s2 = i;
    }
    val = (long long)b[s1] * spaces + a[s1];
    if(i > 1) val += (long long)b[s2] * spaces + a[s2];

    int rem = i - 2;
    for(int i = 0; i < n; ++i)
      if(poz[i] != s1 && poz[i] != s2 && rem > 0) {
        --rem;
        val += a[poz[i]];
      }
    printf("%lld\n", val);
  }
  for(int i = min(n, l) + 1; i <= n; ++i)
    printf("%d\n", 0);
  return 0;
}
