#include <bits/stdc++.h>

using namespace std;

char getch(FILE *fin) {
  char ch = fgetc(fin);
  while(ch != '.' && ch != '#')
    ch = fgetc(fin);
  return ch;
}

string matr[100];
bool viz[10000];
vector<int> graph[10000];

int di[] = {-2, -2, -1, 1, 2, 2, 1, -1};
int dj[] = {-1,  1,  2, 2, 1,-1,-2, -2};

vector<pair<int, int> > rez;
vector<int> bip[2];

void dfs(int nod, bool col) {
  viz[nod] = true;
  bip[col].push_back(nod);
  for(auto it: graph[nod])
    if(!viz[it]) {
      viz[it] = true;
      dfs(it, 1 - col);
    }
}

int main() {
  int n, m, k;
  cin >> n >> m >> k;
  for(int i = 0; i < n; ++i)
    cin >> matr[i];

  for(int i = 0; i < n; ++i)
    for(int j = 0; j < m; ++j) {
      for(int d = 0; d < 8; ++d) {
        int in = i + di[d], jn = j + dj[d];
        if(0 <= in && in < n && 0 <= jn && jn < m && matr[in][jn] != '#' && matr[i][j] != '#') {
          graph[i * m + j].push_back(in * m + jn);
          graph[in * m + jn].push_back(i * m + j);
        }
      }
    }

  for(int i = 0; i < n * m; ++i) {
    if(matr[i / m][i % m] != '#' && !viz[i]) {
      bip[0].clear();
      bip[1].clear();
      dfs(i, 0);

      if(bip[0].size() > bip[1].size())
        bip[0].swap(bip[1]);

      if(bip[0].size() + bip[1].size() == 1) {
        rez.push_back(make_pair(i / m, i % m));
      } else {
        for(int i = 0; i < k + 2; ++i)
          for(auto it: bip[i % 2])
            rez.push_back(make_pair(it / m, it % m));
      }
    }
  }

  cout << rez.size() << '\n';
  for(auto it: rez)
    cout << it.first << ' ' << it.second << '\n';
  return 0;
}
