#include <bits/stdc++.h>
using namespace std;

typedef long long i64;

const int NMAX = 100010;
int n;
int a[NMAX + 10], b[NMAX + 10];
pair <int, int> ord[NMAX + 10];
i64 sp[NMAX + 10];
int poz_in_order[NMAX + 10];

i64 sum_pref(int pref, int x, int y)
{
    i64 ans = sp[pref];
    if (poz_in_order[x] <= pref) {
        ans -= a[x];
        pref++;
        ans += ord[pref].first;
    }
    if (poz_in_order[y] <= pref) {
        ans -= a[y];
        pref++;
        ans += ord[pref].first;
    }
    return ans;
}
i64 val(int id, int x)
{
    return a[id] + 1LL * x * b[id];
}
pair <int, int> best2(int x)
{
    int ab = 0, bb = 0;
    i64 vala = 0, valb = 0;
    for (int i = 1; i <= n; i++) {
        i64 vali = a[i] + 1LL * x * b[i];
        if (vali > vala)
            bb = ab, valb = vala, ab = i, vala = vali;
        else if (vali > valb)
            valb = vali, bb = i;
    }
    return { ab, bb };
}

int main()
{
    int l;
    cin >> n >> l;
    for (int i = 1; i <= n; i++) {
        cin >> a[i] >> b[i];
        ord[i] = { a[i], i };
    }
    sort(ord + 1, ord + n + 1, [](const pair <int, int> a, const pair <int, int> b) { return a.first > b.first; });
    for (int i = 1; i <= n; i++) {
        poz_in_order[ord[i].second] = i;
        sp[i] = sp[i - 1] + ord[i].first;
    }

    auto x = best2(n - 1);
    cout << a[x.first] + 1LL * (n - 1) * b[x.first] << '\n';

    for (int i = 2; i <= min(n, l); i++) {
        auto x = best2(n - i);
        i64 s = sum_pref(n - 2, x.first, x.second);
        s += val(x.first, n - i);
        s += val(x.second, n - i);
        cout << s << '\n';
    }
    for (int i = min(n, l) + 1, i <= l; i++)
        cout << 0 << '\n';

    return 0;
}




