#include <bits/stdc++.h>
using namespace std;

typedef long long i64;

const int NMAX = 100010;
int n;
int a[NMAX + 10], b[NMAX + 10];
pair <int, int> ord[NMAX + 10];
i64 sp[NMAX + 10];
int poz_in_order[NMAX + 10];

i64 sum_pref(int pref, int x, int y)
{
    i64 scad = 0;
    bool done = 0;
    if (poz_in_order[x] <= pref)
        pref++, scad += a[x], done = 1;
    if (poz_in_order[y] <= pref)
        pref++, scad += a[y];
    if (poz_in_order[x] <= pref && !done)
        pref++, scad += a[x];
    return sp[pref] - scad;
}
i64 val(int id, int x)
{
    return a[id] + 1LL * x * b[id];
}
pair <int, int> best2(int x)
{
    int ab = 0, bb = 0;
    i64 vala = -1, valb = -1;
    for (int i = 1; i <= n; i++) {
        i64 vali = val(i, x);
        if (vali > vala)
            bb = ab, valb = vala, ab = i, vala = vali;
        else if (vali > valb)
            valb = vali, bb = i;
    }
    return { ab, bb };
}

int main()
{
    int l;
    cin >> n >> l;
    for (int i = 1; i <= n; i++) {
        cin >> a[i] >> b[i];
        ord[i] = { a[i], i };
    }
    sort(ord + 1, ord + n + 1, [](const pair <int, int> a, const pair <int, int> b) { return a.first > b.first; });
    for (int i = 1; i <= n; i++)
        poz_in_order[ord[i].second] = i;

    for (int i = 1; i <= max(l, n) + 10; i++)
        sp[i] = sp[i - 1] + ord[i].first;

    auto x = best2(l - 1);
    cout << val(x.first, l - 1) << '\n';

    for (int i = 2; i <= min(n, l); i++) {
        auto x = best2(l - i);
        i64 s = sum_pref(i - 2, x.first, x.second);
        s += val(x.first, l - i);
        s += val(x.second, l - i);
        cout << s << '\n';
    }
    for (int i = min(n, l) + 1; i <= n; i++)
        cout << 0 << '\n';

    return 0;
}




