#include <bits/stdc++.h>
using namespace std;

int n, m, k;
char s[105][105];
bool f[105][105];
vector <pair <int, int> > mys;
vector <pair <int, int> > mys2;
short dx[] = {-2, -2, -1, -1, 1, 1, 2, 2};
short dy[] = {-1, 1, -2, 2, -2, 2, -1, 1};
inline void bfs(int i, int j){
    queue <pair <int, int> > q;
    vector <pair <int, int> > v;
    q.push({i, j});
    f[i][j] = 1;
    v.push_back({i, j});
    while(!q.empty()){
        int l = q.front().first, c = q.front().second;
        q.pop();
        for(short k = 0; k < 8 ; ++k){
            int l1 = l + dx[k];
            int c1 = c + dy[k];
            if(!(l1 > 0 && c1 > 0 && l1 <= n && c1 <= m)) continue ;
            if(s[l1][c1] != '.' || f[l1][c1]) continue ;
            f[l1][c1] = 1;
            v.push_back({l1, c1});
            q.push({l1, c1});
        }
    }

    int aux = k + 1;
    while(aux > 0){
        for(auto it : v)
            mys.push_back(it);
        --aux;
    }
    mys.pop_back();
}
int main()
{
//    freopen("1.in", "r", stdin);

    scanf("%d%d%d\n", &n, &m, &k);

    for(int i = 1; i <= n ; ++i)
        scanf("%s", s[i] + 1);

    int t = 0, l1, c1;
    for(int i = 1; i <= n ; ++i){
        for(int j = 1; j <= m ; ++j){
            if(s[i][j] == '.'){
                l1 = i, c1 = j;
                bool ok = 0;
                for(short k = 0; k < 8 ; ++k){
                    short l = dx[k] + i;
                    short c = dy[k] + j;
                    if(!(l > 0 && c > 0 && l <= n && c <= m)) continue ;
                    if(s[l][c] == '.') ok = 1;
                }
                if(ok) continue ;
                ++t; s[i][j] = '#';
                mys2.push_back({i, j});
            }
        }
    }

    for(int i = 1; i <= n ; ++i){
        for(int j = 1; j <= m ; ++j){
            if(s[i][j] == '.' && f[i][j] == 0) bfs(i, j);
        }
    }

    for(auto it : mys2) mys.push_back(it);

    printf("%d\n", mys.size());
    for(auto it : mys)
        printf("%d %d\n", it.first - 1, it.second - 1);


    return 0;
}
