#include <bits/stdc++.h>

using namespace std;
using nagai = long long;

const int N = 100001;
int mx1[N], mx2[N];
pair<nagai, nagai> chels[N];
int n, l;

nagai calc(int i, int k)
{
	return chels[i].first * (l - (k + 1)) + chels[i].second;
}

void solve1(int l, int r, int from, int to)
{
	if (l == r)
		return;
	int m = (l + r) / 2;
	nagai ans = -1, ansi = -1;
	for (int i = max(from, m); i < to; ++i)
	{
		nagai val = calc(i, m);
		if (val > ans)
			ans = val, ansi = i;
	}
	mx1[m] = ansi;
	solve1(l, m, from, ansi);
	solve1(m + 1, r, ansi, to);
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> l;
	for (int i = 0; i < n; ++i)
		cin >> chels[i].first >> chels[i].second;
	sort(chels, chels + n);
	reverse(chels, chels + n);
	vector<nagai> prefa(n + 1);
	for (int i = 0; i < n; ++i)
		prefa[i + 1] = prefa[i] + chels[i].first;
	solve1(0, n, 0, n);
	vector<nagai> prem1(n + 1), prem2(n + 1);
	nagai cur1 = -1, cur2 = -1;
	for (int i = 0; i < n; ++i)
	{
//		cerr << chels[i].first << ' ' << chels[i].second << '\n';
		if (chels[i].second > cur1)
			cur2 = cur1, cur1 = chels[i].second;
		else if (chels[i].second > cur2)
			cur2 = chels[i].second;
		prem1[i + 1] = cur1, prem2[i + 1] = cur2;
	}
	for (int k = 1; k <= n; ++k)
	{
		if (k > l)
		{
			cout << 0 << '\n';
			continue;
		}
		nagai c = l - k;
		nagai ans = 0;
		if (k == 1)
		{
			for (int i = 0; i < n; ++i)
				ans = max(ans, chels[i].first + c * chels[i].second);
		}
		else
		{
			ans = max(ans, prefa[k] + c * (prem1[k] + prem2[k]));
			int mem = mx1[k - 1];
			ans = max(ans, prefa[k - 1] + chels[mem].first + c * (prem1[k - 1] + chels[mem].second));
			for (int i = k - 2; i < n; ++i)
				for (int j = k - 2; j < i; ++j)
				{
					nagai ansich = prefa[k - 2] + chels[i].first + chels[j].first;
					ansich += c * (chels[i].second + chels[j].second);
					ans = max(ans, ansich);
				}
		}
		cout << ans << '\n';
	}
}

