#include <bits/stdc++.h>
typedef long long ll;
typedef long double ld;
using namespace std;

const int N = 101;
char a[N][N];
int n, m, cc;
int d[8][2] = {{1, 2}, {-1, 2}, {1, -2}, {-1, -2},
				{2, 1}, {2, -1}, {-2, 1}, {-2, -1}};
int col[N][N];
vector<vector<pair<int, int>>> c;

void dfs(int x, int y) {
	col[x][y] = cc;
	c[cc - 1].push_back({x, y});
	for (int i = 0; i < 8; i++) {
		int nx = x + d[i][0], ny = y + d[i][1];
		if (nx < 0 || nx >= n || ny < 0 || ny >= m ||
				a[nx][ny] == '#' || col[nx][ny])
			continue;
		dfs(nx, ny);
	}
}

void print(pair<int, int> p) {
	printf("%d %d\n", p.first, p.second);
}

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int k;
	scanf("%d%d%d", &n, &m, &k);
	assert(m == 2 && k < 3);	
	for (int i = 0; i < n; i++)
		scanf("%s", &a[i]);
	vector<pair<int, int>> ans;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			if (a[i][j] == '.' && !col[i][j]) {
				cc++;
				c.emplace_back();
				dfs(i, j);
				for (int l = 0; l <= k + 1; l++) {
					for (int z = (l + 1) % 2; z < c[cc - 1].size(); z += 2)
						ans.push_back(c[cc - 1][z]);
				}
			}
	printf("%d\n", ans.size());
	for (auto p : ans)
		print(p);
	/*for (int i = 0; i < cc; i++) {
		print(c[i][0]);
		for (int j = 0; j <= k; j++) {
			for (int l = 1; l < c[i].size(); l++)
				print(c[i][l]);
			reverse(c[i].begin(), c[i].end());
		}
	}*/
}
