#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse", "sse2", "sse3", "sse4")
#define x first
#define y second 
#define mp make_pair
using namespace std;

typedef long long ll;
typedef pair<int, int> point;

template<typename T1, typename T2> inline void chkmin(T1 &x, const T2 &y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 &x, const T2 &y) {if (x < y) x = y;}

template<typename T1, typename T2>
istream &operator >> (istream &_in, pair<T1, T2> &a) {
	_in >> a.x >> a.y;
	return _in;
}

template<typename T1, typename T2>
ostream &operator << (ostream &_out, pair<T1, T2> &a) {
	_out >> a.x >> a.y;
	return _out;
}

template<typename T> 
istream &operator >> (istream &_in, vector<T> &a) {
	for (auto &i : a) _in >> i; 
	return _in;
}


template<typename T> 
ostream &operator << (ostream &_out, vector<T> &a) {
	bool OK = false;
	for (auto &i : a) {
		if (OK) cout << ' ';
		else OK = true;
	 	_out << i; 
	}
	return _out;
}

int readInt() {
	int v = 0;
	char c = getchar_unlocked();
	while ('0' <= c && c <= '9') {
		v = (v << 3) + (v << 1) + c - '0';
		c = getchar_unlocked();
	}
	return v;
}

void writeString(const string &s) {
	for (char c : s) {
		putchar_unlocked(c);
	}
}

void writeInt(int v) {
	writeString(to_string(v));
}

int n, L;
vector<int> a, b;

bool used[101];
int who[101];
long long ans[201];

void res(int i, int cnt) {
	if (L == i) {
		long long v = 0;
		for (int i = 0; i < L; ++i) {
			if (who[i] == -1) continue;
			v += a[who[i]];
			if (i && who[i - 1] == -1) v += b[who[i]];
			if (i + 1 < L && who[i + 1] == -1) v += b[who[i]];
		}
		chkmax(ans[cnt], v);
		return;
	}
	who[i] = -1;
	res(i + 1, cnt);
	for (int j = 0; j < n; ++j) {
		if (used[j]) continue;
		who[i] = j;
		used[j] = true;
		res(i + 1, cnt + 1);
		used[j] = false;
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin >> n >> L;
	if (L == 1) {
		int ans = 0;
		for (int i = 0; i < n; ++i) {
			int a, b;
			cin >> a >> b;
			chkmax(ans, a);
		}
		cout << ans << '\n';
		for (int i = 1; i < n; ++i) {
			cout << '0' << endl;
		}
		return 0;
	}
	a.resize(n);
	b.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i] >> b[i];
	}
	res(0, 0);
	for (int i = 1; i <= n; ++i) {
		cout << ans[i] << '\n';
	}

}