#include "bits/stdc++.h"

#define len(v) ((int)v.size())
#define pb push_back
#define mp make_pair
#define mt make_tuple
#define x first
#define y second

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v) {
		is >> x;
	}
	return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v) {
		os << x << " ";
	}
	return os;
}

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &p) {
	is >> p.x >> p.y;
	return is;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &p) {
	os << p.x << " " << p.y;
	return os;
}

void run();

signed main(int argc, char *argv[]) {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
}

int n, m, k;
vector<string> mat;

void run() {
	cin >> n >> m >> k;
	mat.resize(n, string(m, '.'));
	cin >> mat;
	set<pii> deq;	
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (mat[i][j] == '.') {
				deq.emplace(i, j);
			}
		}
	}
	vector<pii> rez;
	for (int i = 0; i < k + 1; i++) {
		set<pii> next;
		for (pii p : deq) {
			rez.pb(p);
			for (int dx = -2; dx <= 2; dx++) {
				for (int dy = -2; dy <= 2; dy++) {
					if (abs(dx) + abs(dy) == 3) {
						pii sub = mp(p.x + dx, p.y + dy);
						if (0 <= sub.x && sub.x < n && 0 <= sub.y && sub.y < m) {
							if (mat[sub.x][sub.y] == '.') {
								next.insert(sub);
							}
						}
					}
				}
			}
		}
		deq = next;
	}
	cout << len(rez) << endl;
	for (pii p : rez) {
		cout << p.x << " " << p.y << endl;
	}
}