
#include <bits/stdc++.h>

using namespace std;
#define mp make_pair
#define pb push_back
#define sz(c) (int)(c).size()
#define all(c) (c).begin(), (c).end()
template<class t1, class t2> inline void chkmin(t1 &a, const t2 &b) {if (a > b) a = b;}
template<class t1, class t2> inline void chkmax(t1 &a, const t2 &b) {if (a < b) a = b;}
const int MAXN = 200228;

int n, m, k;
int dx[8] = {1, 1, -1, -1, 2, 2, -2, -2};
int dy[8] = {2, -2, 2, -2, 1, -1, 1, -1};
string s[MAXN];

bool in(char x, char y) {
	return x >= 0 && x < n && y >= 0 && y < m && s[x][y] == '.';
}


map<vector<pair<pair<char, char>, char> >, vector<pair<char, char> > > dp; 

char getdp(vector<pair<pair<char, char>, char> > pos) {
	if (sz(pos) == 0) {
		return 0;
	}
	//cout << sz(pos) << endl;
	bool was = false;
	for (auto y: pos) {
		assert(y.second <= k);
		if (y.second != k) {
			was = true;
			break;
		}
	}
	if (!was) {
		for (auto y: pos) {
			dp[pos].pb(y.first);
		}
		return 0;
	}
	int kek = -1;
	for (auto x: pos) {
		vector<pair<pair<char, char>, char> > npos1, npos;
		for (auto y: pos) {
			if (y.first != x.first) {
				npos1.pb(y);
				if (y.second == k) {
					continue;
				}
				for (char ks = 0; ks < 8; ks++) {
					char sx = y.first.first + dx[ks];
					char sy = y.first.second + dy[ks];
					if (in(sx, sy)) {
						npos1.pb({{sx, sy}, y.second + 1});
					}
				}
			}
		}
		sort(all(npos1));
		for (auto xx: npos1) {
			if (npos.empty() || npos.back().first != xx.first) {
				npos.pb(xx);
			}
		}
		if (pos == npos) {
			continue;
		}
		char ks = getdp(npos);
		if (ks == -1) {
			continue;
		}
		if (kek == -1 || sz(dp[pos]) > 1 + sz(dp[npos])) {
			dp[pos] = dp[npos];
			dp[pos].pb(x.first);
			kek = 1;
		}
	}
	return 0;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m >> k;
	for (int i = 0; i < n; i++) {
		cin >> s[i];
}
	if (n <= 2 && m <= 2) {
		cout << n * m << endl;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				cout << i << ' ' << j << endl;
			}
		}
		return 0;
	}
	if (k == 1) {
		exit(0);
	}
	vector<pair<pair<char, char>, char> > cans;
	for (char i = 0; i < n; i++) {
		for (char j = 0; j < m; j++) {
			if (s[i][j] == '.') {
				cans.pb({{i, j}, 0});
			}
		}
	}
	getdp(cans);
	cout << sz(dp[cans]) << '\n';
	reverse(all(dp[cans]));
	for (auto z: dp[cans]) {
		cout << (int)z.first << ' ' << (int)z.second << '\n';
	}
	return 0;
}














