#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <deque>
#include <queue>
#include <iomanip>
#include <algorithm>
#include <functional>
#include <numeric>
#include <string>
#include <cstring>
#include <cassert>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 205;
ll n, l, a[mx], b[mx];
vector<pair<ll, ll> > v;

ll ans[mx];

int main() {
	cin >> n >> l;
	v.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> v[i].first >> v[i].second;
	}
	sort(v.rbegin(),v.rend());
	for (int i = 0; i < n; ++i) {
		a[i] = v[i].first;
		b[i] = v[i].second;
	}

	//output(a, a + n);
	//output(b, b + n);

	for (int k = 1; k <= n; ++k) {
		if (k > l) {
			ans[k] = 0;
			continue;
		}
		if (k == 1) {
			for (int i = 0; i < n; ++i) {
				chkmax(ans[k], a[i] + b[i] * (l - 1));
			}
		}
		else {
			ll m1 = 0, m2 = 0, sum = 0;
			for (int i = 0; i < k - 2; ++i) {
				sum += a[i];
				if (b[i] >= m1) {
					m2 = m1;
					m1 = b[i];
				}
				else {
					if (b[i] > m2) {
						m2 = b[i];
					}
				}
			}
			for (int p1 = k - 2; p1 < n; ++p1) {
				for (int p2 = p1 + 1; p2 < n; ++p2) {
					vector<ll> v = {m1, m2, b[p1], b[p2]};
					sort(v.rbegin(), v.rend());
					chkmax(ans[k], sum + a[p1] + a[p2] + (v[0] + v[1]) * (l - k));
				}
			}
		}
	}

	for (int i = 1; i <= n; ++i) {
		cout << ans[i] << "\n";
	}
	cout << endl;
}
