#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <deque>
#include <queue>
#include <iomanip>
#include <algorithm>
#include <functional>
#include <numeric>
#include <string>
#include <cstring>
#include <cassert>
#include <random>
#include "park.h"
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(T x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

int my_get_xor(vector<pair<int, int> > a) {
	for (int i = 0; i < a.size(); ++i) {
		a[i].first++;
		a[i].second++;
	}
	return (int)get_xor(a);
}

typedef vector<pair<int, int> > vpp;

const int mx = 1e5 + 228;
int n, ans[mx][3];

void the_end() {
	//cerr << "n = " << n << endl;
	for (int i = 0; i < n; ++i) {
		for (int j = 1; j <= 2; ++j) {
			if (i + j < n) {
				//cerr << "state " << i << " " << i + j << endl;
				state_direction(make_pair(i + 1, i + j + 1), ans[i][j]);
			}
		}
	}
}

void solve(int v) {
	if (v == 0 || v == 1) {
		return;
	}
	vpp query = {{v - 2, v}, {v - 1, v}};
	//cerr << "query " << v - 2 << " " << v << " " << v - 1 << " " << v << endl;
	int res = my_get_xor(query);
	if (res == 0) {
		ans[v - 2][2] = 1;
		ans[v - 1][1] = 1;
		solve(v - 1);
	}
	else {
		if (v >= 3) {
			ans[v - 3][2] = 1;
			ans[v - 2][1] = 1;
			ans[v - 1][1] = 0;
			ans[v - 2][2] = 1;
			solve(v - 2);
		}
	}
}

void run(int _n) {
	n = 2 * _n + 2;
	ans[n - 3][2] = 1;
	ans[n - 2][1] = 1;
	ans[0][1] = 1;
	ans[0][2] = 1;
	solve(n - 2);
	the_end();
}
