#include <bits/stdc++.h>
#include "park.h"
using namespace std;

#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(x) (x).begin(), (x).end()
#define f first
#define s second
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
#define FAST_IO ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)

const int MAXN = 1e5 + 5;
int n, m;
pair<ll, ll> a[MAXN];
bool used[MAXN];

ll get(int i, ll x) {
    return a[i].f + a[i].s * x;
}

int main() {
    FAST_IO;
    cin >> n >> m;
    rep(i, n) {
        cin >> a[i].f >> a[i].s;
    }

    sort(a, a + n);

    for (int i = 1; i <= n; ++i) {
        if (i > m) {
            cout << 0 << '\n';
            continue;
        }

        ll d = m - i;
        ll mx1 = 0, mx2 = 0;
        ll i1, i2;

        if (i == 1) {
            ll res = -0;
            for (int j = 0; j < n; ++j) {
                res = max(res, get(j, d));
                // cout << j << " : " << get(j, d) << endl;
            }
            cout << res << '\n';
            continue;
        }

        for (int j = 0; j < n; ++j) {
            ll k = get(j, d);
            if (k > mx2) {
                if (k >= mx1) {
                    mx2 = mx1;
                    i2 = i1;

                    mx1 = k;
                    i1 = j;
                } else {
                    mx2 = k;
                    i2 = j;
                }
            }
        }

        fill(used, used + n, false);
        used[i1] = true;
        used[i2] = true;

        ll res = mx1 + mx2;

        for (int j = 0; j < i - 2;) {
            if (used[j]) continue;
            res += a[j].f;
            j++;
        }

        cout << res << '\n';
    }
}