#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define x first
#define y second

using namespace std;

typedef long long ll;

char a[105][105];
int number[105][105];
bool vis[5005], used[5005];
int pairs[5005], pa[5005];
int dx[8] = {-2, -1, 1, 2, 2, 1, -1, -2}, dy[8] = {1, 2, 2, 1, -1, -2, -2, -1};
int n, m;
vector <pair <int, int> > black, white, pust, spis, ntsp;

bool ok(int x, int y)
{
    return x >= 0 && x < n && y >= 0 && y < m;
}

bool dfs(int v)
{
    vis[v] = true;
    for (int t = 0; t < 8; t++)
    {
        int nx = black[v].x + dx[t], ny = black[v].y + dy[t];
        if (!ok(nx, ny) || number[nx][ny] == -1) continue;
        int u = number[nx][ny];
        if (pa[u] == -1)
        {
            pa[u] = v;
            pairs[v] = u;
            return true;
        }
        else
        {
            if (!vis[pa[u]] && dfs(pa[u]))
            {
                pa[u] = v;
                pairs[v] = u;
                return true;
            }
        }
    }
    return false;
}

void dfsik(int v)
{
    for (int t = 0; t < 8; t++)
    {
        int nx = black[v].x + dx[t], ny = black[v].y + dy[t];
        if (!ok(nx, ny) || number[nx][ny] == -1) continue;
        int u = number[nx][ny];
        if (pa[u] == v) continue;
        if (!used[pa[u]]) continue;
        used[pa[u]] = false;
        dfsik(pa[u]);
    }
    return;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0); cin.tie(0);
    int k;
    cin >> n >> m >> k;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cin >> a[i][j], number[i][j] = -1;

    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
        {
            if (a[i][j] == '#') continue;
            bool fl = false;
            for (int t = 0; t < 8; t++)
            {
                int nx = i + dx[t], ny = j + dy[t];
                if (ok(nx, ny) && a[nx][ny] == '.') fl = true;
            }
            if (fl)
            {
                if ((i + j) % 2 == 0)
                {
                    number[i][j] = (int) black.size();
                    black.pb(mp(i, j));
                }
                else
                {
                    number[i][j] = (int) white.size();
                    white.pb(mp(i, j));
                }
            }
            else pust.pb(mp(i, j));
        }
    int A = (int) pust.size(), B = (int) black.size(), C = (int) white.size();
    if (k % 2 == 0)
    {
        cout << A + ((k + 2) / 2) * (B + C) << '\n';
        for (int i = 0; i < (int) pust.size(); i++)
            cout << pust[i].x << ' ' << pust[i].y << '\n';
        for (int i = 1; i <= (k + 2) / 2; i++)
        {
            for (int j = 0; j < (int) black.size(); j++)
                cout << black[j].x << ' ' << black[j].y << '\n';
            for (int j = 0; j < (int) white.size(); j++)
                cout << white[j].x << ' ' << white[j].y << '\n';
        }
    }
    else
    {
        int r = 1, ans = 0;
        for (int i = 0; i < B; i++) vis[i] = false, pairs[i] = -1;
        for (int i = 0; i < C; i++) pa[i] = -1;
        while (r != 0)
        {
            r = 0;
            for (int i = 0; i < B; i++) vis[i] = false;
            for (int i = 0; i < B; i++)
                if (!vis[i] && pairs[i] == -1 && dfs(i)) ans++, r = 1;
        }
        cout << A + ans + ((k + 1) / 2) * (B + C) << '\n';
        for (int i = 0; i < B; i++)
            if (pairs[i] != -1) used[i] = true;
        for (int i = 0; i < B; i++)
            if (pairs[i] == -1) dfsik(i);
        for (int i = 0; i < B; i++)
            if (pairs[i] != -1 && used[i]) spis.pb(black[i]);
            else ntsp.pb(black[i]);
        for (int i = 0; i < C; i++)
            if (pa[i] != -1 && !used[pa[i]]) spis.pb(white[i]);
            else ntsp.pb(white[i]);

        for (int i = 0; i < (int) pust.size(); i++)
            cout << pust[i].x << ' ' << pust[i].y << '\n';
        for (int i = 0; i < (int) spis.size(); i++)
            cout << spis[i].x << ' ' << spis[i].y << '\n';
        for (int i = 1; i <= (k + 2) / 2; i++)
        {
            for (int j = 0; j < (int) ntsp.size(); j++)
                cout << ntsp[j].x << ' ' << ntsp[j].y << '\n';
            for (int j = 0; j < (int) spis.size(); j++)
                cout << spis[j].x << ' ' << spis[j].y << '\n';
        }
    }
    return 0;
}

