#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define x first
#define y second
#include "park.h"

using namespace std;

typedef long long ll;

int tree[800005];

void build(int v, int l, int r)
{
    if (tree[v] == -1)
    {
        vector <pair <int, int> > T;
        for (int i = l; i <= r; i++) T.pb(mp(i, i + 1));
        tree[v] = get_xor(T);
    }
    if (l == r)
    {
        state_direction(mp(l, l + 1), tree[v]);
        return;
    }
    int m = (l + r) / 2;
    build(2 * v, l, m);
    tree[2 * v + 1] = tree[v] ^ tree[2 * v];
    build(2 * v + 1, m + 1, r);
    return;
}

void run(int n)
{
    state_direction(mp(1, 2), 1);
    for (int i = 1; i <= n; i++)
    {
        int v = 2 * i - 1;
        state_direction(mp(v, v + 2), 1);
        state_direction(mp(v + 1, v + 3), 1);
    }
    state_direction(mp(2 * n + 1, 2 * n + 2), 1);
    for (int i = 1; i <= 8 * n; i++)
        tree[i] = -1;
    build(1, 2, 2 * n);
    return;
}
