#include "park.h"
#include <bits/stdc++.h>
#define ll long long
#define mp make_pair
#define pb push_back
#define X first
#define Y second
#define pii pair<int, int>

using namespace std;

void run(int n);

const int MAXN = 2e5 + 100;
map<pii, pii> q;
int in[MAXN], out[MAXN];

void add(int x, int y, bool c)
{
    if (q[mp(x, y)] != mp(0, 0))
        return;
    state_direction({mp(x, y)}, c);
    q[mp(x, y)] = mp(c, 1);
    if (c)
    {
        out[x]++;
        in[y]++;
    }
    else
    {
        out[y]++;
        in[x]++;
    }
}

vector<pii> edge;
int b[4];

void del()
{
    if (b[0])
    {
        out[i]--;
        in[i + 1]--;
    }
    else
    {
        in[i]--;
        out[i + 1]--;
    }

    if (b[1])
    {
        out[i]--;
        in[i + 2]--;
    }
    else
    {
        in[i]--;
        out[i + 2]--;
    }

    if (b[2])
    {
        out[i + 1]--;
        in[i + 2]--;
    }
    else
    {
        in[i + 1]--;
        out[i + 2]--;
    }

    if (b[3])
    {
        out[i + 1]--;
        in[i + 3]--;
    }
    else
    {
        in[i + 1]--;
        out[i + 3]--;
    }
}

bool check(int i, int mask, int c1, int c2)
{
    for (int j = 0; j < 4; j++)
        b[j] = (mask & (1 << j)) != 0;
    if (b[0] ^ b[1] != c1)
        return 0;
    if (b[2] ^ b[3] != c2)
        return 0;

    if (q[mp(i - 1, i)] == mp(1, 1) && q[mp(i - 1, i + 1)] == mp(0, 1) && b[0])
        return 0;
    if (q[mp(i - 1, i)] == mp(0, 1) && q[mp(i - 1, i + 1)] == mp(1, 1) && !b[0])
        return 0;

    if (b[1] && !b[2] && !b[0])
        return 0;
    if (!b[1] && b[2] && b[0])
        return 0;

    if (b[0])
    {
        out[i]++;
        in[i + 1]++;
    }
    else
    {
        in[i]++;
        out[i + 1]++;
    }

    if (b[1])
    {
        out[i]++;
        in[i + 2]++;
    }
    else
    {
        in[i]++;
        out[i + 2]++;
    }

    if (b[2])
    {
        out[i + 1]++;
        in[i + 2]++;
    }
    else
    {
        in[i + 1]++;
        out[i + 2]++;
    }

    if (b[3])
    {
        out[i + 1]++;
        in[i + 3]++;
    }
    else
    {
        in[i + 1]++;
        out[i + 3]++;
    }

    if (in[i - 1] == 0 && i != 2)
    {
        del();
        return 0;
    }

    if (out[i - 1] == 0)
    {
        del();
        return 0;
    }

    if (in[i] == 0)
    {
        del();
        return 0;
    }

    if (out[i] == 0)
    {
        del();
        return 0;
    }
    if (in[i + 1] == 0)
    {
        del();
        return 0;
    }
    if (out[i + 1] == 0)
    {
        del();
        return 0;
    }
    del();
    add(i, i + 1, b[0]);
    add(i, i + 2, b[1]);
    add(i + 1, i + 2, b[2]);
    add(i + 1, i + 3, b[3]);
    return 1;
}

void run(int n)
{
    add(1, 2, 1);
    add(1, 3, 1);
    add(2 * n + 1, 2 * n + 2, 1);
    add(2 * n, 2 * n + 2, 1);
    for (int i = 2; i <= 2 * n - 2; i += 2)
    {
        int c1 = get_xor({mp(i, i + 1), mp(i, i + 2)});
        int c2 = get_xor({mp(i + 1, i + 2), mp(i + 1, i + 3)});
        for (int j = 0; j < 16; j++)
        {
            if (check(i, j, c1, c2))
                break;
        }
    }
    int c = get_xor({mp(2 * n, 2 * n + 1)});
    add(2 * n, 2 * n + 1, c);
    return;
}
