#include "park.h"
#include <bits/stdc++.h>

using namespace std;

map<pair<int, int>, bool> m;

bool is_found(int i, int j) {
    return m.find({min(i, j), max(i, j)}) != m.end();
}

bool ask(int i, int j) {
    if (!is_found(i, j))
        return m[{min(i, j), max(i, j)}] = get_xor({{i, j}});
}

bool get(int i, int j) {
    return m[{min(i, j), max(i, j)}];
}

bool st(int i, int j, bool exp) {
    m[{min(i, j), max(i, j)}] = exp;
}

void dfs(int i, int p, int n) {
    if (i == 2 * n + 2) {
        return;
    }
    int to = i - 2;

    if (i > 2 && !is_found(i, to)) {
        if (get(p, i) == get(p, to)) {
            st(to, i, get(p, to));
        } else {
            int cnt = 0, cn = 0;
            for (int x : {-2, -1, 1}) {
                if (get(to + x, to)) {
                    cnt++;
                } else {
                    cn++;
                }
            }
            if (cnt == 0) {
                st(to, i, 1);
            } else if (cnt == 0) {
                st(to, i, 0);
            } else {
                ask(i, to);
            }
        }
        if (get(i, to) == 0 && get(i, p) == 0) {
            st(p, i + 1, 1);
        }
    }
    ask(i, i + 1);
    dfs(i + 1, i, n);
}

void run(int n) {
    m[{1, 2}] = true;
    m[{1, 3}] = true;
    m[{2 * n, 2 * n + 2}] = true;
    m[{2 * n + 1, 2 * n + 2}] = true;

    dfs(1, -1, n);

    for (int i = 1; i <= 2 * n + 1; i++) {
        state_direction({i, i + 1}, m[{i, i + 1}]);
        if (i < 2 * n + 1)
            state_direction({i, i + 2}, m[{i, i + 2}]);
    }
}
