#include <bits/stdc++.h>
#define ll long long
using namespace std;

const ll INF = 1e17;
const int N = 205;
ll dp[N][N][N];
pair<ll, ll> a[N];

int main()
{
#ifdef HOME
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // HOME
    int n, l;
    scanf("%d%d", &n, &l);

    for (int i = 1; i <= n; i++) {
        scanf("%lld%lld", &a[i].second, &a[i].first);
    }

    sort(a + 1, a + n + 1);

    for (int i = 0; i < N; i++) {
        for (int j = 0; j < N; j++) {
            for (int k = 0; k < N; k++) {
                dp[i][j][k] = -INF;
            }
        }
    }

    dp[0][0][l] = 0;

    for (int i = 1; i <= n; i++) {
        for (int c = 0; c < i; c++) {
            for (int j = 0; j < i; j++) {
                for (int k = 0; k <= l - c; k++) {
                    if (dp[c][j][k] < 0)
                        continue;
                    for (int z = 1; z <= k; z++) {
                        dp[c + 1][i][k - z] = max(dp[c + 1][i][k - z],
                            dp[c][j][k] + (a[i].first + a[j].first) * (z - 1) + a[i].second);
                    }
                }
            }
        }
    }

    for (int i = 1; i <= n; i++) {
        ll ans = 0;
        for (int j = 1; j <= n; j++) {
            for (int k = 0; k <= l; k++) {
                ans = max(ans, dp[i][j][k] + a[j].first * k);
            }
        }
        printf("%lld\n", ans);
    }

    return 0;
}
