#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e18;
const ld EPS = 1e-7;
const ld PI = acos(-1);

#define all(x) x.begin(), x.end()
#define size(x) (ll)x.size()
#define mp(a, b) make_pair(a, b)
#define f first
#define s second

void solve();

int main()
{
    #ifdef HOME
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
}


void solve()
{
    int n, l;
    cin >> n >> l;

    ll one = 0;
    vector<pair<ll, ll>> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].f >> v[i].s;
        one = max(one, v[i].f + v[i].s * (l - 1));
    }

    sort(all(v));

    cout << one << "\n";
    for (int person = 2; person <= n; person++) {
        if (person > l) {
            cout << 0 << "\n";
            continue;
        }

        ll mx1, mx2, id, need, sum, ans = 0;

        mx1 = 0, mx2 = 0, sum = 0;
        need = person;

        for (int i = n - 1; i >= 0 && need; i--) {
            sum += v[i].f;

            if (mx1 < v[i].s) {
                mx2 = mx1;
                mx1 = v[i].s;
            } else {
                if (mx2 < v[i].s) {
                    mx2 = v[i].s;
                }
            }

            need--;
        }

        ans = max(ans, sum + mx1 * (l - person) + mx2 * (l - person));

        cout << ans << "\n";

    }
}
