#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e18;
const ld EPS = 1e-7;
const ld PI = acos(-1);

#define all(x) x.begin(), x.end()
#define size(x) (ll)x.size()
#define mp(a, b) make_pair(a, b)
#define f first
#define s second

void solve();

int main()
{
    #ifdef HOME
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
}


void solve()
{
    int n, l;
    cin >> n >> l;

    ll one = 0;
    vector<pair<ll, ll>> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].f >> v[i].s;
        one = max(one, v[i].f + v[i].s * (l - 1));
    }

    sort(all(v));

    vector<ll> suf(n + 1, 0);
    for (int i = n - 1; i >= 0; i--) {
        suf[i] = suf[i + 1] + v[i].f;
    }

    cout << one << "\n";
    for (int person = 2; person <= n; person++) {
        if (person > l) {
            cout << 0 << "\n";
            continue;
        }

        vector<int> get_j(n + 1, 0);
        vector<ll> mx(n + 1, 0);
        for (int j = n - 1; j >= 0; j--) {
            ll now = v[j].f + v[j].s * (l - person);
                int need = person - 2;
                int pos = n - need;
                ll tmp = 0;
                if (pos <= j) pos--, tmp += v[j].f;

//                cout << i << " " << j << " " << suf[pos] << "\n";
                now += suf[pos] - tmp;
                if (mx[j + 1] > now) get_j[j] = get_j[j + 1];
                else get_j[j] = j;
                mx[j] = max(mx[j + 1], now);
        }

        ll ans = 0;
        for (int i = 0; i < n - 1; i++) {
            ll now = mx[i + 1] + v[i].f + v[i].s * (l - person);
            int need = person - 2;
            int pos = n - need;
            ll tmp = 0;
            int j = get_j[i + 1];
                if (pos <= j) pos--, tmp += v[j].f, now += v[pos].f;
            if (pos <= i) pos--, tmp += v[i].f, now += v[pos].f;
            now -= tmp;
            ans = max(ans, now);
//            cout << i << " " << now << "\n";
        }

        cout << ans << "\n";
    }
}
