#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e18;
const ld EPS = 1e-7;
const ld PI = acos(-1);

#define all(x) x.begin(), x.end()
#define size(x) (ll)x.size()
#define mp(a, b) make_pair(a, b)
#define f first
#define s second

void solve();

int main()
{
    #ifdef HOME
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
}


void solve()
{
    int n, l;
    cin >> n >> l;

    ll one = 0;
    vector<pair<ll, ll>> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].f >> v[i].s;
        one = max(one, v[i].f + v[i].s * (ll)(l - 1));
    }

    sort(all(v));

    vector<ll> suf(n + 1, 0);
    for (int i = n - 1; i >= 0; i--) {
        suf[i] = suf[i + 1] + v[i].f;
    }

    cout << one << "\n";
    for (int person = 2; person <= n; person++) {
        if (person > l) {
            cout << 0 << "\n";
            continue;
        }

        vector<ll> mx(n + 1, 0);
        vector<int> jj(n + 1, 0);

        for (int j = n - 1; j >= 0; j--) {
            ll now = v[j].f + v[j].s * (ll)(l - person);
            int need = person - 2;
            int pos = n - need;
            ll tmp = 0;
            if (pos <= j) pos--, tmp += v[j].f;
            now += suf[pos] - tmp;
            if (now > mx[j + 1]) {
                mx[j] = now;
                jj[j] = j;
            } else {
                mx[j] = mx[j + 1];
                jj[j] = jj[j + 1];
            }
        }

        ll ans = 0;
        for (int i = 0; i < n - 1; i++) {
//                ll now = v[i].f + v[i].s * (l - person) + v[j].f + v[j].s * (l - person);
//                int need = person - 2;
//                int pos = n - need;
//                ll tmp = 0;
//                if (pos <= j) pos--, tmp += v[j].f;
//                if (pos <= i) pos--, tmp += v[i].f;
//
////                cout << i << " " << j << " " << suf[pos] << "\n";
//                now += suf[pos] - tmp;
//                ans = max(ans, now);

            ll now = mx[i + 1] + v[i].f + v[i].s * (ll)(l - person);
            int need = person - 2;
            int pos = n - need;
            int j = jj[j];
            ll tmp = 0;

            if (pos <= j) pos--;
            if (pos <= i) {
                pos--;
                now = now - v[i].f + v[pos].f;
            }
            ans = max(ans, now);
        }

        cout << ans << "\n";
    }
}
