#include <bits/stdc++.h>
#include "park.h"
using namespace std;
#define p(a) pair<int, int>(a, a+1)
#define v1(a) vector<pair<int, int> >{p(a)}
#define v2(a, b) vector<pair<int, int> >{p(a), p(b)}
#define v3(a, b, c) vector<pair<int, int> >{p(a), p(b), p(c)}

//#define int long long
//#define uint unsigned long long

const int b010 = 1;
const int b101 = 2;
const int b111 = 3;
const int b110_011 = 4;
const int b110 = 6;
const int b011 = 7;
const int s1 = 10;
const int s0 = 11;

int pos = 1;
int terminationType;

int findblock(int i) {

	if (get_xor(v3(i, i+1, i+2))) {
		if (get_xor(v1(i))) {
			return b111;
		} else {
			return b010;
		}
	} else {
		if (get_xor(v1(i+1))) {
			return b110_011;
		} else {
			return b101;
		}
	}
}

void output(int i) {
	state_direction(p(pos), i);
	pos++;
}

void output(int a, int b, int c) {
	output(a); output(b); output(c);
}

void outputBlock(int block) {
	if (block == b010) output(0, 1, 0);
	if (block == b101) output(1, 0, 1);
	if (block == b111) output(1, 1, 1);
	if (block == b110) output(1, 1, 0);
	if (block == b011) output(0, 1, 1);
	if (block == s0) output(0);
	if (block == s1) output(1);
}

void decideBlock(int lastBlock, vector<int>& blocks) {
	int unknownBlockCount = 0;
	while (blocks.back() == b110_011 && !blocks.empty()) {
		unknownBlockCount++;
		blocks.pop_back();
	}
	int nextBlock;
	if (blocks.empty()) {
		nextBlock = s0;
	} else {
		nextBlock = blocks.back();
	}
	if (nextBlock == b010 || nextBlock == s0) {
		for (int i = 0; i < unknownBlockCount; i++) {
			outputBlock(b011);
		}
		return;
	}
	if (lastBlock == b010) {
		for (int i = 0; i < unknownBlockCount; i++) {
			outputBlock(b110);
		}
		return;
	}
	bool keep110 = false;
	for (int i = 0; i < unknownBlockCount; i++) {
		bool is110;
		if (keep110) is110 = true;
		else is110 = get_xor(v1(pos + 3 * i));
		keep110 = is110;
		if (is110) outputBlock(b110);
		else outputBlock(b011);
	}
}

void run(int n) {
	output(1);
	for (int i = 1; i < 2*n+1; i++) {
		state_direction(pair<int, int>(i, i + 2), 1);
	}
	if (n % 3 == 0) terminationType = 0;
	else if (n % 3 == 1) terminationType = 2;
	else if (n % 3 == 2) terminationType = 1;
	int i = 2;
	vector<int> blocks;
	while (i < 2*n) {
		blocks.push_back(findblock(i));
		i += 3;
	}
	if (terminationType == 1) {
		blocks.push_back(s1);
	} else if (terminationType == 2) {
		blocks.push_back(get_xor(v1(n * 2)) ? s1 : s0);
		blocks.push_back(s1);
	}
	reverse(blocks.begin(), blocks.end());
	int lastBlock = s1;
	while (!blocks.empty()) {
		cout << "blocks are: ";
	for (int b : blocks) {
		if (b == b011) cout << "b011 ";
		else if (b == b110_011) cout << "b110_001 ";
		else if (b == b010) cout << "b010 ";
		else if (b == b101) cout << "b101 ";
		else if (b == b111) cout << "b111 ";
		else if (b == s1) cout << "s1 ";
		else if (b == s0) cout << "s0 ";
		else cout << "<other> ";
	}
	cout << endl;
		int block = blocks.back();
		if (block == b110_011) {
			decideBlock(lastBlock, blocks);
		} else {
			outputBlock(block);
			blocks.pop_back();
		}
		lastBlock = block;
	}
}