#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;
const int MAX_SIZE=200000;

vector<vector<int>> seats[MAX_SIZE+1], passengers[MAX_SIZE+1];
vector<int> cur;
bool used[MAX_SIZE+1];

void genSeats(int k, int l)
{
    if(k > l)
        return;
    seats[cur.size()].push_back(cur);
    for(int i=k+1; i<=l; i++)
    {
        cur.push_back(i);
        genSeats(i, l);
        cur.pop_back();
    }

}

void genPassengers(int k, int n)
{
    if(k > n)
        return;
    passengers[cur.size()].push_back(cur);
    for(int i=1; i<=n; i++)
    {
        if(!used[i])
        {
            used[i]=true;
            cur.push_back(i);
            genPassengers(k+1, n);
            cur.pop_back();
            used[i]=false;
        }
    }
}

int main()
{
    int n,l;
    int a[MAX_SIZE+1], b[MAX_SIZE+1];
    cin>>n>>l;
    for(int i=1; i<=n; i++)
    {
        cin>>a[i]>>b[i];
    }
    genSeats(0,l);
    while(!cur.empty())
        cur.pop_back();
    genPassengers(0,n);
    for(int k=1; k<=n; k++)
    {
        if(k>l)
        {
            cout<<0<<endl;
            continue;
        }
        int m=0;
        for(vector<int> curSeats : seats[k])
        {

            for(vector<int> curPassengers : passengers[k])
            {
                int obsht=0;
                for(int pos=0; pos<curPassengers.size(); pos++)
                {
                    int sus=0;
                    if(pos+1 >= curSeats.size())
                    {
                        sus=abs(l-curSeats[pos]);
                    }
                    else
                    {
                        sus=abs(curSeats[pos+1]-curSeats[pos]-1);
                    }
                    if(pos-1 < 0)
                    {
                        sus+=abs(curSeats[pos]-1);
                    }
                    else
                    {
                        sus+=abs(curSeats[pos]-curSeats[pos-1]-1);
                    }
                    //cout<<curPassengers[pos]<<" "<<curSeats[pos]<<" "<<sus<<endl;
                    obsht+=a[curPassengers[pos]]+sus*b[curPassengers[pos]];
                }
                //cout<<endl;
                m=max(m, obsht);
            }
        }
        cout<<m<<endl;
    }

    return 0;
}
