#include <bits/stdc++.h>
#define endl '\n'
#define left alhkjghkagjha
#define right qitqjofhejwjkfweh

using namespace std;

const int N = 107;
const pair < int, int > D[8] = {
  make_pair(2, 1),
  make_pair(2, -1),
  make_pair(1, 2),
  make_pair(1, -2),
  make_pair(-1, 2),
  make_pair(-1, -2),
  make_pair(-2, 1),
  make_pair(-2, -1)
};

int n, m, k;
char a[N][N];
vector < pair < int, int > > ans;
bool used[N][N];
vector < pair < int, int > > left, right;

void dfs(int r, int c, int side) {
  used[r][c] = true;

  if(side==0) {
    left.push_back(make_pair(r, c));
  }
  else {
    right.push_back(make_pair(r, c));
  }

  for(int i=0;i<8;i++) {
    int p = r + D[i].first, t = c + D[i].second;

    if(p>=0 && p<n && t>=0 && t<m) {
      if(!used[p][t] && a[p][t]=='.') {
        dfs(p, t, side ^ 1);
      }
    }
  }
}

void append(vector < pair < int, int > > &a) {
  for(int i=0;i<(int)(a.size());i++) {
    ans.push_back(a[i]);
  }
}

void update_answer() {
  //printf("%d %d\n", (int)(left.size()), (int)(right.size()));
  
  if(left.empty()) {
    append(right);
    return;
  }

  if(right.empty()) {
    append(left);
    return;
  }

  if(left.size()>right.size()) {
    swap(left, right);
  }

  append(left);
  append(right);

  for(int i=1;i<=k;i++) {
    if(i&1) {
      append(left);
    }
    else {
      append(right);
    }
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int i, j;

  scanf("%d %d %d", &n, &m, &k);
  for(i=0;i<n;i++) {
    scanf("%s", a[i]);
  }

  for(i=0;i<n;i++) {
    for(j=0;j<m;j++) {
      if(a[i][j]=='.' && !used[i][j]) {
        left.clear();
        right.clear();

        dfs(i, j, 0);
        update_answer();
      }
    }
  }

  printf("%d\n", (int)(ans.size()));
  for(i=0;i<(int)(ans.size());i++) {
    printf("%d %d\n", ans[i].first, ans[i].second);
  }

  return 0;
}
