#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 200007;

struct el {
  int a, b, idx;

  el(){}
  el(int x, int y, int z) {
    a = x;
    b = y;
    idx = z;
  }

  bool operator <(const el &x) const {
    if(b > x.b) return true;
    if(b < x.b) return false;

    return a > x.a;
  }
};

int n, l, k;
pair < int, int > a[N];
long long ps[N], ans[N], mx;
el arr[N];

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int i, j;

  scanf("%d %d", &n, &l);
  for(i=1;i<=n;i++) {
    scanf("%d %d", &a[i].first, &a[i].second);
    mx = max(mx, a[i].first + 0ll + a[i].second * 1ll * (l - 1));
  }

  ans[1] = mx;

  //Sort in increasing order of A
  sort(a + 1, a + 1 + n, greater < pair < int, int > > ());

	if(n<=200 || l<=200) {
		//Get partial sums of As
  for(i=1;i<=n;i++) {
    ps[i] = ps[i-1] + a[i].first;
  }

  for(k=2;k<=l && k<=n;k++) {
    int x = l - k;

    for(i=1;i<=n;i++) {
      for(j=i+1;j<=n;j++) {
        long long curr = a[i].first + 0ll + a[i].second*1ll*x + a[j].first + 0ll + a[j].second*1ll*x;

        int to = k-2;
        
        curr += ps[k - 2];
        if(to>=i) {
          curr -= a[i].first;
          curr += a[++to].first;
        }

        if(to>=j) {
          curr -= a[j].first;
          curr += a[++to].first;
        }

        ans[k] = max(ans[k], curr);
      }
    }
  }
	}
else {
  for(i=1;i<=n;i++) {
    arr[i] = el(a[i].first, a[i].second, i);
  }

  sort(arr + 1, arr + 1 + n);

  //Get partial sums of As
  for(i=1;i<=n;i++) {
    ps[i] = ps[i-1] + a[i].first;
  }

  for(k=2;k<=l && k<=n;k++) {
    int x = l - k;

    for(int z=1;z<=3;z++) {
    for(int idx=1;idx+z<=n;idx++) {
      i = min(arr[idx].idx, arr[idx + z].idx);
      j = max(arr[idx].idx, arr[idx + z].idx);

      long long curr = a[i].first + 0ll + a[i].second*1ll*x + a[j].first + 0ll + a[j].second*1ll*x;

      int to = k-2;
      
      curr += ps[k - 2];
      if(to>=i) {
        curr -= a[i].first;
        curr += a[++to].first;
      }

      if(to>=j) {
        curr -= a[j].first;
        curr += a[++to].first;
      }

      ans[k] = max(ans[k], curr);
    }}
  }
}
  for(i=1;i<=n;i++) {
    printf("%lld\n", ans[i]);
  }

  return 0;
}
