#include <bits/stdc++.h>
#define endl '\n'

#define SZ(x) ((int)x.size())
#define ALL(V) V.begin(), V.end()
#define L_B lower_bound
#define U_B upper_bound
#define pb push_back

using namespace std;
template<class T, class T1> int chkmax(T &x, const T1 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T1> int chkmin(T &x, const T1 &y) { return x > y ? x = y, 1 : 0; }
const int MAXN = (142);

vector<int> dx = {-1, -1, -2, -2, 1, 1, 2, 2};
vector<int> dy = {2, -2, -1, 1, -2, 2, 1, -1};

int n, m, k;
string a[MAXN];

bool valid(int x, int y) { return x >= 0 && y >= 0 && x < n && y < m && a[x][y] == '.'; }

void read()
{
    cin >> n >> m >> k;
    for(int i = 0; i < n; i++)
        cin >> a[i];
}

bool ok[MAXN][MAXN][MAXN];

void solve()
{
    vector<pair<int, int> > valid_cells;
    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
            if(valid(i, j))
            {
                ok[i][j][0] = 1;
                valid_cells.push_back({i, j});
            }

    vector<pair<int, int> > answer, ans;
    int found = -1;

    for(int tr = 0; tr < 10; tr++)
    {
        random_shuffle(ALL(valid_cells));
        answer.clear();

        for(auto it: valid_cells)
        {
            int i = it.first, j = it.second;
            ok[i][j][0] = 1;
        }

        for(int h = 0; h <= k; h++)
        for(auto it: valid_cells)
        {
            int i = it.first, j = it.second;
            if(ok[i][j][h])
            {
                answer.pb({i, j});
                for(int o = h; o <= k; o++)
                    ok[i][j][o] = 0;

                for(int d = 0; d < 8; d++)
                {
                    int nx = i + dx[d], ny = j + dy[d];
                    if(valid(nx, ny))
                        ok[nx][ny][h + 1] = 1;
                }
            }
        }

        if(found == -1 || SZ(ans) > SZ(answer))
            ans = answer, found = 1;
    }

    answer = ans;
    cout << SZ(answer) << endl;
    for(auto it: answer) cout << it.first << " " << it.second << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}
