#include <bits/stdc++.h>
#define endl '\n'

#define SZ(x) ((int)x.size())
#define ALL(V) V.begin(), V.end()
#define L_B lower_bound
#define U_B upper_bound
#define pb push_back

using namespace std;
template<class T, class T1> int chkmax(T &x, const T1 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T1> int chkmin(T &x, const T1 &y) { return x > y ? x = y, 1 : 0; }
const int MAXN = (142);

vector<int> dx = {-1, -1, -2, -2, 1, 1, 2, 2};
vector<int> dy = {2, -2, -1, 1, -2, 2, 1, -1};

int n, m, k;
string a[MAXN];

bool valid(int x, int y) { return x >= 0 && y >= 0 && x < n && y < m && a[x][y] == '.'; }

void read()
{
    cin >> n >> m >> k;
    for(int i = 0; i < n; i++)
        cin >> a[i];
}

map<int, int> ok[MAXN][MAXN];
int deg[MAXN][MAXN];

bool cmp(pair<int, int> a, pair<int, int> b) { return deg[a.first][a.second] < deg[b.first][b.second]; }

void solve()
{
    vector<pair<int, int> > valid_cells;
    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
            if(valid(i, j))
            {
                ok[i][j][0] = 1;
                valid_cells.push_back({i, j});
            }

    vector<pair<int, int> > answer;

    for(auto it: valid_cells)
    {
        int i = it.first, j = it.second;
        for(int d = 0; d < 8; d++)
            {
                int nx = i + dx[d], ny = j + dy[d];
                if(valid(nx, ny))
                    deg[i][j]++;
            }
    }

    sort(valid_cells.begin(), valid_cells.end(), cmp);
    reverse(ALL(valid_cells));

    for(int h = 0; h <= k; h++)
    for(auto it: valid_cells)
    {
        int i = it.first, j = it.second;
        if(ok[i][j].count(h))
        {
            answer.pb({i, j});
            for(int d = 0; d < 8; d++)
            {
                int nx = i + dx[d], ny = j + dy[d];
                if(valid(nx, ny))
                    for(auto q: ok[i][j])
                        ok[nx][ny][q.first + 1] = 1;
            }

            ok[i][j].clear();
        }
    }

    cout << SZ(answer) << endl;
    for(auto it: answer) cout << it.first << " " << it.second << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}
