#include <bits/stdc++.h>
#define endl '\n'

#define SZ(x) ((int)x.size())
#define ALL(V) V.begin(), V.end()
#define L_B lower_bound
#define U_B upper_bound
#define pb push_back

using namespace std;
template<class T, class T1> int chkmax(T &x, const T1 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T1> int chkmin(T &x, const T1 &y) { return x > y ? x = y, 1 : 0; }
const int MAXN = (1 << 20);
const int64_t inf = (int64_t)1e18;

int n, l;
pair<int, int> a[MAXN];

void read()
{
    cin >> n >> l;
    for(int i = 0; i < n; i++)
        cin >> a[i].first >> a[i].second;
}

int64_t answer[MAXN];
int m;

void solve()
{
    for(int i = 1; i <= n; i++)
        answer[i] = 0;

    m = min(n, l);

    sort(a, a + n);
    reverse(a, a + n);

    for(int i = 0; i < n; i++)
        chkmax(answer[1], a[i].first + a[i].second * 1ll * (l - 1));

    for(int i = 0; i < n; i++)
            for(int j = i + 1; j < n; j++)
            {
                vector<int> oth;
                for(int o = 0; o < n; o++)
                    if(o != i && o != j)
                        oth.push_back(a[o].first);

                sort(ALL(oth));
                reverse(ALL(oth));

                int64_t sum = 0;
                for(int k = 0; k + 2 <= m; k++)
                {
                    chkmax(answer[k + 2], sum + a[i].first + a[j].first + (l - k - 2) * 1ll * (a[i].second + a[j].second));
                    if(k != m - 2)
                        sum += oth[k];
                }
            }

    vector<int> curr_max;

    int64_t sum_a = 0;
    for(int i = 0; i < m; i++)
    {
        sum_a += a[i].first;
        curr_max.pb(a[i].second);

        sort(ALL(curr_max));
        reverse(ALL(curr_max));
        if(SZ(curr_max) > 2)
            curr_max.pop_back();

        if(i >= 1)
            chkmax(answer[i + 1], sum_a + (l - i - 1) * 1ll * (curr_max[0] + curr_max[1]));
    }

    int mx = 0;
    sum_a = 0;
    for(int i = -1; i + 1 < m; i++)
    {
        if(i != -1)
        {
            chkmax(mx, a[i].second);
            sum_a += a[i].first;
        }

        int64_t mx2 = 0;
        vector<int64_t> mx_li;
        for(int j = i + 1; j < n; j++)
        {
            mx_li.pb(a[j].first + a[j].second * 1ll * (l - i - 3));
            sort(ALL(mx_li));
            reverse(ALL(mx_li));
            if(SZ(mx_li) > 2)
                mx_li.pop_back();

            chkmax(mx2, a[j].first + a[j].second * 1ll * (l - i - 2));
        }

        if(SZ(mx_li) == 2) chkmax(answer[i + 3], sum_a + mx_li[0] + mx_li[1]);
        if(i != -1) chkmax(answer[i + 2], sum_a + mx * 1ll * (l - i - 2) + mx2);
    }

    for(int i = 1; i <= n; i++)
        cout << answer[i] << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}
