#include<iostream>
#include<algorithm>
using namespace std;
struct person{
    long long a, b, id;
    friend bool operator<(const person& a, const person& b)
    {
        return a.a > b.a;
    }
};
const long long maxn = 5000;
long long n, l;
person p[maxn];
long long psum[maxn];
int main()
{
    cin >> n >> l;
    for(long long i = 0; i < n; i ++)
    {
        cin >> p[i].a >> p[i].b;
        p[i].id = i;
    }
    sort(p, p + n);
    /*for(long long i = 0; i < n; i ++)
    {
        cout << p[i].a << " " << p[i].b << " " << p[i].id << endl;
    }*/
    for(long long i = 0; i < n; i ++)
    {
        psum[i] = p[i].a;
        if(i > 0)   psum[i] += psum[i - 1];
    }

    {
        long long mx = 0;
        for(long long i = 0; i < n; i ++)
        {
            mx = max(mx, p[i].a + p[i].b * (l - 1));
        }
        cout << mx << endl;
    }

    for(long long s = 2; s <= min(l, n); s ++)
    {
        long long mx = 0;

        int mi = -1, mj = -1;
        for(int i = 0; i < n; i ++)
        {
            if(p[mi].a + (l - s) * p[mi].b < p[i].a + (l - s) * p[i].b || mi == -1) mi = i;
        }
        for(int i = 0; i < n; i ++)
        {
            if(i != mi)
            if(p[mj].a + (l - s) * p[mj].b < p[i].a + (l - s) * p[i].b || mj == -1) mj = i;
        }

        if(mi > mj) swap(mi, mj);
        //cout << mi << " " << mj << endl;
        for(long long i = mi; i <= mi; i ++)
        {
            for(long long j = mj; j <= mj; j ++)
            {
                long long curr = 0;
                curr += (l - s) * (p[i].b + p[j].b);
                curr += p[i].a;
                curr += p[j].a;
                if(s >= 3)
                {
                    long long gt = s - 3;
                    if(i <= gt)
                    {
                        gt ++;
                        curr -= p[i].a;
                    }
                    if(j <= gt)
                    {
                        gt ++;
                        curr -= p[j].a;
                    }
                    //if(gt == n) gt --;
                    //cout << "!!" << gt << endl;
                    curr += psum[gt];
                }
                mx = max(mx, curr);
            }
        }
        cout << mx << endl;
    }
    for(long long i = l + 1; i <= n; i ++)
    {
        cout << 0 << endl;
    }

}
