#include <bits/stdc++.h>

const int32_t MAX_N = 100;
const int32_t MAX_M = 100;

char board[MAX_N + 5][MAX_M + 5];
int32_t n, m, k;

void SolveEmptyBoard() {
	int32_t cntWhite = 0, cntBlack = 0;
	std::vector< std::pair< int32_t, int32_t > > white, black; 

	for(int32_t i = 0; i < n; i++) {
		for(int32_t j = 0; j < m; j++) {
			if(i % 2 == j % 2) {
				cntWhite++;
				white.push_back({ i, j });
			}
			else {
				cntBlack++;
				black.push_back({ i, j });
			}
		}
	}

	if(k % 2 == 0) {
		std::cout << k * (cntWhite + cntBlack) << '\n';
		
		for(int32_t i = 0; i < k; i++) {
			for(auto &x : white) {
				std::cout << x.first << " " << x.second << '\n';		
			}
			for(auto &x : black) {
				std::cout << x.first << " " << x.second << '\n';
			}
		}
	}
	else {
		std::cout << k * (cntWhite + cntBlack) + std::min(cntWhite, cntBlack) << '\n';

		if(cntWhite <= cntBlack) {
			for(auto &x : white) {
				std::cout << x.first << " " << x.second << '\n';
			}

			for(int32_t i = 0; i < k; i++) {
				for(auto &x : black) {
					std::cout << x.first << " " << x.second << '\n';
				}
				for(auto &x : white) {
					std::cout << x.first << " " << x.second << '\n';
				}
			}
		}
		else {
			for(auto &x : black) {
				std::cout << x.first << " " << x.second << '\n';
			}

			for(int32_t i = 0; i < k; i++) {
				for(auto &x : white) {
					std::cout << x.first << " " << x.second << '\n';
				}
				for(auto &x : black) {
					std::cout << x.first << " " << x.second << '\n';
				}
			}
		}
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n >> m >> k;

	for(int32_t i = 0; i < n; i++) {
		for(int32_t j = 0; j < m; j++) {
			std::cin >> board[i][j];
		}
	}

	SolveEmptyBoard();
}
