#include <bits/stdc++.h>
#include "park.h"
#define int32_t int

const int32_t MAX_N = 1e5;

void state_direction(const std::pair< int32_t, int32_t > &edge, bool direction);

bool get_xor(const std::vector< std::pair< int32_t, int32_t > > &edges);

bool isGuessed[2 * MAX_N + 5];
void run(int32_t n) {
	state_direction({ 1, 2 }, 1);
	state_direction({ 1, 3 }, 1);
	state_direction({ 2 * n + 1, 2 * n + 2 }, 1);
	state_direction({ 2 * n, 2 * n + 2 }, 1);

	for(int32_t i = 2; i <= 2 * n - 1; i++) {
		state_direction({ i, i + 2 }, 1);
	}
	
	/**
	for(int32_t i = 2; i <= 2 * n; i++) {
		std::vector< std::pair< int32_t, int32_t > > edges = { { i, i + 1 } };
		bool dir = get_xor(edges);

		state_direction({ i, i + 1 }, dir);
	}
	*/

	for(int32_t i = 3; i < 2 * n + 1; i += 2) {
		std::vector< std::pair< int32_t, int32_t > > edges = { { i, i + 1 } };
		bool dir = get_xor(edges);

		state_direction({ i, i + 1 }, dir);
		if(dir == 0) {
			if(!isGuessed[i - 1]) {
				state_direction({ i - 1, i }, 1);
				isGuessed[i - 1] = true;
			}
			if(!isGuessed[i + 1]) {
				state_direction({ i + 1, i + 2 }, 1);
				isGuessed[i + 1] = true;
			}
		}
		else {
			if(!isGuessed[i - 1]) {
				edges = { { i - 1, i } };
				dir = get_xor(edges);

				state_direction({ i - 1, i }, dir);
				isGuessed[i - 1] = true;
			}
		}
	}

	if(!isGuessed[2 * n]) {
		std::vector< std::pair< int32_t, int32_t > > edges = { { 2 * n, 2 * n + 1 } };
		bool dir = get_xor(edges);

		state_direction({ 2 * n, 2 * n + 1 }, dir);
	}
}

//#include "Lgrader.cpp"
