#include <bits/stdc++.h>
#include "park.h"
#define int32_t int

const int32_t MAX_N = 1e5;

void state_direction(const std::pair< int32_t, int32_t > &edge, bool direction);

bool get_xor(const std::vector< std::pair< int32_t, int32_t > > &edges);

int32_t dir[2 * MAX_N + 5];
void run(int32_t n) {
	state_direction({ 1, 2 }, 1);
	state_direction({ 1, 3 }, 1);
	state_direction({ 2 * n + 1, 2 * n + 2 }, 1);
	state_direction({ 2 * n, 2 * n + 2 }, 1);

	for(int32_t i = 2; i <= 2 * n - 1; i++) {
		state_direction({ i, i + 2 }, 1);
	}
	
	dir[1] = 1;
	for(int32_t i = 1; i <= 2 * n - 1; i += 2) {
		std::vector< std::pair< int32_t, int32_t > > edges = {
			{ i, i + 1 }, 
			{ i + 1, i + 2 }, 
			{ i + 2, i + 3 }
		};

		bool x = get_xor(edges);

		if(x == 1) {
			state_direction({ i + 2, i + 3 }, dir[i]);
			state_direction({ i + 1, i + 2 }, 1);
			dir[i + 2] = dir[i];
		}
		else {
			if(dir[i] == 0) {
				state_direction({ i + 2, i + 3 }, 1);
				dir[i + 2] = 1;

				state_direction({ i + 1, i + 2 }, 1);
			}
			else {
				edges = {
					{ i + 1, i + 2 }	
				};

				x = get_xor(edges);
				state_direction({ i + 1, i + 2 }, x);
				state_direction({ i + 2, i + 3 }, x);	
				dir[i + 2] = x;
			}
		}
	}
}

//#include "Lgrader.cpp"
