#include <bits/stdc++.h>
#include "park.h"
#define int32_t int

const int32_t MAX_N = 1e5;

void state_direction(const std::pair< int32_t, int32_t > &edge, bool direction);

bool get_xor(const std::vector< std::pair< int32_t, int32_t > > &edges);

int32_t dir[2 * MAX_N + 5];
void run(int32_t n) {
	state_direction({ 1, 2 }, 1);
	state_direction({ 1, 3 }, 1);
	state_direction({ 2 * n + 1, 2 * n + 2 }, 1);
	state_direction({ 2 * n, 2 * n + 2 }, 1);

	for(int32_t i = 2; i <= 2 * n - 1; i++) {
		state_direction({ i, i + 2 }, 1);
	}

	memset(dir, -1, sizeof(dir));

	dir[2 * n + 1] = 1;
	for(int32_t i = 2 * n - 1; i >= 1; i -= 2) {
		std::vector< std::pair< int32_t, int32_t > > edges = {
			{ i, i + 1 }, 
			{ i + 1, i + 2 }, 
			{ i + 2, i + 3 }
		};

		bool x = get_xor(edges);

		if(x == 1) {
			state_direction({ i, i + 1 }, dir[i + 2]);
			state_direction({ i + 1, i + 2 }, 1);
			dir[i] = dir[i + 2];
		}
		else {
			if(dir[i + 2] == 0) {
				state_direction({ i, i + 1 }, 1);
				dir[i] = 1;
				state_direction({ i + 1, i + 2 }, 1);
			}
			else {
				break;
			}
		}

	}
	
	dir[1] = 1;
	for(int32_t i = 1; i <= 2 * n - 1; i += 2) {
		std::vector< std::pair< int32_t, int32_t > > edges = {
			{ i, i + 1 }, 
			{ i + 1, i + 2 }, 
			{ i + 2, i + 3 }
		};

		bool x = get_xor(edges);

		if(x == 1) {
			state_direction({ i + 2, i + 3 }, dir[i]);
			state_direction({ i + 1, i + 2 }, 1);
			dir[i + 2] = dir[i];
		}
		else {
			if(dir[i] == 0) {
				state_direction({ i + 2, i + 3 }, 1);
				dir[i + 2] = 1;
				state_direction({ i + 1, i + 2 }, 1);
			}
			else {
				if(dir[i + 2] != -1) {
					state_direction({ i + 1, i + 2 }, (dir[i + 2] ^ 1));
					break;
				}

				edges = {
					{ i + 1, i + 2 }	
				};

				x = get_xor(edges);
				state_direction({ i + 1, i + 2 }, x);
				state_direction({ i + 2, i + 3 }, (x ^ 1));	
				dir[i + 2] = (x ^ 1);
			}
		}
	}
}

//#include "Lgrader.cpp"
