#include <iostream>
#include <vector>
using namespace std;

bool get_xor(const std::vector<std::pair<int, int>>& edges);
void state_direction(const std::pair<int, int>& edge, bool direction);

int run(int n)
{
    state_direction(make_pair(1, 2), 1);
    state_direction(make_pair(1, 3), 1);
    state_direction(make_pair(n * 2 - 2, n), 1);
    state_direction(make_pair(n * 2 - 1, n), 1);

    for (int i = 2; i <= 2 * n; ++ i)
    {
        bool dir;
        dir = get_xor({make_pair(i, i + 1)});
        state_direction(make_pair(i, i + 1), dir);
        dir = get_xor({make_pair(i, i + 2)});
        state_direction(make_pair(i, i + 2), dir);
    }
}
