#include <iostream>
#include <utility>
#include <algorithm>
#define fi first
#define se second
using namespace std;

const int MAXN = 100005;

int n, l;
pair<long long, long long> a[MAXN];
long long b[MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> l;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i].fi >> a[i].se;
    }

    sort(a + 1, a + n + 1);

    for (int i = 1; i <= n; ++ i)
    {
        b[i] = b[i - 1] + a[i].fi;
    }
}

void One()
{
    long long opt = 0;
    for (int i = 1; i <= n; ++ i)
    {
        if (a[i].fi + a[i].se * (l - 1) > opt)
        {
            opt = a[i].fi + a[i].se * (l - 1);
        }
    }

    cout << opt << endl;
}

void Two()
{
    if (l == 1)
    {
        cout << 0 << endl;
        return;
    }

    long long opt = 0;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = i + 1; j <= n; ++ j)
        {
            if ((a[i].fi + a[j].fi) + (a[i].se + a[j].se) * (l - 2) > opt)
            {
                opt = (a[i].fi + a[j].fi) + (a[i].se + a[j].se) * (l - 2);
            }
        }
    }

    cout << opt << endl;
}

int main()
{
    Init();
    One();
    Two();

    for (int k = 3; k <= n; ++ k)
    {
        if (k > l) cout << 0 << endl;
        else
        {
            long long opt = 0;
            for (int i = 1; i <= n; ++ i)
            {
                for (int j = i + 1; j <= n; ++ j)
                {
                    long long current = 0, tmp = k - 2;
                    if (j >= n - tmp + 1) tmp++;
                    if (i >= n - tmp + 1) tmp++;
                    current += b[n] - b[n - tmp] + (a[i].se + a[j].se) * (l - k);
                    if (current > opt) opt = current;
                }
            }
            cout << opt << endl;
        }
    }

    return 0;
}

