#include<iostream>
#include<algorithm>
#include<cmath>          //              (i+j)%2==0 - cherno
#include<string>
#include<queue>
#include<stack>
#include<cstdio>
using namespace std;
int a[102][102];
int u=1;
int b[10000];
int w[10000];
int n, m, k;
queue<pair<int, int> > q[1000];
void dfs(int i, int j)
{
    if((i+j)%2==0){b[u]++;}
    else {w[u]++;}
    q[u].push(make_pair(i,j));
    a[i][j]=u;
    if(i-2>=0 and j-1>=0 and a[i-2][j-1]==1){dfs(i-2,j-1);}
    if(i-1>=0 and j-2>=0 and a[i-1][j-2]==1){dfs(i-1,j-2);}
    if(i-2>=0 and j+1<m and a[i-2][j+1]==1){dfs(i-2,j+1);}
    if(i-1>=0 and j+2<m and a[i-1][j+2]==1){dfs(i-1,j+2);}
    if(i+2<n and j-1>=0 and a[i+2][j-1]==1){dfs(i+2,j-1);}
    if(i+1<n and j-2>=0 and a[i+1][j-2]==1){dfs(i+1,j-2);}
    if(i+2<n and j+1<m and a[i+2][j+1]==1){dfs(i+2,j+1);}
    if(i+1<n and j+2<m and a[i+1][j+2]==1){dfs(i+1,j+2);}
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>n>>m>>k;
    for(int i=0;i<n;i++)
        for(int j=0;j<m;j++)
    {
        char x;
        cin>>x;
        if(x=='#')a[i][j]=0;
        else a[i][j]=1;
    }
    for(int i=0;i<n;i++)
        for(int j=0;j<m;j++)
    {
        if(a[i][j]==1)
        {
            u++;
            dfs(i,j);
        }
    }
    int ans=0;
    for(int uu=2;uu<=u;uu++)
    {
        if(b[uu]+w[uu]==1)ans+=1;
        else
        {
        ans=ans+k*(b[uu]+w[uu]);
        if(k%2==1)ans+=min(b[uu],w[uu]);
        }
    }
    cout<<ans<<endl;

    for(int uu=2;uu<=u;uu++)
    {
        pair<int,int> qq;
        int broj=b[uu]+w[uu];
        if(broj==1){qq=q[uu].front();cout<<qq.first<<" "<<qq.second<<endl;}
        else
        {
            //if(k%2==0)
            //{
                int fl=0;

                for(int kk=1;kk<=k*2;kk++)
                {
                    fl=(fl+1)%2;//cout<<broj<<endl;
                    for(int i=1;i<=broj;i++)
                    {
                        qq=q[uu].front();

                        if((qq.first+qq.second)%2==fl)cout<<qq.first<<" "<<qq.second<<endl;
                        q[uu].pop();
                        q[uu].push(qq);
                    }
                }
                if(b[uu]<w[uu])
                {
                    for(int i=1;i<=broj;i++)
                    {
                        qq=q[uu].front();
                        if((qq.first+qq.second)%2==0)cout<<qq.first<<" "<<qq.second<<endl;
                        q[uu].pop();
                        q[uu].push(qq);
                    }
                }
                else
                    for(int i=1;i<=broj;i++)
                    {
                        qq=q[uu].front();
                        if((qq.first+qq.second)%2==1)cout<<qq.first<<" "<<qq.second<<endl;
                        q[uu].pop();
                        q[uu].push(qq);
                    }
            //}
        }
    }

    return 0;
}
