#include "park.h"
#include <vector>
using namespace std;

const int N=(5e5)+5;

int up[N],down[N],diag[N];
int in[N];

void run(int n)
{
 bool state;
 int i;
 vector < pair <int,int> > v;

 state_direction({1,2},1);
 state_direction({1,3},1);
 state_direction({2*n,2*n+2},1);
 state_direction({2*n+1,2*n+2},1);

  for(i=3;i<=2*n-1;i+=2)///up
  {
   v.clear();
   v.push_back({i,i+2});
   state=get_xor(v);
   up[i]=state;

    if(state)
     in[i+2]++;
    else
     in[i]++;

   state_direction({i,i+2},state);
  }

  for(i=2;i<=2*n-2;i+=2)///down
  {
   v.clear();
   v.push_back({i,i+2});
   state=get_xor(v);
   down[i]=state;

    if(state)
     in[i+2]++;
    else
     in[i]++;

   state_direction({i,i+2},state);
  }

  for(i=2;i<=2*n;i+=2)///diag
  {
   v.clear();
   v.push_back({i,i+1});
   state=get_xor(v);
   diag[i]=state;

    if(state)
     in[i+1]++;
    else
     in[i]++;

   state_direction({i,i+1},state);
  }

  for(i=3;i<=2*n-1;i+=2)///across
  {
    if(in[i]==0)
    {
     state_direction({i,i+1},0);
     continue;
    }

    if(in[i+1]==0)
    {
     state_direction({i,i+1},1);
     continue;
    }

    if(diag[i-1] && !down[i-1])
    {
     state_direction({i,i+1},0);
     continue;
    }

    if(!diag[i-1] && down[i-1])
    {
     state_direction({i,i+1},1);
     continue;
    }

    if(diag[i+1] && !up[i])
    {
     state_direction({i,i+1},0);
     continue;
    }

    if(!diag[i+1] && up[i])
    {
     state_direction({i,i+1},1);
     continue;
    }
  }
}
