#include <bits/stdc++.h>
using namespace std;
const int MAX_N=205;
int n, l, sitting[MAX_N], sparse[MAX_N], k;
long long int dp[MAX_N][MAX_N][MAX_N];
void print(int toPrint[], int sz)
{
    for(int i=1; i<=sz; i++)
        printf("%d ", toPrint[i]);
    printf("\n");
}
void read()
{
    scanf("%d %d", &n ,&l);
    for(int i=1; i<=n; i++)
        scanf("%d %d", &sitting[i], &sparse[i]);
}
void init()
{
    for(int person=1; person<=n; person++)
        for(int pos=1; pos<=l; pos++)
            dp[person][pos][1]=sitting[person]+(pos-1)*sparse[person]+(l-pos)*sparse[person];
}
void solve()
{
    for(int person=1; person<=n; person++)
        for(int pos=1; pos<=l; pos++)
            for(int currentSeated=1; currentSeated<=pos; currentSeated++)
                for(int prevPerson=currentSeated-1; prevPerson<person; prevPerson++)
                    for(int prevPos=currentSeated-1; prevPos<pos; prevPos++)
                        if(dp[person][pos][currentSeated]<dp[prevPerson][prevPos][currentSeated-1]+(pos-prevPos-1)*sparse[person]+(l-pos)*sparse[person]-(l-pos+1)*sparse[prevPerson]+sitting[person])
                        {
                            if(currentSeated==3)
                            {
                                //cerr<<person<<' '<<pos<<' '<<prevPerson<<' '<<prevPos<<' '<<dp[prevPerson][prevPos][currentSeated-1]<<endl;
                                //cerr<<dp[person][pos][currentSeated]<<' '<<dp[prevPerson][prevPos][currentSeated-1]+(pos-prevPos-1)*sparse[person]+(l-pos)*sparse[person]-(l-pos+1)*sparse[prevPerson]+sitting[person]<<endl;
                            }
                            dp[person][pos][currentSeated]=dp[prevPerson][prevPos][currentSeated-1]+(pos-prevPos-1)*sparse[person]+(l-pos)*sparse[person]-(l-pos+1)*sparse[prevPerson]+sitting[person];
                        }
                        /*dp[person][pos][currentSeated]=max(dp[person][pos][currentSeated],
dp[prevPerson][prevPos][currentSeated-1]+(pos-prevPos-1)*sparse[person]+(l-pos)*sparse[person]-(l-pos+1)*sparse[prevPerson]+sitting[person]);*/
}
void print(int people)
{
    for(int person=1; person<=n; person++)
    {
        for(int pos=1; pos<=l; pos++)
            printf("%lld ", dp[person][pos][people]);
        printf("\n");
    }
}
long long int findAns(int seated)
{
    if(seated>l)
        return 0;
    long long int ans=0;
    for(int person=1; person<=n; person++)
        for(int pos=1; pos<=l; pos++)
            ans=max(ans, dp[person][pos][seated]);
    return ans;
}
void cycleK()
{
    for(int i=1; i<=n; i++)
        printf("%lld\n", findAns(i));
}
int main()
{
    freopen("input.txt", "r", stdin);
    read();
    init();
    solve();
    cycleK();
	return 0;
}
