#pragma GCC optimize "Ofast"
#include <iostream>
#include <vector>

int sx, sy;

const int MAX_N = 101;
bool isfree[MAX_N][MAX_N];

bool graphed[MAX_N][MAX_N];
char asd[MAX_N][MAX_N];

struct ppp {
	int x, y;
};
typedef std::vector<ppp> GR;

std::vector<GR> graphs;

void add_to_graph_up(int n, int x, int y) {
	if(graphed[x][y]) std::cerr << "Wtf\n";
	if(!isfree[x][y]) return;

	graphed[x][y] = true;
	graphs[n].push_back({x, y});
	asd[x][y] = '0' + n;

	if(y - 2 < 0) return;

	if(x == 1) { add_to_graph_up(n, 0, y-2); }
	if(x == 0) { add_to_graph_up(n, 1, y-2); }
}

void add_to_graph_down(int n, int x, int y) {
	if(!isfree[x][y]) return;

	if(!graphed[x][y]) { graphs[n].push_back({x, y});
	asd[x][y] = '0'+n;
	}
	graphed[x][y] = true;

	if(y + 2 >= sy) return;

	if(x == 1) { add_to_graph_down(n, 0, y+2); }
	if(x == 0) { add_to_graph_down(n, 1, y+2); }
}

void make_graph(int x, int y) {
	if(!isfree[x][y]) return;

	graphs.push_back({});
	add_to_graph_up  (graphs.size()-1, x, y);
	add_to_graph_down(graphs.size()-1, x, y);
}

int main() {
	std::cin.tie(nullptr);
	std::ios_base::sync_with_stdio(false);

	int k;
	std::cin >> sy >> sx >> k;

	for(int y = 0;y < sy;y ++) {
		for(int x = 0;x < sx;x ++) {
			char c;
			std::cin >> c;
			isfree[x][y] = (c == '.');
		}
	}


	if(sx != 2) { std::cout << "asd\n"; return 1; }

	for(int y = 0;y < sy;y ++) {
		for(int x = 0;x < sx;x ++) {
			if(!graphed[x][y]) make_graph(x, y);
		}
	}

	std::vector<ppp> ans;
	for(auto g : graphs) {
		for(auto x : g) {
			ans.push_back(x);
		}
	}
	std::cout << ans.size() << '\n';
	for(auto a : ans) std::cout << a.y << ' ' << a.x << '\n';

	/*
	std::cout << graphs.size() << std::endl;
	for(auto g : graphs) {
		for(auto x : g) {
			std::cout << '(' << x.x << ',' << x.y << "), ";
		}
		std::cout << std::endl;
	}
	*/

	/*
	for(int y = 0;y < sy;y ++) {
		for(int x = 0;x < sx;x ++) {
			std::cout << asd[x][y];
		}
		std::cout << std::endl;
	}
	*/

	return 0;
}
