#include <vector>
#include <iostream>
#include "park.h"

using namespace std;
int inc[100001];
int outc[100001];
bool dir[100001][2];
bool stated[100001][2];
int known = 0;
int nn;
bool leftout(int wh)
{
	if(wh == 2) return 1;
	if(wh == 2*nn+1) return 0;
	if(inc[100001] > 0) return 0;
	return 1;
}
bool leftin(int wh)
{
	if(wh == 2) return 0;
	if(wh == 2*nn+1) return 1;
	if(outc[100001] > 0) return 0;
	return 1;
}
int gxor(vector<pair<int, int> > t)
{
	for(int i = 0; i < t.size(); i ++)
	{
		if(t[i].second-t[i].first > 2) return -1;
		if(stated[t[i].first][t[i].second-t[i].first-1]) return -1;
		if(t[i].first<1 || t[i].second > 2*nn+2) return -1;
	}
	return get_xor(t);
}
void statedir(pair<int, int> edge, int dirr)
{
	if(dirr == -1) return;
	if(edge.first<1 || edge.second > 2*nn+2) return;
	if(edge.second-edge.first > 2) return;
	if(stated[edge.first][edge.second-edge.first-1]) return;
	stated[edge.first][edge.second-edge.first-1] = 1;
	state_direction(edge, dirr);
	if(edge.second-edge.first == 1) dir[edge.first][0] = dirr;
	else dir[edge.first][1] = dirr;
	known ++;
	if(dir)
	{
		outc[edge.first] ++;
		inc[edge.second] ++;
	}
	else
	{
		outc[edge.second] ++;
		inc[edge.first] ++;
	}
}
void run(int n)
{
	int target = 4*n+1;
	nn = n;
	statedir({1,2},1);
	statedir({1,3},1);
	statedir({2*n,2*n+2},1);
	statedir({2*n+1,2*n+2},1);

	int curr = 2;
	while(curr < 2*nn+2)
	{
		int ans = gxor({{curr, curr+1},{curr, curr+2}});
		if(ans == -1) continue;
		if(leftout(curr))
		{
			if(ans)
			{
				int k = gxor({{curr-1, curr+1},{curr+1, curr+2}});
				if(k == -1) continue;
				if(k)
				{
					if(!stated[curr-1][1])
					{
						int tmp = gxor({{curr-1, curr+1}});
						if(tmp == -1) continue;
						statedir({curr-1, curr+1}, tmp);
					}
					statedir({curr+1, curr+2}, 1-dir[curr-1][1]);
					if(dir[curr-1][1])
					{
						statedir({curr+1, curr+2}, 0);
						statedir({curr, curr+1}, 1);
						statedir({curr, curr+2}, 0);
						statedir({curr+1, curr+3}, 1);
					}
					else
					{
						statedir({curr+1, curr+2}, 1);
						statedir({curr, curr+1}, 0);
						statedir({curr, curr+2}, 1);
						statedir({curr+1, curr+3}, 0);
					}
				}
				else
				{
					
					statedir({curr-1, curr+1}, 1);
					statedir({curr+1, curr+2}, 1);
					statedir({curr, curr+1}, 0);
					statedir({curr, curr+2}, 1);
				}
			}
			else
			{
				statedir({curr, curr+1}, 1);
				statedir({curr, curr+2}, 1);
				statedir({curr-1, curr+1}, 1);
				statedir({curr+1, curr+2}, gxor({{curr+1, curr+2}}));
			}
		}
		else if(leftin(curr))
		{
			if(ans)
			{
				int k = gxor({{curr-1, curr+1},{curr+1, curr+2}});
				if(k == -1) cotinue;
				if(k)
				{
					if(!stated[curr-1][1])
					{
						int tmp = gxor({{curr-1, curr+1}});
						if(tmp == -1) continue;
						statedir({curr-1, curr+1}, tmp);
					}
					statedir({curr+1, curr+2}, 1-dir[curr-1][1]);
					if(dir[curr-1][1])
					{
						statedir({curr+1, curr+2}, 0);
						statedir({curr, curr+1}, 1);
						statedir({curr, curr+2}, 0);
						statedir({curr+1, curr+3}, 1);
					}
					else
					{
						statedir({curr+1, curr+2}, 1);
						statedir({curr, curr+1}, 0);
						statedir({curr, curr+2}, 1);
						statedir({curr+1, curr+3}, 0);
					}
				}
				else
				{
					
					statedir({curr-1, curr+1}, 0);
					statedir({curr+1, curr+2}, 0);
					statedir({curr, curr+1}, 1);
					statedir({curr, curr+2}, 0);
				}
			}
			else
			{
				statedir({curr, curr+1}, 0);
				statedir({curr, curr+2}, 0);
				statedir({curr-1, curr+1}, 0);
				//statedir({curr+1, curr+2}, gxor({{curr+1, curr+2}}));
			}
		}
		else
		{
			if(dir[curr-1][0]) statedir({curr-3, curr-1}, 0);
			else statedir({curr-3, curr-1}, 1);

			//if(leftin(curr-1)) statedir({curr-1, curr+1}, 0);
			//if(leftout(curr-1)) statedir({curr-1, curr+1}, 1);
			//else statedir({curr-1, curr+1}, gxor({{curr-1, curr+1}}));
			if(dir[curr-1][0])
			{
				statedir({curr-1, curr+1}, 0);
				statedir({curr, curr+1}, 0);
				if(ans)
				{
					statedir({curr, curr+2}, 1);
					statedir({curr+1, curr+2}, 1);
				}
				else
				{
					statedir({curr, curr+2}, 0);
					statedir({curr+1, curr+2}, gxor({{curr+1,curr+2}}));
				}
			}
			else
			{
				statedir({curr-1, curr+1}, 1);
				statedir({curr, curr+1}, 1);
				if(ans)
				{
					statedir({curr, curr+2}, 0);
					statedir({curr+1, curr+2}, 0);
				}
				else
				{
					statedir({curr, curr+2}, 1);
					statedir({curr+1, curr+2}, gxor({{curr+1,curr+2}}));
				}
			}

		}
		curr += 2;
	}
	for(int i = 1; i <= 2*n+2; i ++)
	{
		if(!stated[i][0]) statedir({i, i+1}, gxor({{i, i+1}}));
		if(!stated[i][1]) statedir({i, i+2}, gxor({{i, i+2}}));
	}
}