#include <cstdio>
#include <vector>

using namespace std;

const int MAXN = 1e2;
const int moveY[] = {-2, -2, +2, +2};
const int moveX[] = {-1, +1, -1, + 1};

int n, m, k;
bool a[MAXN][MAXN];
bool T[MAXN][MAXN][MAXN];

void read_input()
{
    scanf("%d %d %d", &n, &m, &k);

    for(int i = 0; i < n; i++)
    {
        char c;
        for(int j = 0; j < m; j++)
        {
            scanf(" %c", &c);
            if(c == '.')
            {
                a[i][j] = 1;
            }
            else
            {
                a[i][j] = 0;
            }
        }
    }

    /*for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < m; j++)
        {
            printf("%d ", a[i][j]);
        }
        printf("\n");
    }*/
}

void mark(int i, int j)
{
    for(int z = 0; z < 4; z++)
    {
        int nI = i + moveY[z];
        int nJ = j + moveX[z];

        if(nI < 0 || nI >= n || nJ < 0 || nJ >= m) continue;

        for(int g = 1; g <= k; g++)
        {
            T[nI][nJ][g] |= T[i][j][g - 1];
        }
    }
}

void solve()
{
    if(m == 2)
    {
        vector < pair<int,int> > v;

        for(int i = 0; i < n; i++)
        {
            for(int j = 0; j < m; j++)
            {
                T[i][j][0] = true;
            }
        }
        for(int h = 0; h <= k; h++)
        for(int i = 0; i < m; i++)
        {
            for(int j = 0; j < n; j++)
            {
                bool cont = false;
                for(int z = 0; z <= k; z++)
                {
                    if(T[j][i][z] != 0) cont = true;
                    T[j][i][z] = 0;
                }
                if(!cont) continue;
                v.push_back({j, i});

                for(int z = 0; z < m; z++)
                {
                    for(int g = 0; g < n; g++)
                    {
                        mark(g, z);
                    }
                }
            }
        }
        printf("%d\n", v.size());
    }
}

int main()
{
    read_input();
    solve();

    return 0;
}

/*
3 5 1
.....
#####
.#.#.
*/

/*
5 2 1
..
..
..
..
..
*/
