#include<iostream>
#include<vector>
#include<set>

using namespace std;

const int MAXN = 1e5 + 5;

pair <int, int> d[8] = { {2, 1}, {-2, 1}, {-2, -1}, {2, -1}, {1, 2}, {1, -2}, {-1, 2}, {-1, -2} };

int n, m, k;
string a[MAXN];

vector < pair <int, int> > answer;
set < pair <int, int> > possible[2];

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n >> m >> k;
    for(int i = 0;i<n;i++)
    {
        cin >> a[i];
    }

    for(int i = 0;i<n;i++)
    {
        for(int j = 0;j<m;j++)
        {
            if(a[i][j]=='.') possible[0].insert({i, j});
        }
    }

    for(int i = 1;i<=k;i++)
    {
        for(auto it = possible[(i-1)%2].begin();it!=possible[(i-1)%2].end();it++)
        {
            answer.push_back(*it);
        }

        possible[i%2].clear();
        for(auto it = possible[(i-1)%2].begin();it!=possible[(i-1)%2].end();it++)
        {
            pair <int, int> x = *it;

            for(int j = 0;j<8;j++)
            {
                if( (x.first + d[j].first >= 0 && x.first + d[j].first < n) && (x.second + d[j].second >= 0 && x.second + d[j].second < m)
                    && a[x.first + d[j].first][x.second + d[j].second]!='#')
                {
                    possible[i%2].insert({x.first + d[j].first, x.second + d[j].second});
                }
            }
        }
    }

    for(auto it = possible[k%2].begin();it!=possible[k%2].end();it++)
    {
        answer.push_back(*it);
    }

    cout << answer.size() << '\n';
    for(int i = 0;i<answer.size();i++)
        cout << answer[i].first << " " << answer[i].second << '\n';
}
