#include "park.h"
#include <utility>
#include <vector>
bool get_xor(const std::vector<std::pair<int, int>>& edges);
void state_direction(const std::pair<int, int>& edge, bool direction);

void run(int n){
    state_direction(std::make_pair(1, 2), true);
    state_direction(std::make_pair(1, 3), true);
    state_direction(std::make_pair(2*n+1, 2*n+2), true);
    state_direction(std::make_pair(2*n, 2*n+2), true);
    for(int i = 0; i <2*n-2; i++){
        auto p = std::make_pair(i+2, i+4);
        std::vector<std::pair<int, int>> v;
        v.push_back(p);
        state_direction(p, get_xor(v));
    }
    for(int i = 2; i <=2*n; i++){
        auto p = std::make_pair(i, i+1);
        std::vector<std::pair<int, int>> v;
        v.push_back(p);
        state_direction(p, get_xor(v));
    }
}
