#include <bits/stdc++.h>
#define MAXN 100000
#define SIZE 10000

int nbuckets;
long long n, l;
struct person{long long a, b; int index;} v[1 + MAXN];
int pos[1 + MAXN];
std::vector <person> emptyvec;
bool cmp(person A, person B){return A.a > B.a;}
bool cmp2(person A, person B){
    if(A.b != B.b) return A.b < B.b;
    return A.a > B.a;
}
inline float intersection(person A, person B){
    return 1.0 * (B.a - A.a) / (A.b - B.b);
}

struct BUCKET{
    std::vector <std::vector <person>> V;
    inline int srcmax(long long x){
        if(V[0].size() == 1) return V[0][0].index;
        if(1.0 * x <= intersection(V[0][0], V[0][1])) return V[0][0].index;
        int st = 1, dr = V[0].size() - 1;
        while(dr - st > 1){
            int m = (st + dr) / 2;
            if(1.0 * x >= intersection(V[0][m - 1], V[0][m])) st = m;
            else dr = m - 1;
        }
        if(1.0 * x >= intersection(V[0][dr - 1], V[0][dr])) return V[0][dr].index;
        return V[0][st].index;
    }
    inline int srcmaxexcluded(long long x, int i){
        if(V[i].size() == 1) return V[i][0].index;
        if(1.0 * x <= intersection(V[i][0], V[i][1])) return V[i][0].index;
        int st = 1, dr = V[i].size() - 1;
        while(dr - st > 1){
            int m = (st + dr) / 2;
            if(1.0 * x >= intersection(V[i][m - 1], V[i][m])) st = m;
            else dr = m - 1;
        }
        if(1.0 * x >= intersection(V[i][dr - 1], V[i][dr])) return V[i][dr].index;
        return V[i][st].index;
    }
} B[1000];

inline long long max(long long a, long long b){
    return a > b ? a : b;
}

long long s[1 + MAXN];
std::pair <long long, long long> m[1 + MAXN];
inline long long max1(long long k){
    return s[k] + (l - k) * (m[k].first + m[k].second);
}
inline long long max2(long long k){
    int bucket = (k - 1) / SIZE + 1;
    long long cmax = 0;
    for(int i = k; i <= std::min(n, 1LL * bucket * SIZE); i++)
        if(v[i].a + (l - k) * v[i].b > cmax)
            cmax = v[i].a + (l - k) * v[i].b;
    for(int b = bucket + 1; b <= nbuckets; b++){
        int ind = B[b].srcmax(l - k);
        if(v[ind].a + (l - k) * v[ind].b > cmax)
            cmax = v[ind].a + (l - k) * v[ind].b;
    }
    return s[k - 1] + (l - k) * m[k - 1].first + cmax;
}
inline long long max3(long long k){
    std::pair <long long, long long> max = {0, 0};
    int bucket = (k - 2) / SIZE + 1;
    for(int i = k - 1; i <= std::min(n, 1LL * bucket * SIZE); i++){
        if(v[i].a + (l - k) * v[i].b > max.second)
            max.second = v[i].a + (l - k) * v[i].b;
        if(max.second > max.first)
            std::swap(max.first, max.second);
    }
    for(int b = bucket + 1; b <= nbuckets; b++){
        int ind = B[b].srcmax(l - k);
        if(v[ind].a + (l - k) * v[ind].b > max.second)
            max.second = v[ind].a + (l - k) * v[ind].b;
        if(max.second > max.first)
            std::swap(max.first, max.second);

        /*ind = B[b].srcmaxexcluded(l - k, pos[ind]);
        if(v[ind].a + (l - k) * v[ind].b > max.second)
            max.second = v[ind].a + (l - k) * v[ind].b;
        if(max.second > max.first)
            std::swap(max.first, max.second);*/
    }
    return s[k - 2] + max.first + max.second;
}

int main(){
    FILE*fi,*fo;
    //fi = fopen("a.in","r");
    //fo = fopen("a.out","w");
    fi = stdin;
    fo = stdout;

    fscanf(fi,"%lld%lld", &n, &l);
    for(int i = 1; i <= n; i++)
        fscanf(fi,"%lld%lld", &v[i].a, &v[i].b);
    std::sort(v + 1, v + n + 1, cmp);
    for(int i = 1; i <= n; i++){
        s[i] = s[i - 1] + v[i].a;
        m[i] = m[i - 1];
        if(v[i].b > m[i].second) m[i].second = v[i].b;
        if(m[i].second > m[i].first) std::swap(m[i].second, m[i].first);
        v[i].index = i;
    }

    for(int bucket = 1; (bucket - 1) * SIZE + 1 <= n; bucket++){
        nbuckets = bucket;
        int L = (bucket - 1) * SIZE + 1, R = std::min(n, 1LL * bucket * SIZE);

        std::vector <person> W;
        W.clear();
        for(int i = L; i <= R; i++) W.push_back(v[i]);
        std::sort(W.begin(), W.end(), cmp2);
        for(int i = L; i <= R; i++)
            pos[W[i - L].index] = i - (L - 1);

        for(int excluded = L - 1; excluded <= L - 1; excluded++){
            B[bucket].V.push_back(emptyvec);
            for(auto y: W) if(y.index != excluded){
                if(B[bucket].V[excluded - (L - 1)].size() == 0)
                    B[bucket].V[excluded - (L - 1)].push_back(y);
                else if(B[bucket].V[excluded - (L - 1)].back().b != y.b){
                    while(B[bucket].V[excluded - (L - 1)].size() >= 2 &&
                          intersection(y, B[bucket].V[excluded - (L - 1)][B[bucket].V[excluded - (L - 1)].size() - 1]) <=
                             intersection(B[bucket].V[excluded - (L - 1)][B[bucket].V[excluded - (L - 1)].size() - 1],
                                          B[bucket].V[excluded - (L - 1)][B[bucket].V[excluded - (L - 1)].size() - 2]))
                        B[bucket].V[excluded - (L - 1)].pop_back();
                    B[bucket].V[excluded - (L - 1)].push_back(y);
                }
            }
        }
    }

    long long cmax = 0;
    for(int i = 1; i <= n; i++){
        if(v[i].a + (l - 1) * v[i].b > cmax)
            cmax = v[i].a + (l - 1) * v[i].b;
    }
    fprintf(fo,"%lld\n", cmax);

    for(int k = 2; k <= std::min(l, n); k++)
        fprintf(fo,"%lld\n", max(max1(k), max(max2(k), max3(k))));
    for(int k = l + 1; k <= n; k++) fprintf(fo,"0\n");
    return 0;
}
