#include <bits/stdc++.h>

using namespace std;

const int NMAX = 100;

int dx[8] = {-2,-1,1,2,2,1,-1,-2};
int dy[8] = {1,2,2,1,-1,-2,-2,-1};
int N, M, K;
int v[NMAX+2][NMAX+2];
int vecin[NMAX+2][NMAX+2];
vector<pair<int,int>> G[NMAX+2][NMAX+2];
vector<pair<int,int>> libere;
set<pair<int,int>> s_pare, s_impare;
vector<pair<int,int>> pare, impare;

bool bounds(int x, int y)
{
    if( x < 1 || x > N ) return 0;
    if( y < 1 || y > M ) return 0;
    return 1;
}

void afis(const vector<pair<int,int>>& vec)
{
    cout << vec.size() << '\n';
    for( auto el : vec ) {
        cout << el.first - 1 << ' ' << el.second - 1 << '\n';
    }
}

void pune_vec(const vector<pair<int,int>>& vec)
{
    for( auto el : vec ) {
        cout << el.first - 1 << ' ' << el.second - 1 << '\n';
    }
}

void solve_m_2()
{
    bool has_edges = 0;
    for( int i = 1;  i <= N;  ++i ) {
        for( int j = 1;  j <= M;  ++j ) {
            if( !v[i][j] ) continue;
            for( int dir = 0;  dir < 8;  ++dir ) {
                int x = i + dx[dir];
                int y = j + dy[dir];
                if( bounds(x,y) ) {
                    if( v[x][y] ) {
                        has_edges = 1;
                        vecin[i][j] = 1;
                        if( (i + j) % 2 == 0 )
                            s_pare.insert({i, j});
                        else
                            s_impare.insert({i, j});
                    }
                }
            }
        }
    }

    for( auto el : s_pare )
        pare.push_back(el);
    for( auto el : s_impare )
        impare.push_back(el);

    if( !has_edges || K == 0 ) {
        afis(libere);
        return ;
    }
    /// isolated
    vector<pair<int,int>> isolated;
    for( int i = 1;  i <= N;  ++i ) {
        for( int j = 1;  j <= M;  ++j ) {
            if( v[i][j] && !vecin[i][j] )
                isolated.push_back({i, j});
        }
    }
    int start = 0;
    if( impare.size() < pare.size() )
        start = 1;
    int nr_moves = isolated.size() + K * (pare.size() + impare.size()) + min(pare.size(), impare.size());
    cout << nr_moves << '\n';
    pune_vec(isolated);
    for( int i = 1, care = start;  i <= 2*K + 1;  ++i, care = 1 - care ) {
        if( care == 0 )
            pune_vec(pare);
        else
            pune_vec(impare);
    }
}

int main()
{
    cin >> N >> M >> K;
    for( int i = 1;  i <= N;  ++i ) {
        string s;
        cin >> s;
        for( int j = 0;  j < M;  ++j ) {
            v[i][j + 1] = (s[j] == '.');
            if( v[i][j + 1] ) {
                libere.push_back({i, j + 1});
            }
        }
    }


    if( 1 ) {
        solve_m_2();
        return 0;
    }
    return 0;
}

