#include <bits/stdc++.h>
using namespace std;

const int DIM = 105;
const int dx[8] = {-2, -2, -1, 1, 2,  2, 1, -1};
const int dy[8] = {-1,  1,  2, 2, 1, -1, -2, -2};

string str[DIM]; vector<int> edg[DIM * DIM];
vector<pair<int, int> > sol, row[2];
bitset<DIM * DIM> oki;

void dfs(int x, int m) {
    row[(x / m + x % m) % 2].push_back(make_pair(x / m, x % m));
    oki[x] = true;
    for (int y : edg[x]) {
        if (!oki[y]) { dfs(y, m); } } }

int main(void) {
  //  freopen("chess.in", "r", stdin);
  //  freopen("chess.out", "w", stdout);
    int n, m, k; cin >> n >> m >> k; k ++;
    for (int i = 0; i < n; ++i) {
        cin >> str[i]; }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (str[i][j] == '.') {
                bool ok = false;
                for (int d = 0; d < 8; ++d) {
                    int xx = i + dx[d], yy = j + dy[d];
                    if (xx >= 0 && xx < n && yy >= 0 && yy < m && str[xx][yy] == '.') {
                        ok = true; edg[i * m + j].push_back(xx * m + yy); } }
                if (!ok) {
                    sol.push_back(make_pair(i, j));
                    str[i][j] = '#'; } } } }
    for (int i = 0; i < n * m; ++i) {
        int x = i / m, y = i % m;
        if (oki[i] || str[x][y] == '#') { continue; }
        row[0].clear(); row[1].clear(); dfs(i, m);
        if (row[0].size() > row[1].size()) {
            swap(row[0], row[1]); }
        for (int j = 0; j <= k; ++j) {
            for (auto pr : row[j % 2]) {
                sol.push_back(pr); } } }
    cout << sol.size() << "\n";
    for (auto pr : sol) {
        cout << pr.first << " " << pr.second << "\n"; }
    return 0; }

