#include <bits/stdc++.h>

using namespace std;

#define fin cin
#define fout cout
//ifstream fin ("x.in"); ofstream fout ("x.out");

const int nmax = 100 + 5;
const int dl[8] = {-2, -2, 1, 1, 2, 2, -1, -1};
const int dc[8] = {1, -1, 2, -2, 1, -1, 2, -2};

int n, m, k;
bool d[2][nmax + 1][nmax + 1];
string v[nmax + 1];

vector<pair<int, int>> rasp1, rasp2;

void afis (vector<pair<int, int>> &x) {
    fout << x.size() << "\n";
    for (auto i : x)
        fout << i.first << " " << i.second << "\n";
}

void solve (int start, vector<pair<int, int>> &unde) {
    int ind = 1;
    for (int pas = 0; pas < k; ++ pas, ind = 1 - ind, start ^= 1) {
        memset(d[ind], 0, sizeof(d[ind]));

        for (int i = 0; i < n; ++ i)
            for (int j = 0; j < m; ++ j)
                if (d[1 - ind][i][j] == 1)
                    unde.push_back({i, j});

        for (int i = 0; i < n; ++ i) {
            for (int j = 0; j < m; ++ j) {
                for (int dir = 0; dir < 8; ++ dir) {
                    int x = i + dl[dir], y = j + dc[dir];

                    if (!(0 <= x && x < n && 0 <= y && y < m))
                        continue;

                    d[ind][i][j] |= d[1 - ind][x][y];
                }
            }
        }
    }

    ind = 1 - ind;
    for (int i = 0; i < n; ++ i)
        if (d[ind][i][start] == 1)
            unde.push_back({i, start});
}

int main () {
    fin >> n >> m >> k;

    for (int i = 0; i < n; ++ i) {
        fin >> v[i];
    }

    for (int i = 0; i < n; ++ i)
        for (int j = 0; j < m; ++ j) {
            d[0][i][j] = (v[i][j] == '.');
        }


    if (m == 2) {
        solve(0, rasp1);
        solve(1, rasp2);

        if (rasp1.size() > rasp2.size()) {
            afis(rasp2);
        } else {
            afis(rasp1);
        }
    }

    return 0;
}

