#ifndef PARK_H_INCLUDED
#define PARK_H_INCLUDED

#include <vector>
#include "park.h"
bool get_xor(const std::vector<std::pair<int, int>>& edges);
void state_direction(const std::pair<int, int>& edge, bool direction);

void run(int n)
{
    int i=0;
    for(i=2; i<2*n; i+=2)
    {
        state_direction(make_pair(i-1,i), 1);
        state_direction(make_pair(i,i+2), 1);
    }
    state_direction(make_pair(1,2),1);
    state_direction(make_pair(2*n+1,2*n+2),1);
    for(i=2; i<=2*n; i++)
    {
        int x;
        x=get_xor({make_pair(i,i+1)});
        state_direction(make_pair(i,i+1),x);
    }
}

#endif // PARK_H_INCLUDED
