#include <bits/stdc++.h>
using namespace std;

typedef long long i64;

const int NMAX = 200010;
int n;
i64 a[NMAX + 10], b[NMAX + 10];
pair <int, int> ord[NMAX + 10];
i64 sp[NMAX + 10];
i64 b1[NMAX + 10], b2[NMAX + 10];
int poz_in_order[NMAX + 10];

i64 val(int id, int x)
{
    return a[id] + 1LL * x * b[id];
}
pair <i64, i64> best2(int from, int x)
{
    i64 vala = -1, valb = -1;
    for (int i = 1; i <= n; i++) {
        if (poz_in_order[i] <= from)
            continue;
        i64 vali = val(i, x);
        if (vali > vala)
            valb = vala, vala = vali;
        else if (vali > valb)
            valb = vali;
    }
    return { vala, valb };
}

int main()
{
    int l;
    cin >> n >> l;

    for (int i = 1; i <= n; i++) {
        cin >> a[i] >> b[i];
        ord[i] = { a[i], i };
    }

    sort(ord + 1, ord + n + 1, [](const pair <int, int> a, const pair <int, int> b) { return a.first > b.first; });
    for (int i = 1; i <= n; i++)
        poz_in_order[ord[i].second] = i;

    for (int i = 1; i <= n; i++) {
        sp[i] = sp[i - 1] + ord[i].first;
        b1[i] = b1[i - 1], b2[i] = b2[i - 1];
        int p = b[ord[i].second];
        if (p > b1[i])
            b2[i] = b1[i], b1[i] = p;
        else if (p > b2[i])
            b2[i] = p;
    }

    auto x = best2(0, l - 1);
    cout << x.first << '\n';

    for (int i = 2; i <= n; i++) {
        if (i > l) {
            cout << "0\n";
            continue;
        }

        i64 best = 0;

        /// 1 -> ambii sunt din suma
        best = max(best, sp[i] + 1LL * (b1[i] + b2[i]) * (l - i));

        /// 2-> unul e din suma unul dinafara
        auto x = best2(i - 1, l - i);
        best = max(best, sp[i - 1] + 1LL * (l - i) * (b1[i - 1]) + x.first);

        /// 3-> ambii sunt dinafara
        x = best2(i - 2, l - i);
        best = max(best, sp[i - 2] + x.first + x.second);

        cout << best << '\n';
    }

    return 0;
}

