#include <iostream>
#include "park.h"

using namespace std;

const int MAX_N = 1e5 + 10;
const int MAX_V = MAX_N * 2 + 2 + 1;
const int MAX_E = MAX_N * 4 + 1;

int d1[MAX_V];
int d2[MAX_V];




void run(int n) {
  int v = 2 * n + 2;
  for (int i = 1; i <= v; i++)
    d1[i] = d2[i] = -1;
  d1[1] = d1[v - 1] = 1;
  d2[1] = d2[v - 2] = 1;
  d2[0] = 1;
  d2[v - 1] = 1;
  for ( int i = 2; i < v - 1; i++ ) {
    vector<pair<int, int>> x;
    x.push_back({i, i + 1});
    d1[i] = get_xor(x);
  }

  int g = 0;
  while ( !g ) {
    g = 1;
    for ( int i = 1; i <= v - 2; i++ )
      if ( d1[i] == d1[i + 1] && d2[i] == -1 ) {
        g = 0;
        d2[i] = d1[i];
      }

    for ( int i = 2; i <= v - 1; i++ ) {
      int in, out, unk;
      in = out = unk = 0;
      for ( int x : { d1[i], d2[i] } ) {
        if ( x == -1 ) unk++;
        else if ( x == 1 ) out++;
        else in++;
      }
      for ( int x : { d1[i - 1], d2[i - 2] } ) {
        if ( x == -1 ) unk++;
        else if ( x == 0 ) out++;
        else in++;
      }

      if (unk == 1) {
        g = 0;
        int t = (in == 3);
        if ( d1[i] == -1 ) d1[i] = t;
        else if ( d2[i] == -1 ) d2[i] = t;
        else if ( d1[i - 1] == -1 ) d1[i - 1] = !t;
        else if ( d2[i - 2] == -1 ) d2[i - 2] = !t;
      }
    }
  }

  for ( int i = 1; i <= v; i++ ) {
    if ( i < v )
      state_direction({i, i + 1}, d1[i]);
    if ( i < v - 1 )
      state_direction({i, i + 2}, d2[i]);
  }
}
