#include <bits/stdc++.h>

using namespace std;
using nagai = long long;

const int N = 200002;
pair<nagai, nagai> chels[N];
int n, l;

nagai calc(int i, int k)
{
	return chels[i].first + chels[i].second * (l - (k + 1));
}

struct ln
{
	nagai a, b;
	ln(nagai a, nagai b)
		: a(a), b(b)
	{}
	ln()
		: a(0), b(0)
	{}
	nagai calc(nagai x)
	{
		return a + b * x;
	}
};


ln mx1[2 * N], mx2[2 * N];

void add(int v, int l, int r, ln line)
{
	int m = (l + r) / 2;
	nagai c = line.calc(m);
	if (c > mx1[v].calc(m))
	{
		auto m2 = mx2[v];
		mx2[v] = mx1[v];
		mx1[v] = line;
		line = m2;
	}
	else if (c > mx2[v].calc(m))
		swap(line, mx2[v]);
	if (r - l == 1)
		return;
	if (mx2[v].calc(l) > line.calc(l))
		add(v * 2 + 1, m, r, line);
	else
		add(v * 2, l, m, line);
}

vector<ln> lns;

void get(int v, int l, int r, int x)
{
	if (x < l || x >= r)
		return;
	lns.push_back(mx1[v]);
	lns.push_back(mx2[v]);
	if (r - l == 1)
		return;
	int m = (l + r) / 2;
	get(v * 2, l, m, x);
	get(v * 2 + 1, m, r, x);
}

nagai get(nagai k)
{
	lns.clear();
	get(1, 0, n + 1, k);
	nagai ans = 0;
//	for (auto& x : lns)
//		cerr << x.a << ' ' << x.b << ' ' << k << ' ' <<  x.calc(k) << '\n';
	for (auto& x : lns)
		ans = max(ans, x.calc(k));
	return ans;
}


int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> l;
	for (int i = 0; i < n; ++i)
		cin >> chels[i].first >> chels[i].second;
	sort(chels, chels + n);
	reverse(chels, chels + n);
	vector<nagai> prefa(n + 1);
	for (int i = 0; i < n; ++i)
		prefa[i + 1] = prefa[i] + chels[i].first;
	vector<nagai> prem1(n + 1), prem2(n + 1);
	nagai cur1 = -1, cur2 = -1;
	for (int i = 0; i < n; ++i)
	{
//		cerr << chels[i].first << ' ' << chels[i].second << '\n';
		if (chels[i].second > cur1)
			cur2 = cur1, cur1 = chels[i].second;
		else if (chels[i].second > cur2)
			cur2 = chels[i].second;
		prem1[i + 1] = cur1, prem2[i + 1] = cur2;
	}
	vector<nagai> anss(n + 1);
	add(1, 0, n + 1, ln(chels[n - 1].first, chels[n - 1].second));
	for (int k = n; k >= 1; --k)
	{
		nagai c = l - k;
		nagai ans = 0;
		if (k > l)
		{
			add(1, 0, n + 1, ln(chels[k - 2].first, chels[k - 2].second));
			continue;
		}
		if (k == 1)
		{
			for (int i = 0; i < n; ++i)
				ans = max(ans, chels[i].first + c * chels[i].second);
		}
		else
		{
			ans = max(ans, prefa[k] + c * (prem1[k] + prem2[k]));
			nagai kek = get(c);
			ans = max(ans, prefa[k - 1] + kek + prem1[k - 1] * c);
			add(1, 0, n + 1, ln(chels[k - 2].first, chels[k - 2].second));
			lns.clear();
			get(1, 0, n + 1, c);
			vector<nagai> vec;
			for (auto& x : lns)
				vec.push_back(x.calc(c));
			sort(vec.rbegin(), vec.rend());
			ans = max(ans, prefa[k - 2] + vec[0] + vec[1]);
		}
		anss[k] = ans;
	}
	for (int i = 1; i <= n; ++i)
		cout << anss[i] << '\n';
}

