#include "park.h"
#include <bits/stdc++.h>


using namespace std;
using nagai = long long;

/*

bool get_xor(const std::vector<std::pair<int, int>>& edges);

void state_direction(const std::pair<int, int>& edge, bool direction)

*/

int n;
int myget(vector<pair<int, int>> edg)
{
	int ansich = 0;
	vector<pair<int, int>> e;
	for (auto& x : edg)
	{
		if (x.first >= 2 * n || x.second >= 2 * n)
			ansich ^= 1;
		else
		{
			x.first++, x.second++;
			e.push_back(x);
		}
	}
	return ansich ^ get_xor(e);
}


int getedge(int a, int b)
{
	auto edg = make_pair(a, b);
	if (edg.first == 0 || edg.second == 0)
		return 1;
	if (edg.first == 2 * n - 1 || edg.second == 2 * n - 1)
		return 1;
	return myget({edg});
}

void state_dir(pair<int, int> edge, bool dir)
{
	++edge.first, ++edge.second;
	state_direction(edge, dir);
}

const int N = 200010;

vector<int> g[N];

int curt = N;
int t[N];

void ts(int u)
{
	if (t[u] != 0)
		return;
	for (int v : g[u])
		ts(v);
	t[u] = curt--;
}

void run(int N)
{
	n = N;
	++n;
	int up = 2, down = 1;
	auto proc = [&](int a, int b)
	{
		int mem = myget({make_pair(a, b)});
		if (mem && a < b || !mem && a > b)
		{
			g[a].push_back(b);
			return true;
		}
		else
		{
			g[b].push_back(a);
			return false;
		}
	};
	while (up < 2 * n && down < 2 * n)
	{
		if (down == up + 1)
		{
			vector<pair<int, int>> que = {make_pair(up, down), make_pair(down, up + 2)};
			int mem = myget(que);
			if (mem == 0)
			{
				g[up].push_back(down);
				up += 2;
			}
			else
			{
				if (getedge(up, down))
				{
					g[up].push_back(down);
					g[up + 2].push_back(down);
					up += 4, down += 2;
				}
				else
				{
					g[down].push_back(up);
					g[down].push_back(up + 2);
					up += 2, down += 2;
				}
			}
		}
		else if (up == down + 1)
		{
			vector<pair<int, int>> que = {make_pair(down, up), make_pair(up, down + 2)};
			int mem = myget(que);
			if (mem == 0)
			{
				g[down].push_back(up);
				g[up].push_back(down + 2);
				up += 2;
				down += 2;
			}
			else
			{
				int kek = getedge(down, up);
				if (kek)
				{
					g[down].push_back(up);
					g[down + 2].push_back(up);
					up += 2;
					down += 4;
				}
				else
				{
					g[up].push_back(down);
					g[up].push_back(down + 2);
					up += 2;
					down += 2;
				}
			}
		}
		else
		{
			if (up < down)
				up += 2;
			else
				down += 2;
		}
	}
	g[0].push_back(1);
	g[2 * n - 2].push_back(2 * n);
	for (int i = 0; i < n - 1; ++i)
	{
		g[2 * i].push_back(2 * i + 2);
		g[2 * i + 1].push_back(2 * i + 3);
	}
	for (int i = 0; i < 2 * n; ++i)
		ts(i);
	vector<pair<int, int>> edgs;
	for (int i = 0; i < n; ++i)
	{
		edgs.emplace_back(2 * i, 2 * i + 1);
		edgs.emplace_back(2 * i, 2 * i + 2);
		edgs.emplace_back(2 * i + 1, 2 * i + 2);
		edgs.emplace_back(2 * i + 1, 2 * i + 3);
	}
	for (auto& x : edgs)
	{
		if (x.first < 2 * n && x.second < 2 * n)
		{
			if (t[x.first] < t[x.second])
				state_dir(x, 1);
			else
				state_dir(x, 0);
		}
	}
}
