#include <bits/stdc++.h>
#include "park.h"

using namespace std;

void dfs(int v, vector <bool> &u, vector <vector <int> > &g, vector <int> &t)
{
	if (u[v])
	{
		return;
	}
	u[v] = true;
	for (int to : g[v])
	{
		if (!u[to])
		{
			dfs(to, u, g, t);
		}
	}
	t.push_back(v);
}

void run(int n)
{
	int v = 2 * n + 2;
	vector <int> in_deg(v + 1), out_deg(v + 1);
	map <pair <int, int>, int> ans;
	vector <vector <int> > g(v + 1);
	for (int i = 1; i + 1 <= v; i++)
	{
		vector <pair <int, int> > e;
		if (i + 1 <= v)
		{
			e.push_back({i, i + 1});
		}
		if (i + 2 <= v)
		{
			e.push_back({i, i + 2});
		}
		if (i == 1)
		{
			for (auto c : e)
			{
				g[c.first].push_back(c.second);
				in_deg[c.second]++;
				out_deg[c.first]++;
			}
		}
		else
		{
			if (!in_deg[i])
			{
				vector <pair <int, int> > f;
				f.push_back(e[0]);
				int rt = (e[0].second == v ? 1 : get_xor(f));
				if (rt == 1)
				{
					out_deg[e[0].first]++;
					in_deg[e[0].second]++;
					out_deg[e[1].second]++;
					in_deg[e[1].first]++;
					g[e[0].first].push_back(e[0].second);
					g[e[1].second].push_back(e[1].first);
				}
				else
				{
					out_deg[e[0].second]++;
					in_deg[e[0].first]++;
					g[e[0].second].push_back(e[0].first);
				}
			}
			else if (!out_deg[i])
			{
				vector <pair <int, int> > f;
				f.push_back(e[0]);
				int rt = (e[0].second == v ? 1 : get_xor(f));
				if (rt == 1)
				{
					out_deg[e[0].first]++;
					in_deg[e[0].second]++;
					g[e[0].first].push_back(e[0].second);
				}
				else
				{
					out_deg[e[0].second]++;
					in_deg[e[0].first]++;
					out_deg[e[1].first]++;
					in_deg[e[1].second]++;
					g[e[0].second].push_back(e[0].first);
					g[e[1].first].push_back(e[1].second);
				}
			}
		}
	}
	vector <bool> u(v + 1);
	vector <int> t;
	for (int i = 1; i <= v; i++)
	{
		dfs(i, u, g, t);
	}
	reverse(t.begin(), t.end());
	vector <int> ind(v + 1);
	for (int i = 0; i < (int) t.size(); i++) ind[t[i]] = i;
	for (int i = 1; i <= v; i++)
	{
		vector <pair <int, int> > e;
		if (i + 1 <= v)
		{
			e.push_back({i, i + 1});
		}
		if (i + 2 <= v)
		{
			e.push_back({i, i + 2});
		}
		for (auto c : e)
		{
			state_direction(c, (ind[c.first] < ind[c.second]));
		}
	}
}
