#include <bits/stdc++.h>

using namespace std;

char s[100][100];

struct state
{
	int x, y, mvs;
};

bool operator < (const state &a, const state &b)
{
	if (a.x != b.x) return a.x < b.x;
	if (a.y != b.y) return a.y < b.y;
	return a.mvs < b.mvs;
}

bool operator == (const state &a, const state &b)
{
	return (a.x == b.x && a.y == b.y && a.mvs == b.mvs);
}

int dx[] = {-1, 1, -1, 1, -2, 2, -2, 2};
int dy[] = {2, -2, -2, 2, -1, 1, 1, -1};

int n, m;

int k;

vector <state> move(const vector <state> &e, int x, int y)
{
	vector <state> go;
	for (auto c : e)
	{
		if (c.x != x || c.y != y)
		{
			go.push_back(c);
			if (c.mvs + 1 <= k)
			{
				for (int t = 0; t < 8; t++)
				{
					if (c.x + dx[t] >= 0 && c.x + dx[t] < n && c.y + dy[t] >= 0 && c.y + dy[t] < m)
					{
						go.push_back({c.x + dx[t], c.y + dy[t], c.mvs + 1});
					}
				}
			}
		}
	}
	sort(go.begin(), go.end());
	vector <state> mv;
	for (int i = 0; i < (int) go.size(); i++)
	{
		if (mv.empty() || mv.back().x != go[i].x || mv.back().y != go[i].y)
		{
			mv.push_back(go[i]);
		}
	}
	int ret = 0;
	go = mv;
	return go;
}

map <vector <state>, int> kek;
map <vector <state>, vector <pair <int, int> > > d;
vector <pair <int, int> > p;

void rec(vector <state> me, int dist)
{
	if (kek.count(me) && kek[me] <= dist) return;
	d[me] = p;
	kek[me] = dist;
	if (me.empty()) return;
	for (int x = 0; x < n; x++)
	{
		for (int y = 0; y < m; y++)
		{
			p.push_back({x, y});
			auto lul = move(me, x, y);
			rec(lul, dist + 1);
			p.pop_back();
		}
	}
}

int main()
{
#ifdef ONPC
	freopen("a.in", "r", stdin);
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m, k;
	cin >> n >> m >> k;
	vector <pair <int, int> > ans;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			cin >> s[i][j];
			if (s[i][j] != '#')
			{
				ans.push_back({i, j});
				int x = i - 2;
				int y = j ^ 1;
				vector <pair <int, int> > mem;
				mem.push_back({i, j});
				mem.push_back({x, y});
				if (x >= 0 && s[x][y] != '#')
				{
					int cur = 1;
					for (int it = 0; it < k; it++)
					{
						ans.push_back({mem[cur].first, mem[cur].second});
						cur ^= 1;
					}
				}
			}
		}
	}
	cout << ans.size() << '\n';
	for (auto c : ans)
	{
		cout << c.first << ' ' << c.second << '\n';
	}
	/*
	for (n = 1; n <= 10; n++)
	{
		m = 2;
		k = 3;
		kek.clear();
		vector <state> res;
		for (int i = 0; i < n; i++)
		{
			for (int j = 0; j < m; j++)
			{
				res.push_back({i, j, 0});
			}
		}
		rec(res, 0);
		cout << kek[{}] << endl;
		for (auto c : d[{}])
		{
			cout << c.first << ' ' << c.second << '\n';
		}
	}
	return 0;
	*/
	/*
	int n = 100, m = 100, k = 100;
	//cin >> n >> m >> k;
	vector <state> e;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			//cin >> s[i][j];
			if (s[i][j] == '.')
			{
				e.push_back({i, j, 0});
			}
		}
	}
	vector <pair <int, int> > ans;
	while (e.size() > 0)
	{
		int cx = -1, cy = -1;
		int sum = -1;
		vector <state> best;
		int mem = k;
		for (auto c : e) mem = min(mem, c.mvs);
		for (auto c : e)
		{
			if (c.mvs != mem) continue;
			int x = c.x, y = c.y;
			vector <state> go;
			for (auto c : e)
			{
				if (c.x != x || c.y != y)
				{
					go.push_back(c);
					if (c.mvs + 1 <= k)
					{
						for (int t = 0; t < 8; t++)
						{
							if (c.x + dx[t] >= 0 && c.x + dx[t] < n && c.y + dy[t] >= 0 && c.y + dy[t] < m && s[c.x + dx[t]][c.y + dy[t]] == '.')
							{
								go.push_back({c.x + dx[t], c.y + dy[t], c.mvs + 1});
							}
						}
					}
				}
			}
			sort(go.begin(), go.end());
			vector <state> mv;
			for (int i = 0; i < (int) go.size(); i++)
			{
				if (mv.empty() || mv.back().x != go[i].x || mv.back().y != go[i].y)
				{
					mv.push_back(go[i]);
				}
			}
			int ret = 0;
			go = mv;
			for (auto c : go) ret += k - c.mvs + 1;
			if (sum == -1 || ret < sum)
			{
				best = go;
				sum = ret;
				cx = x, cy = y;
			}
		}
		ans.push_back({cx, cy});
		e = best;
	}
	cout << ans.size() << '\n';
	for (auto c : ans)
	{
		cout << c.first << ' ' << c.second << '\n';
	}
*/
}
