#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse", "sse2", "sse3", "sse4")
#define x first
#define y second 
#define pb push_back
#define mp make_pair
using namespace std;

typedef long long ll;
typedef pair<int, int> point;

template<typename T1, typename T2> inline void chkmin(T1 &x, const T2 &y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 &x, const T2 &y) {if (x < y) x = y;}

template<typename T1, typename T2>
istream &operator >> (istream &_in, pair<T1, T2> &a) {
	_in >> a.x >> a.y;
	return _in;
}

template<typename T1, typename T2>
ostream &operator << (ostream &_out, pair<T1, T2> &a) {
	_out << a.x << ' ' << a.y;
	return _out;
}

template<typename T> 
istream &operator >> (istream &_in, vector<T> &a) {
	for (auto &i : a) _in >> i; 
	return _in;
}


template<typename T> 
ostream &operator << (ostream &_out, vector<T> &a) {
	bool OK = false;
	for (auto &i : a) {
		if (OK) _out << ' ';
		else OK = true;
	 	_out << i; 
	}
	return _out;
}

int readInt() {
	int v = 0;
	char c = getchar_unlocked();
	while ('0' <= c && c <= '9') {
		v = (v << 3) + (v << 1) + c - '0';
		c = getchar_unlocked();
	}
	return v;
}

void writeString(const string &s) {
	for (char c : s) {
		putchar_unlocked(c);
	}
}

void writeInt(int v) {
	writeString(to_string(v));
}


int n, m, k;

bool in(int x, int y) {
	return 0 <= x && x < n && 0 <= y && y < m;
}	
 
const int dx[8] = {-2, -2, -1, 1, 2, 2, 1, -1};
const int dy[8] = {-1, 1, 2, 2, 1, -1, -2, -2};

int r[101][101];

vector<pair<int, int>> w[102][9];
vector<pair<int, int>> ans;

int main() {
	ios::sync_with_stdio(false);
	cin >> n >> m >> k;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			char c;
			cin >> c;
			if (c == '#') {
				r[i][j] = k + 1;
			} else {
				w[0][8].pb({i, j});
			}
		}
	}
	for (int tk = 0; tk <= k; ++tk) {
		for (int t = 9; t--;) {
			// cout << tk << ' ' << t << endl;
			for (auto i : w[tk][t]) {
				int cnt = 0, val = k + 1;
				for (int j = 0; j < 8; ++j) {
					point a = {i.x + dx[j], i.y + dy[j]};
					if (in(a.x, a.y) && r[a.x][a.y] <= k) {
						++cnt;
						chkmin(val, r[a.x][a.y]);
					} 
				}
				if (cnt == t) {
					ans.pb(i);
					// cout << val << "?" << endl;
					r[i.x][i.y] = val + 1;
					w[val + 1][cnt].pb(i);
				} else {
					w[tk][cnt].pb(i);
				}
			}
			w[tk][t].clear();
			w[tk][t].shrink_to_fit();
		}
	}
	cout << ans.size() << '\n';
	for (auto i : ans) {
		cout << i << '\n';
	}
}