#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse", "sse2", "sse3", "sse4")
#define x first
#define y second 
#define mp make_pair
using namespace std;

typedef long long ll;
typedef pair<int, int> point;

template<typename T1, typename T2> inline void chkmin(T1 &x, const T2 &y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 &x, const T2 &y) {if (x < y) x = y;}

template<typename T1, typename T2>
istream &operator >> (istream &_in, pair<T1, T2> &a) {
	_in >> a.x >> a.y;
	return _in;
}

template<typename T1, typename T2>
ostream &operator << (ostream &_out, pair<T1, T2> &a) {
	_out >> a.x >> a.y;
	return _out;
}

template<typename T> 
istream &operator >> (istream &_in, vector<T> &a) {
	for (auto &i : a) _in >> i; 
	return _in;
}


template<typename T> 
ostream &operator << (ostream &_out, vector<T> &a) {
	bool OK = false;
	for (auto &i : a) {
		if (OK) cout << ' ';
		else OK = true;
	 	_out << i; 
	}
	return _out;
}

int readInt() {
	int v = 0;
	char c = getchar_unlocked();
	while ('0' <= c && c <= '9') {
		v = (v << 3) + (v << 1) + c - '0';
		c = getchar_unlocked();
	}
	return v;
}

void writeString(const string &s) {
	for (char c : s) {
		putchar_unlocked(c);
	}
}

void writeInt(int v) {
	writeString(to_string(v));
}

int n, L;
vector<int> a, b;
long long dp[201][201][3][2];
long long ndp[201][201][3][2];
int cnt;
long long sum = 0;

void clr() {
	for (int i = 0; i <= n; ++i) {
		for (int j = 0; j <= n; ++j) {
			for (int t1 = 0; t1 < 2; ++t1) {
				for (int t = 0; t < 3; ++t) {
					for (int k = 0; k < 2; ++k) {
						dp[i][j][t][k] = -1e18;
					}
				}
			}
		}
	}
}

void rev() {
	for (int i = 0; i <= n; ++i) {
		for (int j = 0; j <= n; ++j) {
			for (int t = 0; t < 3; ++t) {
				for (int k = 0; k < 2; ++k) {
					ndp[i][j][t][k] = dp[i][j][t][k];
				}
			}
		}
	}
}

long long ans[201];

int main() {
	ios::sync_with_stdio(false);
	cin >> n >> L;
	if (L == 1) {
		int ans = 0;
		for (int i = 0; i < n; ++i) {
			int a, b;
			cin >> a >> b;
			chkmax(ans, a);
		}
		cout << ans << '\n';
		for (int i = 1; i < n; ++i) {
			cout << '0' << endl;
		}
		return 0;
	}
	a.resize(n);
	b.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i] >> b[i];
	}
	clr();
	dp[0][0][0][0] = 0;
	for (int i = 0; i < n; ++i) {
		rev();
		clr();
		for (int len = 0; len <= n; ++len) {
			for (int cnt = 0; cnt <= n; ++cnt) {
				for (int t = 0; t < 3; ++t) {
					for (int k = 0; k < 2; ++k) {
						if (ndp[len][cnt][t][k] < 0) continue; 
						if (t != 2) {
							chkmax(dp[len + 1][cnt][t + 1][k], ndp[len][cnt][t][k] + a[i] + b[i]);
						}
						if (k != 1) {
							chkmax(dp[len][cnt + 1][t][k + 1], ndp[len][cnt][t][k] + a[i] + b[i]);
						}
						chkmax(dp[len][cnt + 1][t][k], ndp[len][cnt][t][k] + a[i] + b[i] * 2);
						chkmax(dp[len + 1][cnt][t][k], ndp[len][cnt][t][k] + a[i]);
						chkmax(dp[len][cnt][t][k], ndp[len][cnt][t][k]);
					}
				}
			}
		}
		// for (int len = 0; len <= n; ++len) {
		// 	for (int cnt = 0; cnt <= n; ++cnt) {
		// 		for (int t = 0; t < 3; ++t) {
		// 			if (dp[len][cnt][t] < 0) continue; 
		// 			cout << len << ' ' << cnt << ' ' << t << ' ' << dp[len][cnt][t] << endl;
		// 		}
		// 	}
		// }
		// cout << "_____" << endl;
	}
	// for (int len = 0; len <= n; ++len) {
	// 	for (int cnt = 0; cnt <= n; ++cnt) {
	// 		for (int t = 0; t < 3; ++t) {
	// 			if (dp[len][cnt][t] < 0) continue; 
	// 			cout << len << ' ' << cnt << ' ' << t << ' ' << dp[len][cnt][t] << endl;
	// 		}
	// 	}
	// }
	// cout << dp[1][0][1][1] << endl;
	for (int i = 1; i <= n; ++i) {
		for (int len = 0; len <= n; ++len) {
			for (int k = 0; k < 2; ++k) {
				int cnt = i - len;
				int length = (cnt + 1) * 2 + len - 1;
				if (length + 1 <= L + k) {
					// cout << dp[len][cnt][2][k] << ' ' << len << ' ' << cnt << ' ' << 2 << ' ' << k << endl;
					chkmax(ans[i], dp[len][cnt][2][k]);
				}
				if (length <= L + k) {
					chkmax(ans[i], dp[len][cnt][1][k]);
				}
				if (len == 0 && cnt * 2 + 1 <= L + k) {
					chkmax(ans[i], dp[0][cnt][0][k]);
				}
			}
		}
		if (i == L) {
			ans[i] = dp[i][0][0][0];
		}
		cout << ans[i] << '\n';
	}

}