#include <bits/stdc++.h>
#include "park.h"
#pragma GCC optimize("Ofast")
#pragma GCC target("sse", "sse2", "sse3", "sse4")
#define x first
#define y second 
#define mp make_pair
#define pb push_back
using namespace std;

typedef long long ll;
typedef pair<int, int> point;

template<typename T1, typename T2> inline void chkmin(T1 &x, const T2 &y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 &x, const T2 &y) {if (x < y) x = y;}

template<typename T1, typename T2>
istream &operator >> (istream &_in, pair<T1, T2> &a) {
	_in >> a.x >> a.y;
	return _in;
}

template<typename T1, typename T2>
ostream &operator << (ostream &_out, pair<T1, T2> &a) {
	_out << a.x << " " << a.y;
	return _out;
}

template<typename T> 
istream &operator >> (istream &_in, vector<T> &a) {
	for (auto &i : a) _in >> i; 
	return _in;
}


template<typename T> 
ostream &operator << (ostream &_out, vector<T> &a) {
	bool OK = false;
	for (auto &i : a) {
		if (OK) cout << ' ';
		else OK = true;
	 	_out << i; 
	}
	return _out;
}

int readInt() {
	int v = 0;
	char c = getchar_unlocked();
	while ('0' <= c && c <= '9') {
		v = (v << 3) + (v << 1) + c - '0';
		c = getchar_unlocked();
	}
	return v;
}

void writeString(const string &s) {
	for (char c : s) {
		putchar_unlocked(c);
	}
}

void writeInt(int v) {
	writeString(to_string(v));
}

const int N = 3e5 + 1;

vector<pair<int, int>> my_edge;
vector<int> edge[N];
int w[N];
int cnt = 1;
int clr[N];

bool dfs(int i, int h = 0) {
	if (clr[i] == cnt + 1) return false;
	if (clr[i] == cnt) return true;
	if (h > 20) return false;
	clr[i] = cnt;
	for (int j : edge[i]) {
		if (dfs(j, h + 1)) return true;
	}
	clr[i] = cnt + 1;
	return false;
}

void _state_direction(point a, bool v) {
	state_direction(a, v);
	if (v) {
		edge[a.x].pb(a.y);
	} else {
		edge[a.y].pb(a.x);
	}
}

void run(int n) {
	++n;
	int k = n * 2;
	for (int i = 0; i < k; i += 2) {
		if (i == 1) _state_direction({1, 2}, 1); 
		else if (i + 2 == n * 2) _state_direction({i + 1, i + 2}, 1);
		else my_edge.pb({i + 1, i + 2});
		if (i + 2 < k) {
			my_edge.pb({i + 1, i + 3});
			my_edge.pb({i + 2, i + 3});
			if (i + 4 != n * 2) my_edge.pb({i + 2, i + 4});
			else _state_direction({i + 2, i + 4}, 1);
		}
	}
	while (my_edge.size()) {
		bool OK = false;
		for (int i = my_edge.size(); i--;) {
			auto e = my_edge[i];
			if (abs(my_edge.size() - i) > 5) break;
			int lstv = e.y + 1;
			bool can1 = true, can2 = true;
			++w[e.x];
			++w[e.y];
			for (int t = 0; t < 2; ++t) {
				edge[e.x].pb(e.y);
				for (int i = min(e.x, e.y); i < e.x + 15 && i < k; ++i) {
					if (i == k - 1 || i == 2) {
						if (w[i] == 3 && edge[i].size() == 0 || edge[i].size() == 3) {
							can1 = false;
							break;
						}
					} else {
						if (w[i] == 4 && edge[i].size() == 0 || edge[i].size() == 4) {
							can1 = false;
							break;
						}
					} 
				}
				cnt += 2;
				if (can1 && dfs(e.x)) {
					can1 = false;
				}
				edge[e.x].pop_back();
				swap(can1, can2);
				swap(e.x, e.y);
			}
			if (can1 && can2) {
				--w[e.x];
				--w[e.y];
				continue;
			}
			if (can1) {
				_state_direction(e, 1);
			} else {
				_state_direction(e, 0);
			}
			swap(my_edge[i], my_edge.back());
			my_edge.pop_back();
			break;
		}
		if (!OK) {
			auto e = my_edge.back();
			my_edge.pop_back();
			++w[e.x];
			++w[e.y];
			if (get_xor({e})) {
				_state_direction(e, 1);
			} else {
				_state_direction(e, 0);
			}
		} 	
	}
}

// void run(int n) {
// 	int k = n * 2;
// 	for (int i = 0; i < k; i += 2) {
// 		if (i == 1) state_direction({1, 2}, 1); 
// 		else if (i + 2 == n * 2) state_direction({i + 1, i + 2}, 1);
// 		else my_edge.pb({i + 1, i + 2});
// 		if (i + 2 < k) {
// 			my_edge.pb({i + 1, i + 3});
// 			my_edge.pb({i + 2, i + 3});
// 			if (i + 4 != n * 2) my_edge.pb({i + 2, i + 4});
// 			else state_direction({i + 2, i + 4}, 1);
// 		}
// 	}
// 	int m = 10;
// 	while (my_edge.size()) {
// 		int lst = my_edge.size();
// 		--lst;
// 		chkmin(m, my_edge.size());  
// 		vector<int> cool_masks;
// 		vector<int> cur;
// 		for (int i = 0; i < (1 << m); ++i) {
// 			for (int j = 0; j < m; ++j) {
// 				if (cur.size() == 0) {
// 					cur.pb(my_edge[lst - j].x);
// 					cur.pb(my_edge[lst - j].y);	
// 				}
// 				if ((i >> j) & 1) {
// 					edge[my_edge[lst - j].x].pb(my_edge[lst - j].y);
// 				} else {
// 					edge[my_edge[lst - j].y].pb(my_edge[lst - j].x);
// 				}
// 			}
// 		}
// 		bool OK = true;
// 		for (auto i : cur) {
// 			if (i > 2 && i < k - 1) {
// 				if (edge[i].size() == 0 || edge[i].size() == 4) {
// 					OK = false;
// 				}
// 			} else {

// 			}
// 		}
// 	}

// }