#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse", "sse2", "sse3", "sse4")
#define x first
#define y second 
#define mp make_pair
using namespace std;

typedef long long ll;
typedef pair<int, int> point;

template<typename T1, typename T2> inline void chkmin(T1 &x, const T2 &y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 &x, const T2 &y) {if (x < y) x = y;}

template<typename T1, typename T2>
istream &operator >> (istream &_in, pair<T1, T2> &a) {
	_in >> a.x >> a.y;
	return _in;
}

template<typename T1, typename T2>
ostream &operator << (ostream &_out, pair<T1, T2> &a) {
	_out >> a.x >> a.y;
	return _out;
}

template<typename T> 
istream &operator >> (istream &_in, vector<T> &a) {
	for (auto &i : a) _in >> i; 
	return _in;
}


template<typename T> 
ostream &operator << (ostream &_out, vector<T> &a) {
	bool OK = false;
	for (auto &i : a) {
		if (OK) cout << ' ';
		else OK = true;
	 	_out << i; 
	}
	return _out;
}

int readInt() {
	int v = 0;
	char c = getchar_unlocked();
	while ('0' <= c && c <= '9') {
		v = (v << 3) + (v << 1) + c - '0';
		c = getchar_unlocked();
	}
	return v;
}

void writeString(const string &s) {
	for (char c : s) {
		putchar_unlocked(c);
	}
}

void writeInt(int v) {
	writeString(to_string(v));
}

int n, L;
vector<int> a, b;
int cnt;
long long sum = 0;
long long ans[100001];


int main() {
	ios::sync_with_stdio(false);
	cin >> n >> L;
	if (L == 1) {
		int ans = 0;
		for (int i = 0; i < n; ++i) {
			int a, b;
			cin >> a >> b;
			chkmax(ans, a);
		}
		cout << ans << '\n';
		for (int i = 1; i < n; ++i) {
			cout << '0' << endl;
		}
		return 0;
	}
	a.resize(n);
	b.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i] >> b[i];
	}
	vector<pair<int, int>> arr;
	for (int i = 0; i < n; ++i) {
		arr.push_back({a[i], i});
	}
	sort(arr.rbegin(), arr.rend());
	for (int i = 0; i < n; ++i) {
		chkmax(ans[1], 1LL * b[i] * (L - 1) + a[i]);
		for (int j = i + 1; j < n; ++j) {
			long long cur = 0;
			int L = 0;
							// cout << i << ' ' << j << ' ' << n << ' ' << L << endl;

			for (int len = 2; len <= n && len <= ::L; ++len) {
				// cout << i << ' ' << j << ' '<< a[i] << ' ' << ' ' << cur << endl;
				chkmax(ans[len], a[i] + a[j] + 1LL * (b[i] + b[j]) * (::L - len) + cur);
				if (len == n || len == L) break;
				while (arr[L].y == i || arr[L].y == j) {
					++L;
				}
				cur += arr[L].x;
				++L;
			}
		}
	}
	for (int i = 1; i <= n; ++i) {
		cout << ans[i] << '\n';
	}
}