#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse", "sse2", "sse3", "sse4")
#define x first
#define y second 
#define mp make_pair
using namespace std;

typedef long long ll;
typedef pair<int, int> point;

template<typename T1, typename T2> inline void chkmin(T1 &x, const T2 &y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 &x, const T2 &y) {if (x < y) x = y;}

template<typename T1, typename T2>
istream &operator >> (istream &_in, pair<T1, T2> &a) {
	_in >> a.x >> a.y;
	return _in;
}

template<typename T1, typename T2>
ostream &operator << (ostream &_out, pair<T1, T2> &a) {
	_out >> a.x >> a.y;
	return _out;
}

template<typename T> 
istream &operator >> (istream &_in, vector<T> &a) {
	for (auto &i : a) _in >> i; 
	return _in;
}


template<typename T> 
ostream &operator << (ostream &_out, vector<T> &a) {
	bool OK = false;
	for (auto &i : a) {
		if (OK) cout << ' ';
		else OK = true;
	 	_out << i; 
	}
	return _out;
}

int readInt() {
	int v = 0;
	char c = getchar_unlocked();
	while ('0' <= c && c <= '9') {
		v = (v << 3) + (v << 1) + c - '0';
		c = getchar_unlocked();
	}
	return v;
}

void writeString(const string &s) {
	for (char c : s) {
		putchar_unlocked(c);
	}
}

void writeInt(long long v) {
	writeString(to_string(v));
}

int n, L;
vector<int> a, b;
int cnt;
long long sum = 0;
long long ans[100001];


int main() {
	ios::sync_with_stdio(false);
	n = readInt();
	L = readInt();
	a.resize(n);
	b.resize(n);
	for (int i = 0; i < n; ++i) {
		a[i] = readInt();
		b[i] = readInt();
	}
	vector<pair<int, int>> arr;
	for (int i = 0; i < n; ++i) {
		arr.push_back({a[i], i});
		chkmax(ans[1], 1LL * (::L - 1) * b[i] + a[i]);
	}
	sort(arr.rbegin(), arr.rend());
	long long cur = 0;
	for (int len = 2; len <= n && len <= L; ++len) {
		long long nans = 0;
		long long a1 = -2e18, a2 = -2e18;
		for (int j = len - 2; j < n; ++j) {
			long long v = (L - len) * b[arr[j].y] + a[arr[j].y];
			if (a2 < v) {
				a2 = v;
				if (a1 < a2) {
					swap(a1, a2);
				}
			}
		}
		// cout << len << ":" << cur << ' ' << a1 << ' ' << a2 << endl;
		chkmax(nans, cur + a1 + a2);
		long long f = (L - len) * b[arr[len - 2].y] + a[arr[len - 2].y];
		long long a3 = -2e18, a4 = -2e18;
		for (int j = 0; j <= len - 2; ++j) {
			long long v = (L - len) * b[arr[j].y];
			if (a4 < v) {
				a4 = v;
				if (a3 < a4) {
					swap(a3, a4);
				}
			}
		}
		if (f == a1) a1 = a2;
		cur += arr[len - 2].x; 
		chkmax(nans, cur + a1 + a3);
		chkmax(nans, cur + arr[len - 1].x + a3 + a4);
		chkmax(ans[len], nans);
		// cout << len << ":" << cur << ' ' << a1 << ' ' << a2 << ' ' << a3 << ' ' << a4 << endl;
	}
	for (int i = 1; i <= n; ++i) {
		writeInt(ans[i]);
		putchar_unlocked('\n');
	}
}