#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse", "sse2", "sse3", "sse4")
#define x first
#define y second 
#define pb push_back
#define mp make_pair
using namespace std;

typedef long long ll;
typedef pair<int, int> point;

template<typename T1, typename T2> inline void chkmin(T1 &x, const T2 &y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 &x, const T2 &y) {if (x < y) x = y;}

template<typename T1, typename T2>
istream &operator >> (istream &_in, pair<T1, T2> &a) {
	_in >> a.x >> a.y;
	return _in;
}

template<typename T1, typename T2>
ostream &operator << (ostream &_out, pair<T1, T2> &a) {
	_out << a.x << ' ' << a.y;
	return _out;
}

template<typename T> 
istream &operator >> (istream &_in, vector<T> &a) {
	for (auto &i : a) _in >> i; 
	return _in;
}


template<typename T> 
ostream &operator << (ostream &_out, vector<T> &a) {
	bool OK = false;
	for (auto &i : a) {
		if (OK) _out << ' ';
		else OK = true;
	 	_out << i; 
	}
	return _out;
}

int readInt() {
	int v = 0;
	char c = getchar_unlocked();
	while ('0' <= c && c <= '9') {
		v = (v << 3) + (v << 1) + c - '0';
		c = getchar_unlocked();
	}
	return v;
}

void writeString(const string &s) {
	for (char c : s) {
		putchar_unlocked(c);
	}
}

void writeInt(int v) {
	writeString(to_string(v));
}


int n, m, k;

bool in(int x, int y) {
	return 0 <= x && x < n && 0 <= y && y < m;
}	
 
const int dx[8] = {-2, -2, -1, 1, 2, 2, 1, -1};
const int dy[8] = {-1, 1, 2, 2, 1, -1, -2, -2};

int r[101][101];

bool used[101][101];

vector<point> elem;
vector<point> ans;

bool shoot(point i) {
	int val = k;
	for (int j = 0; j < 8; ++j) {
		point a = {i.x + dx[j], i.y + dy[j]};
		if (in(a.x, a.y) && r[a.x][a.y] <= k) {
			chkmin(val, r[a.x][a.y]);
		} 
	}
	if (r[i.x][i.y] < val + 1) {
		elem.pb(i);
		r[i.x][i.y] = val + 1;
		return true;
	} else {
		return false;
	}
}

vector<pair<int, int>> all;
vector<pair<int, int>> who[2];

void dfs(int i, int j) {
	if (!in(i, j)) return;
	if (used[i][j] || r[i][j]) return;
	who[(i + j) & 1].pb({i, j});
	all.pb({i, j});
	used[i][j] = true;
	for (int d = 0; d < 8; ++d) {
		dfs(i + dx[d], j + dy[d]);
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin >> n >> m >> k;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			char c;
			cin >> c;
			if (c == '#') {
				r[i][j] = k + 1;
			}
		}
	} 
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			who[0].clear();
			who[1].clear();
			all.clear();
			dfs(i, j);
			if (who[0].size() || who[1].size()) {
				vector<point> rep[2];
				if (k & 1) {
					for (int t = 0; t < 2; ++t) {
						bool chg = true;
						while (chg) {
							chg = false;
							for (auto i : who[1]) {
								chg |= shoot(i);
							}
							for (auto i : who[0]) {
								chg |= shoot(i);
							}
						}
						rep[t] = elem;
						elem.clear();
						swap(who[0], who[1]);
						for (auto i : who[0]) r[i.x][i.y] = 0;
						for (auto i : who[1]) r[i.x][i.y] = 0;
					}
					if (rep[0].size() < rep[1].size()) {
						swap(rep[0], rep[1]);
					}
					for (auto i : rep[1]) ans.pb(i);
				} else {
					for (int t = 0; t < 2; ++t) {
						bool chg = true;
						while (chg) {
							if (abs(r[all[0].x][all[0].y] - k) < 1) {
								for (auto i : all) {
									shoot(i);
								}
							}
							chg = false;
							for (auto i : who[1]) {
								chg |= shoot(i);
							}
							for (auto i : who[0]) {
								chg |= shoot(i);
							}
						}
						rep[t] = elem;
						elem.clear();
						swap(who[0], who[1]);
						for (auto i : who[0]) r[i.x][i.y] = 0;
						for (auto i : who[1]) r[i.x][i.y] = 0;
					}
					if (rep[0].size() < rep[1].size()) {
						swap(rep[0], rep[1]);
					}
					for (auto i : rep[1]) ans.pb(i);
				}
			}
		}
	}
	cout << ans.size() << '\n';
	for (auto i : ans) {
		cout << i << '\n';
	}
}