#include "bits/stdc++.h"

#define len(v) ((int)v.size())
#define pb push_back
#define mp make_pair
#define mt make_tuple
#define x first
#define y second

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v) {
		is >> x;
	}
	return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v) {
		os << x << " ";
	}
	return os;
}

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &p) {
	is >> p.x >> p.y;
	return is;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &p) {
	os << p.x << " " << p.y;
	return os;
}

void run();

signed main(int argc, char *argv[]) {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
}

int n, m, k;
vector<string> mat;
vector<vector<int>> dist;

vector<pii> shs;
bool is_cord(int x, int y) {
	return 0 <= x && x < n && 0 <= y && y < m;
}

vector<pii> del(int st) {
	vector<vector<bool>> can(n, vector<bool>(m, true));	
	vector<pii> rez;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			if (mat[i][j] == '#') continue;
			if ((i + j) % 2 == st) {
				rez.emplace_back(i, j);
				can[i][j] = false;
			}
		}
	}
	for (int t = 0; t < k + 1; t++) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (mat[i][j] == '#') continue;
				if ((i + j + st + 1) % 2 == t % 2) {
					if (can[i][j]) {
						rez.emplace_back(i, j);
						can[i][j] = false;
						for (pii sh : shs) {
							pii sub = mp(i + sh.x, j + sh.y);
							if (is_cord(sub.x, sub.y)) {
								if (mat[sub.x][sub.y] == '#') continue;
								can[sub.x][sub.y] = true;
							}
						}
					}
				}
			}
		}
	}
	return rez;
}

void run() {
	for (int dx = -2; dx <= 2; dx++) {
		for (int dy = -2; dy <= 2; dy++) {
			if (abs(dx) + abs(dy) == 3) {
				shs.emplace_back(dx, dy);
			}
		}
	}
	cin >> n >> m >> k;
	mat.resize(n, string(m, '.'));
	dist.resize(n, vector<int>(m, 1e9));
	cin >> mat;
	// vector<pii> deq;
	// for (int i = 0; i < n; i++) {
	// 	for (int j = 0; j < m; j++) {
	// 		if (mat[i][j] == '.') {
	// 			dist[i][j] = 0;
	// 			// deq.emplace(i, j);
	// 		}
	// 	}
	// }
	// vector<pii> rez;
	// while (true) {
	// 	pii best = mp(0, 0);
	// 	for (int i = 0; i < n; i++) {
	// 		for (int j = 0; j < m; j++) {

	// 			if (dist[i][j] < dist[best.x][best.y]) {
	// 				best = mp(i, j);
	// 			}
	// 		}
	// 	}	
	// 	if (dist[best.x][best.y] > k) break;
	// 	for (pii sh : shs) {
	// 		pii sub = mp(best.x + sh.x, best.y + sh.y);
	// 		if (is_cord(sub.x, sub.y) && mat[sub.x][sub.y] == '.') {
	// 			dist[sub.x][sub.y] = min(dist[sub.x][sub.y], dist[best.x][best.y] + 1);
	// 		}
	// 	}
	// 	dist[best.x][best.y] = 1e9;
	// 	rez.pb(best);
	// }
	vector<pii> A = del(0);
	vector<pii> B = del(1);
	if (len(B) < len(A)) {
		A = B;
	}
	cout << len(A) << endl;
	for (pii p : A) {
		cout << p.x << " " << p.y << endl;
	}
}