
#include <bits/stdc++.h>
#include "park.h"

using namespace std;
#define mp make_pair
#define pb push_back
#define sz(c) (int)(c).size()
#define all(c) (c).begin(), (c).end()
template<class t1, class t2> inline void chkmin(t1 &a, const t2 &b) {if (a > b) a = b;}
template<class t1, class t2> inline void chkmax(t1 &a, const t2 &b) {if (a < b) a = b;}
const int MAXN = 200228;


vector<int> g[MAXN];
map<int, bool> dir[MAXN], was[MAXN];
bool wout[MAXN];
bool win[MAXN];
int have[MAXN];
	set<pair<int, int> > s;

bool isok(int a, int b) {
	if (dir[a].find(b) == dir[a].end()) {
		return false;
	}
	return !((a < b) ^ dir[a][b]);
}


void ans(int a, int b) {
	state_direction({a, b}, a < b);
	s.erase({have[a], a});
	s.erase({have[b], b});
	have[a]--;
	have[b]--;
	s.insert({have[a], a});
	s.insert({have[b], b});
	wout[a] = true;
	win[b] = true;
	dir[a][b] = a < b;
	dir[b][a] = dir[a][b];
}


void check(int a, int b) {
	if (!win[a] && have[a] == 1) {
		ans(b, a);
		return;
	}
	if (!wout[a] && have[a] == 1) {
		ans(a, b);
		return;
	}
	if (!wout[b] && have[b] == 1) {
		ans(b, a);
		return;
	}
	if (!win[b] && have[b] == 1) {
		ans(a, b);
		return;
	}
	for (auto c: g[a]) {
		if (was[c][b]) {
			if (isok(a, c) && isok(c, b)) {
				ans(a, b);
				return;
			}
			if (isok(c, a) && isok(b, c)) {
				ans(b, a);
				return;
			}
		}
	}
	for (auto c: g[b]) {
		if (was[c][a]) {
			if (isok(b, c) && isok(c, a)) {
				ans(b, a);
				return;
			}
			if (isok(c, b) && isok(a, c)) {
				ans(a, b);
				return;
			}
		}
	}
	vector<pair<int, int> > f;
	f.pb({a, b});
	int s = get_xor(f);
	if ((a < b) != s) {
		swap(a, b);
	}
	ans(a, b);
}


void run (int n) {
	n++;
	for (int i = 1; i < 2  * n; i++) {
		g[i].pb(i + 1);
		g[i + 1].pb(i);
	}
	for (int i = 1; i + 2 <= 2 * n; i += 2) {
		g[i].pb(i + 2);
		g[i + 2].pb(i);
	}
	for (int i = 2; i + 2 <= 2 * n; i += 2) {
		g[i].pb(i + 2);
		g[i + 2].pb(i);
	}
	for (int i = 2; i < 2 * n; i++) {
		have[i] = sz(g[i]);
	}
	for (int i = 1; i <= 2 * n; i++) {
		for (auto x: g[i]) {
			was[i][x] = true;
		}
	}
	for (auto x: g[1]) {
		state_direction({1, x}, 1);
		dir[1][x] = true;
		dir[x][1] = true;
		win[x] = true;
		have[x]--;
	}
	for (auto x: g[2 * n]) {
		state_direction({2 * n, x}, 1);
		dir[2 * n][x] = true;
		dir[x][2 * n] = true;
		wout[x] = true;
		have[x]--;
	}

	for (int i = 2; i < 2 * n; i++) {
		s.insert({have[i], i});
	}
	while (!s.empty()) {
		pair<int, int> p = *s.begin();
		if (p.first == 0) {
			s.erase(p);
			continue;
		}
		int i = p.second;
		for (auto x: g[i]) {
			if (dir[i].find(x) == dir[i].end()) {
				check(i, x);
				break;
			}
		}
	}
}