#include <bits/stdc++.h>
using namespace std;

#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(x) (x).begin(), (x).end()
#define f first
#define s second
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
#define FAST_IO ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)

const int MAXN = 1e5 + 5;
int n, m;
pair<ll, ll> a[MAXN];
bool used[MAXN];
ll pref[MAXN];

ll get(int i, ll x) {
    return a[i].f + a[i].s * x;
}

ll get_max(ll d) {
    ll r = 0, p;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            ll k = get(i, d);
            if (k > r) {
                r = k;
                p = i;
            }
        }
    }

    used[p] = true;
    return p;
}

ll alt(ll cnt) {
    ll res = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            ll c = cnt - 2;

            ll sum = get(i, m - cnt) + get(j, m - cnt);
            if (i >= c) {
                sum += pref[c - 1];
            } else if (j >= c + 1) {
                // sum += pref[i - 1]
                if (i != 0) sum += pref[i - 1];
                sum += pref[c] - pref[i];
            } else {
                if (i != 0) sum += pref[i - 1];
                sum += pref[j - 1] - pref[i];
                sum += pref[c + 1] - pref[j];
            }

            // for (int k = 0; c > 0; ++k) {
            //     if (k == i || k == j) continue;

            //     sum += a[k].f;
            //     c--;
            // }

            res = max(res, sum);
        }
    }

    return res;
}

int main() {
    FAST_IO;
    cin >> n >> m;
    rep(i, n) {
        cin >> a[i].f >> a[i].s;
    }
    pref[0] = a[0].f;
    for (int i = 1; i < n; ++i) {
        pref[i] = pref[i - 1] + a[i].f;
    }


    sort(a, a + n);
    reverse(a, a + n);

    for (int i = 1; i <= n; ++i) {
        if (i > m) {
            cout << 0 << '\n';
            continue;
        }

        fill(used, used + n, false);
        if (i == 1) {
            ll d = m - 1;
            cout << get(get_max(d), d) << '\n';
            continue;
        }

        cout << alt(i) << endl;
    }
}