#include <bits/stdc++.h>
using namespace std;

#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(x) (x).begin(), (x).end()
#define f first
#define s second
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
#define FAST_IO ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)

const int MAXN = 1e5 + 5;
int n, m;
pair<ll, ll> a[MAXN];
bool used[MAXN];

ll get(int i, ll x) {
    return a[i].f + a[i].s * x;
}

ll get_max(int l, int r, ll d) {
    ll res = 0, p;
    for (int i = l; i <= r; ++i) {
        if (!used[i]) {
            ll k = get(i, d);
            if (k > res) {
                res = k;
                p = i;
            }
        }
    }

    used[p] = true;
    return p;
}

ll get_max_b(int l, int r) {
    ll res = 0, p;
    for (int i = l; i <= r; ++i) {
        if (!used[i]) {
            ll k = a[i].s;
            if (k > res) {
                res = k;
                p = i;
            }
        }
    }

    used[p] = true;
    return p;
}

void upd(ll &a1, ll &a2, ll b) {
    if (b > a2) {
        if (b >= a1) {
            a2 = a1;
            a1 = b;
        } else {
            a2 = b;
        }
    }
}

ll solve(int cnt) {
    // cout << "solve " << cnt << endl;
    ll d = m - cnt;
    ll res = 0;
    for (int i = 0; i < cnt; ++i) {
        res += a[i].f;
    }

    ll a1 = get_max_b(0, cnt - 1);
    ll a2 = get_max_b(0, cnt - 1);

    // cout << ": " << a1 << ' ' << a2 << endl;

    res -= a[a1].f;
    res -= a[a2].f;

    // cout << res << endl;

    a1 = get(a1, d);
    a2 = get(a2, d);

    if (cnt < n) {
        upd(a1, a2, get(get_max(cnt, n - 1, d), d));
    }
    if (cnt < n - 1) {
        upd(a1, a2, get(get_max(cnt, n - 1, d), d));
    }

    res += a1;
    res += a2;

    return res;
}

int main() {
    FAST_IO;
    cin >> n >> m;
    rep(i, n) {
        cin >> a[i].f >> a[i].s;
    }

    sort(a, a + n);
    reverse(a, a + n);

    for (int i = 1; i <= n; ++i) {
        if (i > m) {
            cout << 0 << '\n';
            continue;
        }

        fill(used, used + n, false);
        if (i == 1) {
            ll d = m - 1;
            cout << get(get_max(0, n - 1, d), d) << '\n';
            continue;
        }

        cout << solve(i) << endl;
    }
}
