#pragma GCC optimize("Ofast,unroll-loops")
#include <bits/stdc++.h>
using namespace std;

#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(x) (x).begin(), (x).end()
#define f first
#define s second
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
#define FAST_IO ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)

const int MAXN = 1e5 + 5;
int n, m;
pair<ll, ll> a[MAXN];
bool used[MAXN];
ll b1, b2;

ll get(int i, ll x) {
    return a[i].f + a[i].s * x;
}

ll get_mx_b(int l, int r) {
    ll res = 0, p;
    for (int i = l; i <= r; ++i) {
        if (!used[i] && a[i].s > res) {
            res = a[i].s;
            p = i;
        }
    }

    used[p] = true;
    return p;
}

ll mnp;

ll get_mn(int l, int r, ll d) {
    // cout << "get_mn" << endl;
    ll res = INT64_MAX, p;
    for (int i = l; i <= r; ++i) {
        ll b;
        if (i == b1) b = a[b1].s;
        else b = a[b2].s;

        ll k = a[i].f + b * d;
        if (k < res) {
            res = k;
            p = i;
        }
    }

    mnp = p;
    // cout << mnp << endl;
    return res;
}

ll mxp;

ll get_mx(ll l, ll r, ll d) {
    ll res = 0, p;
    for (int i = l; i <= r; ++i) {
        ll k = get(i, d);
        if (k > res) {
            res = k;
            p = i;
        }
    }

    // used[p] = true;
    mxp = p;
    return res;
}

vector<pii> sw;

ll solve(ll cnt) {
    ll d = m - cnt;
    ll res = 0;
    for (int i = 0; i < cnt; ++i) {
        res += a[i].f;
    }

    b1 = get_mx_b(0, cnt - 1);
    b2 = get_mx_b(0, cnt - 1);
    used[b1] = used[b2] = false;
    // b1 = a[b1].s;
    // b2 = a[b2].s;

    res += d * (a[b1].s + a[b2].s);

    // cout << ": " << res << endl;

    // ll a2 = get_mn(0, cnt - 1, d);
    // used[a1] = used[a2] = false;

    if (cnt < n) {
        ll mn = get_mn(0, cnt - 1, d);

        ll nw = get_mx(cnt, n - 1, d);
        if (nw > mn) {
            res -= mn;
            res += nw;
            swap(a[mnp], a[mxp]);
            sw.push_back({mnp, mxp});
        }
    }
    if (cnt < n - 1) {
        b1 = get_mx_b(0, cnt - 1);
        b2 = get_mx_b(0, cnt - 1);
        used[b1] = used[b2] = false;

        ll mn = get_mn(0, cnt - 1, d);

        ll nw = get_mx(cnt, n - 1, d);
        if (nw > mn) {
            res -= mn;
            res += nw;
            swap(a[mnp], a[mxp]);
            sw.push_back({mnp, mxp});
        }
    }

    while (!sw.empty()) {
        swap(a[sw.back().f], a[sw.back().s]);
        sw.pop_back();
    }

    return res;
}

int main() {
    FAST_IO;
    cin >> n >> m;
    rep(i, n) {
        cin >> a[i].f >> a[i].s;
    }

    sort(a, a + n);
    reverse(a, a + n);

    for (int i = 1; i <= n; ++i) {
        if (i > m) {
            cout << 0 << '\n';
            continue;
        }

        fill(used, used + n, false);
        if (i == 1) {
            cout << get_mx(0, n - 1, m - 1) << '\n';
            continue;
        }

        cout << solve(i) << '\n';
    }
}
