#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define x first
#define y second

using namespace std;

typedef long long ll;

char a[105][105];
int dx[8] = {-2, -1, 1, 2, 2, 1, -1, -2}, dy[8] = {1, 2, 2, 1, -1, -2, -2, -1};
int n, m;

bool ok(int x, int y)
{
    return x >= 0 && x < n && y >= 0 && y < m;
}

int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0); cin.tie(0);
    int k;
    cin >> n >> m >> k;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cin >> a[i][j];
    vector <pair <int, int> > black, white, pust;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
        {
            if (a[i][j] == '#') continue;
            bool fl = false;
            for (int t = 0; t < 8; t++)
            {
                int nx = i + dx[t], ny = j + dy[t];
                if (ok(nx, ny) && a[nx][ny] == '.') fl = true;
            }
            if (fl)
            {
                if ((i + j) % 2 == 0) black.pb(mp(i, j));
                else white.pb(mp(i, j));
            }
            else pust.pb(mp(i, j));
        }
    int A = (int) pust.size(), B = (int) black.size(), C = (int) white.size();
    if (k % 2 == 0)
    {
        assert(0);
        cout << A + ((k + 2) / 2) * (B + C) << '\n';
        for (int i = 0; i < (int) pust.size(); i++)
            cout << pust[i].x << ' ' << pust[i].y << '\n';
        for (int i = 1; i <= (k + 2) / 2; i++)
        {
            for (int j = 0; j < (int) black.size(); j++)
                cout << black[j].x << ' ' << black[j].y << '\n';
            for (int j = 0; j < (int) white.size(); j++)
                cout << white[j].x << ' ' << white[j].y << '\n';
        }
    }
    else
    {
        if (B <= C)
        {
            cout << A + B + ((k + 1) / 2) * (B + C) << '\n';
            for (int i = 0; i < (int) pust.size(); i++)
                cout << pust[i].x << ' ' << pust[i].y << '\n';
            for (int i = 0; i < (int) black.size(); i++)
                cout << black[i].x << ' ' << black[i].y << '\n';
            for (int i = 1; i <= (k + 1) / 2; i++)
            {
                for (int j = 0; j < (int) white.size(); j++)
                    cout << white[j].x << ' ' << white[j].y << '\n';
                for (int j = 0; j < (int) black.size(); j++)
                    cout << black[j].x << ' ' << black[j].y << '\n';
            }
        }
        else
        {
            cout << A + C + ((k + 1) / 2) * (B + C) << '\n';
            for (int i = 0; i < (int) pust.size(); i++)
                cout << pust[i].x << ' ' << pust[i].y << '\n';
            for (int i = 0; i < (int) white.size(); i++)
                cout << white[i].x << ' ' << white[i].y << '\n';
            for (int i = 1; i <= (k + 1) / 2; i++)
            {
                for (int j = 0; j < (int) black.size(); j++)
                    cout << black[j].x << ' ' << black[j].y << '\n';
                for (int j = 0; j < (int) white.size(); j++)
                    cout << white[j].x << ' ' << white[j].y << '\n';
            }
        }
    }
    return 0;
}

