#include "park.h"
#include <bits/stdc++.h>
#define ll long long
#define mp make_pair
#define pb push_back
#define X first
#define Y second
#define pii pair<int, int>

using namespace std;

void run(int n);

const int MAXN = 2e5 + 100;
map<pii, pii> q;
int in[MAXN], out[MAXN];

void add(int x, int y, bool c)
{
    if (q[mp(x, y)] != mp(0, 0))
        return;
    state_direction({mp(x, y)}, c);
    q[mp(x, y)] = mp(c, 1);
    if (c)
    {
        out[x]++;
        in[y]++;
    }
    else
    {
        out[y]++;
        in[x]++;
    }
}

void check(int i)
{
    if (in[i - 1] == 3 && out[i - 1] == 0)
    {
        state_direction({mp(i - 1, i + 1)}, 1);
        q[mp(i - 1, i + 1)] = mp(1, 1);
        in[i + 1]++;
        out[i - 1]++;
    }

    if (out[i - 1] == 3 && in[i - 1] == 0)
    {
        state_direction({mp(i - 1, i + 1)}, 1);
        q[mp(i - 1, i + 1)] = mp(1, 1);
        in[i + 1]++;
        out[i - 1]++;
    }
    if (in[i] == 2 && out[i] == 0)
    {
        state_direction({mp(i, i + 2)}, 1);
        q[mp(i, i + 2)] = mp(1, 1);
        in[i + 2]++;
        out[i]++;
    }
    if (out[i] == 2 && in[i] == 0)
    {
        state_direction({mp(i, i + 2)}, 0);
        q[mp(i, i + 2)] = mp(0, 1);
        in[i]++;
        out[i + 2]++;
    }
    if (q[mp(i - 1, i)] == q[mp(i, i + 1)])
    {
        add(i - 1, i + 1, q[mp(i - 1, i)].X);
    }
    if (q[mp(i - 1, i + 1)] == mp(1, 1) && q[mp(i, i + 1)] == mp(0, 1))
        add(i - 1, i, 1);
    if (q[mp(i - 1, i + 1)] == mp(0, 1) && q[mp(i, i + 1)] == mp(1, 1))
        add(i - 1, i, 0);

    if (q[mp(i - 1, i)] == mp(0, 1) && q[mp(i - 1, i + 1)] == mp(1, 1))
        add(i, i + 1, 1);
    if (q[mp(i - 1, i)] == mp(1, 1) && q[mp(i - 1, i + 1)] == mp(0, 1))
        add(i, i + 1, 0);

    if (q[mp(i, i + 1)] == mp(0, 1) && q[mp(i, i + 2)] == mp(1, 1))
        add(i + 1, i + 2, 1);
    if (q[mp(i, i + 1)] == mp(1, 1) && q[mp(i, i + 2)] == mp(0, 1))
        add(i + 1, i + 2, 0);

    if (q[mp(i, i + 2)] == mp(1, 1) && q[mp(i + 1, i + 2)] == mp(0, 1))
        add(i, i + 1, 1);
    if (q[mp(i, i + 2)] == mp(0, 1) && q[mp(i + 1, i + 2)] == mp(1, 1))
        add(i, i + 1, 0);

    if (q[mp(i, i + 1)] == mp(0, 1) && q[mp(i + 1, i + 2)] == mp(0, 1))
        add(i, i + 2, 0);
    if (q[mp(i, i + 1)] == mp(1, 1) && q[mp(i + 1, i + 2)] == mp(1, 1))
        add(i, i + 2, 1);
}

void run(int n)
{
    add(1, 2, 1);
    add(1, 3, 1);
    add(2 * n + 1, 2 * n + 2, 1);
    add(2 * n, 2 * n + 2, 1);
    for (int i = 2; i <= 2 * n; i += 2)
    {
        if (q[mp(i, i + 1)] == mp(0, 0))
        {
            int c = get_xor({mp(i, i + 1)});
            add(i, i + 1, c);
            check(i);
        }
        if (q[mp(i - 1, i + 1)] == mp(0, 0))
        {
            int c = get_xor({mp(i - 1, i + 1)});
            add(i - 1, i + 1, c);
            check(i);
        }
        if (q[mp(i, i + 2)] == mp(0, 0))
        {
            int c = get_xor({mp(i, i + 2)});
            add(i, i + 2, c);
            check(i);
        }
        if (q[mp(i + 1, i + 2)] == mp(0, 0))
        {
            int c = get_xor({mp(i + 1, i + 2)});
            add(i + 1, i + 2, c);
            check(i);
        }
    }
    return;
}
