#include <bits/stdc++.h>
#define ll long long
#define mp make_pair
#define pb push_back
#define X first
#define Y second
#define pii pair<int, int>

using namespace std;

int solve();

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    solve();
    return 0;
}

const int N = 105;
int n, m, k;

pii go[8] = {{2, 1}, {-2, 1}, {2, -1}, {-2, -1}, {1, 2}, {1, -2}, {-1, 2}, {-1, -2}};
char a[N][N];
int cnt[N][N];
bool used[N][N];
vector<pii> order;
vector<pii> ans;

void dfs(int x, int y)
{
    used[x][y] = 1;
    order.pb(mp(x, y));
    for (int i = 0; i < 8; i++)
    {
        int tx = x + go[i].X;
        int ty = y + go[i].Y;
        if (tx < 0 || ty < 0 || tx >= n || ty >= m)
            continue;
        if (!used[tx][ty] && a[tx][ty] == '.')
            dfs(tx, ty);
    }
}

int d[N * N];

void add()
{
    for (int i = 0; i <= 7 * (int)log2(k); i++)
    {
        for (int j = 1; j < (int)order.size(); j += 2)
            ans.pb(order[j]);
        for (int j = 0; j < (int)order.size(); j += 2)
            ans.pb(order[j]);
    }
    for (int j = 1; j < (int)order.size(); j += 2)
        ans.pb(order[j]);
}

int solve()
{
    cin >> n >> m >> k;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cin >> a[i][j];

    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (a[i][j] == '.')
            {
                for (int k = 0; k < 8; k++)
                {
                    int tx = i + go[k].X;
                    int ty = j + go[k].Y;
                    if (tx < 0 || ty < 0 || tx >= n || ty >= m || a[tx][ty] != '.')
                        continue;
                    cnt[i][j]++;
                }
                if (cnt[i][j] == 0)
                    ans.pb(mp(i, j));
            }
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (!used[i][j] && cnt[i][j] == 1)
            {
                order.clear();
                dfs(i, j);
                add();
            }
    cout << (int)ans.size() << endl;
    for (int i = 0; i < (int)ans.size(); i++)
        cout << ans[i].X << ' ' << ans[i].Y << endl;
    return 0;
}

