#include <bits/stdc++.h>

using namespace std;

int n, m, k;
char mp[100][100];
bool w[100][100];

vector<pair<int, int>> lc[2];

bool free(int i, int j) {
    return i >= 0 && j >= 0 && i < n && j < m && mp[i][j] == '.';
}

void dfs(int i, int j, int c = 0, int pi = -1, int pj = -1) {
    lc[c].push_back({i, j});
    w[i][j] = true;
    for (int dx : {1, -1, 2, -2}) {
        for (int dy : {1, -1, 2, -2}) {
            if (abs(dx) + abs(dy) == 3) {
                if (free(i + dx, j + dy) && !w[i + dx][j + dy]) {
                    dfs(i + dx, j + dy, 1 - c, i, j);
                }
            } else if (free(i + dx, j + dy) && w[i + dx][j + dy]) {
                if (!(i + dx == pi && j + dy == pj)) {
                    flag = true;
                }
            }
        }
    }
}

int main()
{
    #ifdef _DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _DEBUG

    cin.sync_with_stdio(0);

    cin >> n >> m >> k;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> mp[i][j];
        }
    }
    vector<pair<int, int>> ans;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (!w[i][j] && free(i, j)) {
                for (int x : {0, 1}) {
                    lc[x].clear();
                }

                dfs(i, j);
                if (lc[0].size() + lc[1].size() == 1) {
                    ans.emplace_back(i, j);
                    continue;
                }

                if (lc[0].size() > lc[1].size()) {
                    swap(lc[0], lc[1]);
                }
                vector<int> dest = {0, 1, 0};
                if (flag) {
                    des.push_back(1);
                }
                for (int x : dest) {
                    for (auto d : lc[x]) {
                        ans.push_back(d);
                    }
                }
            }
        }
    }
    cout << ans.size() << '\n';
    for (auto d : ans) {
        cout << d.first << ' ' << d.second << '\n';
    }
    return 0;
}
