#include <bits/stdc++.h>
#define ll long long
using namespace std;

int dx[8] = {2, 2, -2, -2, 1, 1, -1, -1}, dy[8] = {1, -1, 1, -1, 2, -2, 2, -2};
const int N = 105;
char s[N][N];
bool used[N][N];
int n, m, k;

vector<pair<int, int>> d[2];

int dfs(int x, int y) {
    used[x][y] = 1;
    d[(x + y) % 2].push_back({x, y});
    for (int i = 0; i < 8; i++) {
        int a = x + dx[i], b = y + dy[i];
        if (a >= 0 && a < n && b >= 0 && b < m && !used[a][b] && s[a][b] == '.')
            dfs(a, b);
    }
}

int main()
{
#ifdef HOME
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // HOME

    scanf("%d%d%d", &n, &m, &k);

    for (int i = 0; i < n; i++) {
        scanf(" %s", s[i]);
    }

    vector<pair<int, int>> t;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (!used[i][j] && s[i][j] == '.') {
                d[0].clear();
                d[1].clear();
                dfs(i, j);
                if (d[0] < d[1]) {
                    swap(d[0], d[1]);
                }
                if (d[1].empty()) {
                    t.push_back(d[0][0]);
                    continue;
                }

                int g = 1 + (k + 1) / 2 + (k + 2) / 2;
                for (int z = 0; z < g; z++) {
                    int q = 1 - z % 2;
                    t.insert(t.end(), d[q].begin(), d[q].end());
                }
            }
        }
    }

    printf("%d\n", t.size());
    for (auto p : t)
        printf("%d %d\n", p.first, p.second);














    return 0;
}
