#include <bits/stdc++.h>

using namespace std;

#define size(s) (int)(s).size()
#define all(x) (x).begin(), x.end()

typedef long long ll;
typedef long double ld;

void bye() {
    cout << "\n";
    exit(0);
}

struct Coord {
    int x, y, num;
};

bool operator <(Coord a, Coord b) {
    return a.num < b.num || (a.num == b.num && a.x + a.y < b.x + b.y) ||
                        (a.num == b.num && a.x + a.y == b.x + b.y && a.x < b.x);
}

bool is_back(Coord a, Coord b) {
    return a.x + a.y < b.x + b.y || (a.x + a.y == b.x + b.y && a.x < b.x);
}

int XX[] = {1, 1, -1, -1, 2, 2, -2, -2};
int YY[] = {2, -2, 2, -2, 1, -1, 1, -1};
int n, m, k;
vector<vector<char> > g;

bool check(Coord v) {
    return v.x >= 0 && v.y >= 0 && v.x < n && v.y < m && g[v.x][v.y] != '#';
}

signed main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> m >> k;
    assert(n == 1 || m == 1);
    set<Coord> q;
    g.resize(n, vector<char>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> g[i][j];
            if (g[i][j] == '.') {
                q.insert({i, j, 0});
            }
        }
    }
    vector<Coord> ans;
    while (!q.empty()) {
        set<Coord> tmp;
        for (auto v : q) {
            ans.push_back(v);
            for (int j = 0; j < 8; j++) {
                Coord to = {v.x + XX[j], v.y + YY[j], v.num + 1};
                if (check(to) && is_back(to, v) && to.num <= k) {
                    tmp.insert(to);
                }
            }
        }
        q = tmp;
    }
    cout << size(ans) << "\n";
    for (auto v : ans) {
        cout << v.x << " " << v.y << "\n";
    }
    bye();
}
