#include <bits/stdc++.h>

using namespace std;

#define size(s) (int)(s).size()
#define all(x) (x).begin(), x.end()

typedef long long ll;
typedef long double ld;

void bye() {
    cout << "\n";
    exit(0);
}

struct Coord {
    int x, y;
};

bool operator <(Coord a, Coord b) {
    return a.x + a.y < b.x + b.y || (a.x + a.y == b.x + b.y && a.x < b.x);
}

int XX[] = {1, 1, -1, -1, 2, 2, -2, -2};
int YY[] = {2, -2, 2, -2, 1, -1, 1, -1};
int n, m, k;
vector<vector<char> > g;
vector<Coord> ans;

bool check(Coord v) {
    return v.x >= 0 && v.y >= 0 && v.x < n && v.y < m && g[v.x][v.y] != '#';
}

vector<vector<bool> > used;

void get_all(vector<Coord> &v, Coord s) {
    used[s.x][s.y] = 1;
    v.push_back(s);
    for (int i = 0; i < 8; i++) {
        Coord to = {s.x + XX[i], s.y + YY[i]};
        if (check(to) && !used[to.x][to.y]) {
            get_all(v, to);
        }
    }
}

void solve(vector<Coord> &v) {
    if (size(v) == 1) {
        ans.push_back(v[0]);
        return;
    }
    bool c = size(v) & 1;
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < size(v); j++) {
            if ((j & 1) == c) {
                ans.push_back(v[j]);
            }
        }
        c ^= 1;
        for (int j = 0; j < size(v); j++) {
            if ((j & 1) == c) {
                ans.push_back(v[j]);
            }
        }
        c ^= 1;
    }
    if (k & 1) {
        for (int j = 0; j < size(v); j++) {
            if ((j & 1) == c) {
                ans.push_back(v[j]);
            }
        }
    }
}

signed main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n >> m >> k;
    g.resize(n, vector<char>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> g[i][j];
        }
    }
    used.resize(n, vector<bool> (m, 0));
    if (m == 2) {
        vector<vector<Coord> > tmp;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (!used[i][j] && check({i, j})) {
                    tmp.push_back({});
                    get_all(tmp.back(), {i, j});
                }
            }
        }
        for (auto v : tmp) {
            solve(v);
        }
    }
    cout << size(ans) << "\n";
    for (auto v : ans) {
        cout << v.x << " " << v.y << "\n";
    }
    bye();
}
