#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e18;
const ld EPS = 1e-7;
const ld PI = acos(-1);

#define all(x) x.begin(), x.end()
#define size(x) (ll)x.size()
#define mp(a, b) make_pair(a, b)
#define f first
#define s second

void solve();

int main()
{
    #ifdef HOME
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif

    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
}


void solve()
{
    int n, l;
    cin >> n >> l;

    ll ans = 0;
    vector<pair<ll, ll>> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].f >> v[i].s;
        ans = max(ans, v[i].f + v[i].s * (l - 1));
    }

    sort(all(v));

    ll now = 0;

    cout << ans << "\n";
    for (int person = 2; person <= n; person++) {
        if (person > l) {
            cout << 0 << "\n";
            continue;
        }

        vector<bool> used(n, 0);
        ll mx1 = 0, id;
        for (int i = 0; i < n; i++) {
            if (mx1 < v[i].f + v[i].s * (l - person)) {
                id = i;
                mx1 = v[i].f + v[i].s * (l - person);
            }
        }

        used[id] = 1;

        ll mx2 = 0;
        for (int i = 0; i < n; i++) {
            if (mx2 < v[i].f + v[i].s * (l - person) && !used[i]) {
                id = i;
                mx2 = v[i].f + v[i].s * (l - person);
            }
        }

        used[id] = 1;

        int need = person - 2;
        for (int i = n - 1; i >= 0 && need; i--) {
            if (!used[i]) {
                mx1 += v[i].f;
                need--;
            }
        }

        cout << mx1 + mx2 << "\n";
    }
}
