#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define pb push_back
#define mp make_pair
template<typename T> bool ckmn(T &a, T b){ T c=a;a=min(a,b);return a!=c;}
template<typename T> bool ckmx(T &a, T b){ T c=a;a=max(a,b);return a!=c;}
//#define fastio
#ifdef fastio
    #define printf abcdef
    #define scanf abcdeg
#endif

struct Data
{
	ll val;
	int id;
	Data(ll a=0, int b=0):val(a),id(b){}
	bool operator < (Data b) const { return val<b.val;}
	bool operator > (Data b) const { return val>b.val;}
	bool operator <= (Data b) const { return val<=b.val;}
	bool operator >= (Data b) const { return val>=b.val;}
};
Data max(Data a, Data b){ return a>b?a:b;}
Data min(Data a, Data b){ return a>b?b:a;}
struct Line
{
	ll k,n;int id;
	Line(ll a=0, ll b=0, int i=0):k(a),n(b),id(i){}
	Data Get(ll x){ return Data(x*k+n,id);}
};
const int N=100050;
const int M=20*N;
const int lim=2*N;
struct PersistentLiChao
{
	int ls[M],rs[M],root[N],tsz,rsz;
	Line line[M];
	PersistentLiChao(){ tsz=0;}
	void AddLine(int p, int &c, int ss, int se, Line k)
	{
		c=++tsz;ls[c]=ls[p];rs[c]=rs[p];line[c]=line[p];
		if(!p){ line[c]=k;return;}
		Data A=line[c].Get(ss),B=k.Get(ss),C=line[c].Get(se),D=k.Get(se);
		if(A>=B && C>=D) return;
		if(A<=B && C<=D){ line[c]=k;return;}
		int mid=ss+se>>1;
		if(A<B) swap(line[c],k);
		if(line[c].Get(mid)>=k.Get(mid)) AddLine(rs[p],rs[c],mid+1,se,k);
		else swap(line[c],k),AddLine(ls[p],ls[c],ss,mid,k);
	}
	void AddLine(Line t){ rsz++;AddLine(root[rsz-1],root[rsz],1,lim,t);}
	Data Get(int c, int ss, int se, int qi)
	{
		if(!c) return Data(0,0);
		Data ans=line[c].Get(qi);
		if(ss==se) return ans;
		int mid=ss+se>>1;
		if(qi<=mid) return max(Get(ls[c],ss,mid,qi),ans);
		else return max(Get(rs[c],mid+1,se,qi),ans);
	}
	Data Get(int x, int ro){ return Get(root[ro],1,lim,x);}
} FW,BW;
const int H=2*N;
int ls[H],rs[H],sz[H],root,tsz;
ll sm[H];
void Set(int &c, int ss, int se, int qi, ll val, int f)
{
	if(!c) c=++tsz;
	sz[c]+=f;
	sm[c]+=val;
	if(ss==se) return;
	int mid=ss+se>>1;
	if(qi<=mid) Set(ls[c],ss,mid,qi,val,f);
	else Set(rs[c],mid+1,se,qi,val,f);
}
ll Get(int c, int ss, int se, int k)
{
	if(ss==se) return k>=sz[c]?sm[c]:0;
	int mid=ss+se>>1;
	if(sz[ls[c]]<=k) return sm[ls[c]]+Get(rs[c],mid+1,se,k-sz[ls[c]]);
	else return Get(ls[c],ss,mid,k);
}
int a[N],b[N],idx[N];
ll sum[N],ans[N];
vector<Data> all;
ll Get(int sz, int fid, int sid)
{
	int pf=fid,ps=sid;
	fid=idx[fid];
	sid=idx[sid];
	if(fid>sid) swap(fid,sid);
    ll ans=sum[sz];
    if(fid<=sz) ans-=a[fid],ans+=all[sz].val,sz++;
    if(sid<=sz) ans-=a[sid],ans+=all[sz].val;
    return ans;
}
int main()
{
#ifdef fastio
    ios_base.sync_with_stdio(false);cin.tie(0);cout.tie(0);cerr.tie(0);
#endif

	int n,l,i,j,k;
	scanf("%i %i",&n,&l);
	for(i=1;i<=n;i++) scanf("%i %i",&a[i],&b[i]),all.pb(Data(a[i],i));
	sort(all.begin(),all.end());
	reverse(all.begin(),all.end());
	for(i=0;i<n;i++) idx[all[i].id]=i+1,sum[i+1]=sum[i]+all[i].val;
	for(i=1;i<=n;i++) FW.AddLine(Line(b[i],a[i],i));
	for(i=n;i>=1;i--) BW.AddLine(Line(b[i],a[i],i));
	for(i=1;i<=n;i++) Set(root,1,n,idx[i],a[i],1);
	for(i=1;i<=n;i++)
	{
		if(i>l){ ans[i]=0;continue;}
		if(i==1) ans[i]=FW.Get(l-i,n).val;
		else if(i==l) ans[i]=sum[i];
		else
		{
			for(int fid=1;fid<=n;fid++) for(int sid=fid+1;sid<=n;sid++)
			{
				//Set(root,1,n,idx[fid],-a[fid],-1);
				//Set(root,1,n,idx[sid],-a[sid],-1);
				ckmx(ans[i],(ll)(l-i)*b[fid]+a[fid]+(ll)(l-i)*b[sid]+a[sid]+Get(i-2,fid,sid));//+Get(root,1,n,i-2));
				//printf("%lld\n",(ll)(l-i)*b[fid]+a[fid]+(ll)(l-i)*b[sid]+a[sid]+Get(root,1,n,i-2));
				//Set(root,1,n,idx[fid],a[fid],1);
				//Set(root,1,n,idx[sid],a[sid],1);
			}
			/*Data fir=FW.Get(l-i,n);
			int fid=fir.id;
			Data sec=max(FW.Get(l-i,fid-1),BW.Get(l-i,n-fid));
			int sid=sec.id;
			//printf("fid:%i sid:%i\n",fid,sid);
			Set(root,1,n,idx[fid],-a[fid],-1);
			Set(root,1,n,idx[sid],-a[sid],-1);
			ans[i]=fir.val+sec.val+Get(root,1,n,i-2);
			Set(root,1,n,idx[fid],a[fid],1);
			Set(root,1,n,idx[sid],a[sid],1);*/
		}
	}
	for(i=1;i<=n;i++) printf("%lld\n",ans[i]);
    return 0;
}
