#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define pb push_back
#define mp make_pair
template<typename T> bool ckmn(T &a, T b){ T c=a;a=min(a,b);return a!=c;}
template<typename T> bool ckmx(T &a, T b){ T c=a;a=max(a,b);return a!=c;}
//#define fastio
#ifdef fastio
    #define printf abcdef
    #define scanf abcdeg
#endif

bool debug=0;

struct Data
{
	ll val;
	int id;
	Data(ll a=0, int b=0):val(a),id(b){}
	bool operator < (Data b) const { return val<b.val;}
	bool operator > (Data b) const { return val>b.val;}
	bool operator <= (Data b) const { return val<=b.val;}
	bool operator >= (Data b) const { return val>=b.val;}
};
Data max(Data a, Data b){ return a>b?a:b;}
Data min(Data a, Data b){ return a>b?b:a;}
struct Line
{
	ll k,n;int id;
	Line(ll a=0, ll b=0, int i=0):k(a),n(b),id(i){}
	Data Get(ll x){ return Data(x*k+n,id);}
	bool operator < (Line b) const { return k<b.k || (k==b.k && n>b.n);}
};
ll inter(Line a, Line b)
{
	ll p=a.n-b.n,q=b.k-a.k;
	if(q<0) p=-p,q=-q;
	if(p>0) return (p+q-1)/q;
	else return p/q;
}
const int N=100050;
const int M=20*N;
const int lim=2*N;
struct PersistentLiChao
{
	int ls[M],rs[M],root[N],tsz,rsz;
	Line line[M];
	PersistentLiChao(){ tsz=0;}
	void AddLine(int p, int &c, int ss, int se, Line k)
	{
		c=++tsz;ls[c]=ls[p];rs[c]=rs[p];line[c]=line[p];
		if(!p){ line[c]=k;return;}
		Data A=line[c].Get(ss),B=k.Get(ss),C=line[c].Get(se),D=k.Get(se);
		if(A>=B && C>=D) return;
		if(A<=B && C<=D){ line[c]=k;return;}
		int mid=ss+se>>1;
		if(A<B) swap(line[c],k);
		if(line[c].Get(mid)>=k.Get(mid)) AddLine(rs[p],rs[c],mid+1,se,k);
		else swap(line[c],k),AddLine(ls[p],ls[c],ss,mid,k);
	}
	void AddLine(Line t){ rsz++;AddLine(root[rsz-1],root[rsz],1,lim,t);}
	Data Get(int c, int ss, int se, int qi)
	{
		if(!c) return Data(0,0);
		Data ans=line[c].Get(qi);
		if(ss==se) return ans;
		int mid=ss+se>>1;
		if(qi<=mid) return max(Get(ls[c],ss,mid,qi),ans);
		else return max(Get(rs[c],mid+1,se,qi),ans);
	}
	Data Get(int x, int ro){ return Get(root[ro],1,lim,x);}
} FW,BW,SO;
const int H=2*N;
vector<Line> MergeSort(const vector<Line> &a, const vector<Line> &b)
{
    int i=0,j=0;
    vector<Line> ans;
    while(i<a.size() || j<b.size())
	{
		if(j==b.size()) ans.pb(a[i++]);
		else if(i==a.size()) ans.pb(b[j++]);
		else if(a[i]<b[j]) ans.pb(a[i++]);
		else ans.pb(b[j++]);
	}
	return ans;
}
struct CHTTree
{
	int ls[H],rs[H],root,tsz;
	vector<Line> hull[H];
	Line pl[N];
	CHTTree(){}
	void Set(int i, Line k){ pl[i]=k;}
	void init(int &c, int ss, int se)
	{
		c=++tsz;
		if(ss==se){ hull[c].pb(pl[ss]);return;}
		int mid=ss+se>>1;
		init(ls[c],ss,mid);
		init(rs[c],mid+1,se);
		vector<Line> tmp=MergeSort(hull[ls[c]],hull[rs[c]]);
		for(int i=0;i<tmp.size();i++)
		{
			if(hull[c].size() && hull[c].back().k==tmp[i].k) continue;
			while(hull[c].size()>1)
			{
				int sz=hull[c].size();
                if(inter(hull[c][sz-2],tmp[i])<inter(hull[c][sz-1],tmp[i])) hull[c].pop_back();
                else break;
			}
			hull[c].pb(tmp[i]);
		}
	}
	Data Get(int c, int ss, int se, int qs, int qe, ll val)
	{
		if(qs>qe || qs>se || ss>qe) return Data(0,0);
		if(qs<=ss && qe>=se)
		{
			if(!hull[c].size()) return Data(0,0);
			while(hull[c].size()>1)
			{
				int sz=hull[c].size();
				if(hull[c][sz-2].Get(val)>hull[c][sz-1].Get(val)) hull[c].pop_back();
				else break;
			}
			return hull[c].back().Get(val);
		}
		int mid=ss+se>>1;
		return max(Get(ls[c],ss,mid,qs,qe,val),Get(rs[c],mid+1,se,qs,qe,val));
	}
} CHT;
int ls[H],rs[H],sz[H],root,tsz;
ll sm[H];
void Set(int &c, int ss, int se, int qi, ll val, int f)
{
	if(!c) c=++tsz;
	sz[c]+=f;
	sm[c]+=val;
	if(ss==se) return;
	int mid=ss+se>>1;
	if(qi<=mid) Set(ls[c],ss,mid,qi,val,f);
	else Set(rs[c],mid+1,se,qi,val,f);
}
ll Get(int c, int ss, int se, int k)
{
	if(ss==se) return k>=sz[c]?sm[c]:0;
	int mid=ss+se>>1;
	if(sz[ls[c]]<=k) return sm[ls[c]]+Get(rs[c],mid+1,se,k-sz[ls[c]]);
	else return Get(ls[c],ss,mid,k);
}
int a[N],b[N],idx[N];
ll sum[N],ans[N];
vector<Data> all;
ll Get(int sz, int fid, int sid)
{
	int pf=fid,ps=sid;
	fid=idx[fid];
	sid=idx[sid];
	if(fid>sid) swap(fid,sid),swap(pf,ps);
    ll ans=sum[sz];
    if(fid<=sz) ans-=a[pf],ans+=all[sz].val,sz++;
    if(sid<=sz) ans-=a[ps],ans+=all[sz].val;
    return ans;
}
ll Asm;
set<pair<int,int> > A,B;
void Add(int id){ Asm+=a[id];A.insert(mp(a[id],id));B.insert(mp(b[id],id));}
void Del(int id){ Asm-=a[id];A.erase(mp(a[id],id));B.erase(mp(b[id],id));}
ll Calc(int sz)
{
	auto it=--B.end();
	ll Bsm=it->first;it--;Bsm+=it->first;
	//if(debug) printf("%lld %lld\n",Asm,Bsm);
	return Asm+Bsm*sz;
}
int Fir(){ auto it=A.begin();return it->second;}
int Sec(){ auto it=A.begin();it++;return it->second;}
int dxi[N];
int main()
{
#ifdef fastio
    ios_base.sync_with_stdio(false);cin.tie(0);cout.tie(0);cerr.tie(0);
#endif

	int n,l,i,j,k;
	scanf("%i %i",&n,&l);
	for(i=1;i<=n;i++) scanf("%i %i",&a[i],&b[i]),all.pb(Data(a[i],i));
	sort(all.begin(),all.end());
	reverse(all.begin(),all.end());
	for(i=0;i<n;i++) idx[all[i].id]=i+1,sum[i+1]=sum[i]+all[i].val;
	//for(i=1;i<=n;i++) FW.AddLine(Line(b[i],a[i],i));
	//for(i=n;i>=1;i--) BW.AddLine(Line(b[i],a[i],i));
	//for(i=1;i<=n;i++) Set(root,1,n,idx[i],a[i],1);
	ll take=0;
	int mxb=0,scb=0;
	vector<pair<pair<int,int> ,int> > p;
	for(i=1;i<=n;i++) p.pb(mp(mp(a[i],b[i]),i));
	sort(p.begin(),p.end());reverse(p.begin(),p.end());
	//for(i=n-1;i>=0;i--) SO.AddLine(Line(p[i].first.second,p[i].first.first,p[i].second));
	for(i=n-1;i>=0;i--) CHT.Set(i+1,Line(p[i].first.second,p[i].first.first,p[i].second)),dxi[p[i].second]=i+1;
	CHT.init(CHT.root,1,n);
	for(i=1;i<=n;i++)
	{
		//take+=p[i-1].first;
		//if(mxb<p[i-1].second) scb=mxb,mxb=p[i-1].second;
		//else if(scb<p[i-1].second) scb=p[i-1].second;
		Add(p[i-1].second);
		if(i>l){ ans[i]=0;continue;}
		if(i==1)
		{
			for(j=1;j<=n;j++) ckmx(ans[i],(ll)b[j]*(l-i)+a[j]);
			//ans[i]=FW.Get(l-i,n).val;
		}
		else if(i==l) ans[i]=sum[i];
		else
		{
			//for(int fid=1;fid<=n;fid++) for(int sid=fid+1;sid<=n;sid++)
			//{
				//Set(root,1,n,idx[fid],-a[fid],-1);
				//Set(root,1,n,idx[sid],-a[sid],-1);
				//ckmx(ans[i],(ll)(l-i)*b[fid]+a[fid]+(ll)(l-i)*b[sid]+a[sid]+Get(i-2,fid,sid));//+Get(root,1,n,i-2));
				//printf("%lld\n",(ll)(l-i)*b[fid]+a[fid]+(ll)(l-i)*b[sid]+a[sid]+Get(root,1,n,i-2));
				//Set(root,1,n,idx[fid],a[fid],1);
				//Set(root,1,n,idx[sid],a[sid],1);
			//}
			/*Data fir=FW.Get(l-i,n);
			int fid=fir.id;
			Data sec=max(FW.Get(l-i,fid-1),BW.Get(l-i,n-fid));
			int sid=sec.id;
			//printf("fid:%i sid:%i\n",fid,sid);
			Set(root,1,n,idx[fid],-a[fid],-1);
			Set(root,1,n,idx[sid],-a[sid],-1);
			ans[i]=fir.val+sec.val+Get(root,1,n,i-2);
			Set(root,1,n,idx[fid],a[fid],1);
			Set(root,1,n,idx[sid],a[sid],1);*/
			//if(i==n) debug=1;
			ans[i]=max(ans[i],Calc(l-i));//take+(ll)(mxb+scb)*(l-i));
			if(i>=2 && i!=n)
			{
				//Data thi=SO.Get(l-i,n-i);
				Data thi=CHT.Get(CHT.root,1,n,i+1,n,l-i);
				int t=thi.id;
				int f=Fir(),s=Sec();
				//printf("i:%i t:%i f:%i s:%i\n",i,t,f,s);
				Del(f);Add(t);ckmx(ans[i],Calc(l-i));Del(t);Add(f);
				Del(s);Add(t);ckmx(ans[i],Calc(l-i));Del(t);Add(s);
				Data fou=max(CHT.Get(CHT.root,1,n,i+1,dxi[t]-1,l-i),CHT.Get(CHT.root,1,n,dxi[t]+1,n,l-i));
				int m=fou.id;
				ll val=fou.val;
				/*for(j=i;j<p.size();j++)
				{
					int dd=p[j].second;
					if(dd==t) continue;
					ll tmp=(ll)b[dd]*(l-i)+a[dd];
					if(val<tmp) val=tmp,m=dd;
				}*/
				if(m!=0)
				{
					Del(f);Del(s);
					Add(t);Add(m);
					ckmx(ans[i],Calc(l-i));
					//if(i==6) printf("f:%i s:%i t:%i m:%i calc:%i\n",f,s,t,m,Calc(l-i));
					Del(m);Del(t);
					Add(s);Add(f);
				}
			}
		}
	}
	for(i=1;i<=n;i++) printf("%lld\n",ans[i]);
    return 0;
}
