#include <bits/stdc++.h>

using namespace std;

#define int int64_t

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	
	int N, M, K;
	cin >> N >> M >> K;
	
	vector<vector<int> > board(N, vector<int>(M));
	vector<int> blocked(M);
	vector<int> nojump(M);
	vector<pair<int, int> > query;
	
	if (M != 2)
		return 1;
	
	for (int n = 0; n < N; ++n) {
		for (int m = 0; m < M; ++m) {
			char tmp;
			cin >> tmp;
			
			board[n][m] = (tmp=='.'?1:0);
			if ((n == 2 || n == 3) && !board[n][m] && board[n-2][!m]) {
				nojump[!m]++;
				board[n-2][!m] = 2;
			}
			if ((n == N-3 || n == N-4) && !board[n][m] && board[n+2][!m]) {
				nojump[!m]++;
				board[n+2][!m] = 2;
			}
			if (n > 3 && !board[n][m] && !board[n-4][m] && board[n-2][!m]) {
				nojump[!m]++;
				board[n-2][!m] = 2;
			}
			blocked[m] += (tmp=='.'?0:1);
		}
	}
	
	if (N == 2 || N == 3) {
		if (board[1][0] == 1) {
			board[1][0] = 2;
			nojump[0]++;
		}
		if (board[1][1] == 1) {
			board[1][1] = 2;
			nojump[1]++;
		}
	}
	if (N < 3) {
		if (board[0][0] == 1) {
			board[0][0] = 2;
			nojump[0]++;
		}
		if (board[0][1] == 1) {
			board[0][1] = 2;
			nojump[1]++;
		}
	}
	
/*	for (int i = 0; i < N; ++i) {
		for (int j = 0; j < M; ++j) {
			cout << board[i][j];
		}
		cout << "\n";
	}*/
	
	if (blocked[0] + nojump[0] > blocked[1] + nojump[1]) {
		vector<pair<int, int> > tmp0;
		vector<pair<int, int> > tmp1;
		for (int i = 0; i < N; ++i) {
			if (board[i][0] == 0)
				continue;
			query.push_back({i, 0});
			if (board[i][0] != 2)
				tmp0.push_back({i, 0});
		}
		for (int i = 0; i < N; ++i) {
			if (board[i][1] == 0)
				continue;
			query.push_back({i, 1});
			if (board[i][1] != 2)
				tmp1.push_back({i, 1});
		}
		for (int i = 0; i < K; ++i) {
			if (i%2 == 0) {
				query.insert(query.end(), tmp0.begin(), tmp0.end());
			} else {
				query.insert(query.end(), tmp1.begin(), tmp1.end());
			}
		}
	} else {
		vector<pair<int, int> > tmp0;
		vector<pair<int, int> > tmp1;
		for (int i = 0; i < N; ++i) {
			if (board[i][1] == 0)
				continue;
			query.push_back({i, 1});
			if (board[i][1] != 2)
				tmp1.push_back({i, 1});
		}
		for (int i = 0; i < N; ++i) {
			if (board[i][0] == 0)
				continue;
			query.push_back({i, 0});
			if (board[i][0] != 2)
				tmp0.push_back({i, 0});
		}
//		cout << query.size() << "	" << tmp1.size() << "	" << tmp0.size() << "\n";
		for (int i = 0; i < K; ++i) {
			if (i%2 == 0) {
				query.insert(query.end(), tmp1.begin(), tmp1.end());
			} else {
				query.insert(query.end(), tmp0.begin(), tmp0.end());
			}
		}
	}
	
	cout << query.size() << "\n";
	
	for (int i = 0; i < query.size(); ++i) {
		cout << query[i].first << " " << query[i].second << "\n";
	}
	
	return 0;
}
