#include <bits/stdc++.h>
#define coutV(v) for (const auto& e: v) {cout << e << " ";} cout << "\n"

#include "park.h"

using namespace std;

void run(int N) {
	
	bool dirL = true; // First edge is pointing down
	state_direction({1, 2}, true);
	
	for (int pos = 0; pos < N; pos++) {
		
		bool all = get_xor({
			{2*pos + 1, 2*pos + 3},
			{2*pos + 2, 2*pos + 3},
			{2*pos + 2, 2*pos + 4},
			{2*pos + 3, 2*pos + 4}});
			
		bool edge = get_xor({
			{2*pos + 1, 2*pos + 3},
			{2*pos + 3, 2*pos + 4}});
		
		if (dirL) {
			// Left Edge Down
			
			if (all == 0 && edge == 0) {
				state_direction({2*pos + 1, 2*pos + 3}, true);
				state_direction({2*pos + 2, 2*pos + 3}, true);
				state_direction({2*pos + 2, 2*pos + 4}, true);
				state_direction({2*pos + 3, 2*pos + 4}, true);
				dirL = true;
			} else if (all == 1 && edge == 0) {
				state_direction({2*pos + 1, 2*pos + 3}, true);
				state_direction({2*pos + 2, 2*pos + 3}, false);
				state_direction({2*pos + 2, 2*pos + 4}, true);
				state_direction({2*pos + 3, 2*pos + 4}, true);
				dirL = true;
			} else if (all == 1 && edge == 1) {
				state_direction({2*pos + 1, 2*pos + 3}, true);
				state_direction({2*pos + 2, 2*pos + 3}, true);
				state_direction({2*pos + 2, 2*pos + 4}, true);
				state_direction({2*pos + 3, 2*pos + 4}, false);
				dirL = false;
			} else if (all == 0 && edge == 1) {
				state_direction({2*pos + 1, 2*pos + 3}, true);
				state_direction({2*pos + 2, 2*pos + 3}, true);
				state_direction({2*pos + 2, 2*pos + 4}, false);
				state_direction({2*pos + 3, 2*pos + 4}, false);
				dirL = false;
				cerr << "Shouldn't be possible! (Down)" << "\n";
			} else {
				cerr << "Not possible! (Down)" << "\n";
				exit(1);
			}
			
		} else {
			// Left Edge Up
			
			if (all == 0 && edge == 0) {
				state_direction({2*pos + 1, 2*pos + 3}, true);
				state_direction({2*pos + 2, 2*pos + 3}, true);
				state_direction({2*pos + 2, 2*pos + 4}, true);
				state_direction({2*pos + 3, 2*pos + 4}, true);
				dirL = true;
			} else if (all == 0 && edge == 1) {
				state_direction({2*pos + 1, 2*pos + 3}, true);
				state_direction({2*pos + 2, 2*pos + 3}, true);
				state_direction({2*pos + 2, 2*pos + 4}, false);
				state_direction({2*pos + 3, 2*pos + 4}, false);
				dirL = false;
			} else if (all == 1 && edge == 1) {
				state_direction({2*pos + 1, 2*pos + 3}, true);
				state_direction({2*pos + 2, 2*pos + 3}, true);
				state_direction({2*pos + 2, 2*pos + 4}, true);
				state_direction({2*pos + 3, 2*pos + 4}, false);
				dirL = false;
			} else {
				cerr << "Not possible! (Up)" << "\n";
				exit(1);
			}
		}
	}
	
}
