#include <bits/stdc++.h>
#define coutV(v) for (const auto& e: v) {cout << e << " ";} cout << "\n"

#include "park.h"

using namespace std;

//~ void run(int N) {
	
	//~ bool dirL = true; // First edge is pointing down
	//~ state_direction({1, 2}, true);
	
	//~ for (int pos = 0; pos < N; pos++) {
		
		//~ bool all = get_xor({
			//~ {2*pos + 1, 2*pos + 3},
			//~ {2*pos + 2, 2*pos + 3},
			//~ {2*pos + 2, 2*pos + 4},
			//~ {2*pos + 3, 2*pos + 4}});
			
		//~ bool edge = get_xor({
			//~ {2*pos + 1, 2*pos + 3},
			//~ {2*pos + 3, 2*pos + 4}});
		
		//~ if (dirL) {
			//~ // Left Edge Down
			
			//~ if (all == 0 && edge == 0) {
				//~ state_direction({2*pos + 1, 2*pos + 3}, true);
				//~ state_direction({2*pos + 2, 2*pos + 3}, true);
				//~ state_direction({2*pos + 2, 2*pos + 4}, true);
				//~ state_direction({2*pos + 3, 2*pos + 4}, true);
				//~ dirL = true;
			//~ } else if (all == 1 && edge == 0) {
				//~ state_direction({2*pos + 1, 2*pos + 3}, true);
				//~ state_direction({2*pos + 2, 2*pos + 3}, false);
				//~ state_direction({2*pos + 2, 2*pos + 4}, true);
				//~ state_direction({2*pos + 3, 2*pos + 4}, true);
				//~ dirL = true;
			//~ } else if (all == 1 && edge == 1) {
				//~ state_direction({2*pos + 1, 2*pos + 3}, true);
				//~ state_direction({2*pos + 2, 2*pos + 3}, true);
				//~ state_direction({2*pos + 2, 2*pos + 4}, true);
				//~ state_direction({2*pos + 3, 2*pos + 4}, false);
				//~ dirL = false;
			//~ } else if (all == 0 && edge == 1) {
				//~ state_direction({2*pos + 1, 2*pos + 3}, true);
				//~ state_direction({2*pos + 2, 2*pos + 3}, true);
				//~ state_direction({2*pos + 2, 2*pos + 4}, false);
				//~ state_direction({2*pos + 3, 2*pos + 4}, false);
				//~ dirL = false;
				//~ cerr << "Shouldn't be possible! (Down)" << "\n";
			//~ } else {
				//~ cerr << "Not possible! (Down)" << "\n";
				//~ exit(1);
			//~ }
			
		//~ } else {
			//~ // Left Edge Up
			
			//~ if (all == 0 && edge == 0) {
				//~ state_direction({2*pos + 1, 2*pos + 3}, true);
				//~ state_direction({2*pos + 2, 2*pos + 3}, true);
				//~ state_direction({2*pos + 2, 2*pos + 4}, true);
				//~ state_direction({2*pos + 3, 2*pos + 4}, true);
				//~ dirL = true;
			//~ } else if (all == 0 && edge == 1) {
				//~ state_direction({2*pos + 1, 2*pos + 3}, true);
				//~ state_direction({2*pos + 2, 2*pos + 3}, true);
				//~ state_direction({2*pos + 2, 2*pos + 4}, false);
				//~ state_direction({2*pos + 3, 2*pos + 4}, false);
				//~ dirL = false;
			//~ } else if (all == 1 && edge == 1) {
				//~ state_direction({2*pos + 1, 2*pos + 3}, true);
				//~ state_direction({2*pos + 2, 2*pos + 3}, true);
				//~ state_direction({2*pos + 2, 2*pos + 4}, true);
				//~ state_direction({2*pos + 3, 2*pos + 4}, false);
				//~ dirL = false;
			//~ } else {
				//~ cerr << "Not possible! (Up)" << "\n";
				//~ exit(1);
			//~ }
		//~ }
	//~ }
	
//~ }

void run(int N) {
	
	// First and last edge
	state_direction({1, 2}, true);
	state_direction({2*N + 1, 2*N + 2}, true);
	
	for (int i = 0; i < N; i++) {
		state_direction({2*i + 1, 2*i + 3}, true);
		state_direction({2*i + 2, 2*i + 4}, true);
	}
	
	// N % 2 == 0
	for (int i = 0; i < N - 1; i += 2) {
		
		vector<bool> ans (4, false);
		
		bool outX = get_xor({
			{2*i + 1, 2*i + 2},
			{2*i + 4, 2*i + 5}});
		bool midX = get_xor({
			{2*i + 2, 2*i + 3},
			{2*i + 3, 2*i + 4}});
			
		if (outX == 0 && midX == 0) {
			bool det = get_xor({{2*i + 1, 2*i + 2}});
			
			if (det == 1) { // 1
				ans[0] = true; ans[1] = true; ans[2] = true; ans[3] = true;
			} else { // 7
				ans[0] = false; ans[1] = true; ans[2] = true; ans[3] = false;
			}
		} else if (outX == 1 && midX == 0) {
			bool det = get_xor({{2*i + 1, 2*i + 2}});
			
			if (det == 1) { // 2
				ans[0] = true; ans[1] = true; ans[2] = true; ans[3] = false;
			} else { // 6
				ans[0] = false; ans[1] = true; ans[2] = true; ans[3] = true;
			}
		} else if (outX == 0 && midX == 1) {
			bool det = get_xor({{2*i + 3, 2*i + 4}});
			
			if (det == 1) { // 3
				ans[0] = true; ans[1] = false; ans[2] = true; ans[3] = true;
			} else { // 5
				ans[0] = true; ans[1] = true; ans[2] = false; ans[3] = true;
			}
		} else if (outX == 1 && midX == 1) {
			bool det = get_xor({{2*i + 1, 2*i + 2}});
			
			if (det == 1) { // 4
				ans[0] = true; ans[1] = false; ans[2] = true; ans[3] = false;
			} else { // 8
				ans[0] = false; ans[1] = true; ans[2] = false; ans[3] = true;
			}
		}
		
		state_direction({2*i + 1, 2*i + 2}, ans[0]);
		state_direction({2*i + 2, 2*i + 3}, ans[1]);
		state_direction({2*i + 3, 2*i + 4}, ans[2]);
		state_direction({2*i + 4, 2*i + 5}, ans[3]);
	}
	
	if (N % 2) {
		// Query last two edges
		state_direction({2*N - 1, 2*N}, get_xor({{2*N - 1, 2*N}}));
		state_direction({2*N, 2*N + 1}, get_xor({{2*N, 2*N + 1}}));
	}
	
}
