#include <bits/stdc++.h>
#define int long long
#define coutV(v) for (const auto& e: v) {cout << e << " ";} cout << "\n"

using namespace std;

int N, M, K;
vector<vector<bool>> board;

// N == y, M == x
vector<pair<int, int>> shots;
void shoot(int y, int x) {
	if (!board[y][x]) {
		shots.push_back({x, y});
	} else {
		cerr << "Position " << y << " " << x << " is blocked.\n";
	}
}

void output() {
	cout << shots.size() << "\n";
	for (const auto& shot: shots) {
		cout << shot.first << " " << shot.second << "\n";
	}
	exit(0);
}

signed main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	
	cin >> N >> M >> K;
	
	board.assign(N, vector<bool>(M, false));
	
	for (int i = 0; i < N; i++) {
		for (int j = 0; j < M; j++) {
			char c;
			cin >> c;
			board[i][j] = c == '#';
		}
	}
	
	// Case width or height == 1
	if (M == 1) {
		for (int i = 0; i < N; i++) {
			shoot(i, 0);
		}
		
		output();
	} else if (N == 1) {
		for (int i = 0; i < M; i++) {
			shoot(0, i);
		}
		
		output();
	}
	
	// Solve M == 2
	if (M == 2) {
		for (int _k = 0; _k <= K; _k++) {
			for (int x = 0; x < M; x++) {
				for (int y = 0; y < N; y++) {
					shoot(y, x);
				}
			}
		}
	}
	
	// Output
	output();
	
	return 0;
}

