#include <cstdio>
#include <algorithm>

using namespace std;
#define MAXN 100000

struct Person
{
    int sD;
    int aD;
};

bool PersonComp(Person& p1, Person& p2)
{
    return (p1.sD > p2.sD);
}

Person people[MAXN];
int n;

int l;

void Input()
{
    scanf("%d %d", &n, &l);

    for (int i = 0; i < n; i++)
    {
        scanf("%d %d", &people[i].sD, &people[i].aD);
    }
}

int GetMaxJoy(int k)
{
    if (k > l)
    {
        return 0;
    }

    if (k == 1)
    {
        int maxJoy = 0;
        for (int i = 0; i < n; i++)
        {
            maxJoy = max(maxJoy, people[i].sD + (l - 1) * people[i].aD);
        }
        return maxJoy;
    }

    int maxJoy = 0;
    int currJoy = 0;

    int a = 0;
    for (int i = 0; i < k; i++)
    {
        currJoy += people[i].sD;
        if (people[i].aD > people[a].aD)
        {
            a = i;
        }
    }
    int b = 0; if (b == a) b++;
    for (int i = 0; i < k; i++)
    {
        if (people[i].aD > people[b].aD && i != a)
        {
            b = i;
        }
    }
    currJoy += (l - k) * (people[a].aD + people[b].aD);

    return currJoy;
}

int main()
{
    Input();
    sort(people, people + n, PersonComp);

    for (int i = 1; i <= n; i++)
    {
        printf("%d\n", GetMaxJoy(i));
    }

    return 0;
}
