#include <cstdio>
#include <algorithm>

using namespace std;
#define MAXN 100000

struct Person
{
    int sD;
    int aD;
};

bool PersonComp(Person& p1, Person& p2)
{
    return (p1.sD > p2.sD);
}

Person people[MAXN];
int n;

int l;

void Input()
{
    scanf("%d %d", &n, &l);

    for (int i = 0; i < n; i++)
    {
        scanf("%d %d", &people[i].sD, &people[i].aD);
    }
}

int GetMaxJoy(int k)
{
    if (k > l)
    {
        return 0;
    }

    if (k == 1)
    {
        int maxJoy = 0;
        for (int i = 0; i < n; i++)
        {
            maxJoy = max(maxJoy, people[i].sD + (l - 1) * people[i].aD);
        }
        return maxJoy;
    }

    int bestA = 0, bestB = 1;
    for (int a = 0; a < n - 1; a++)
    {
        for (int b = a + 1; b < n; b++)
        {
            if ((l - k) * (people[a].aD + people[b].aD) + people[a].sD + people[b].sD >
                (l - k) * (people[bestA].aD + people[bestB].aD) + people[bestA].sD + people[bestB].sD)
            {
                bestA = a;
                bestB = b;
            }
        }
    }

    int maxJoy = (l - k) * (people[bestA].aD + people[bestB].aD) + people[bestA].sD + people[bestB].sD;
    int c = 2;
    for (int i = 0; i < n && c < k; i++)
    {
        if (i == bestA || i == bestB) continue;
        maxJoy += people[i].sD;
        c++;
    }

    return maxJoy;
}

int main()
{
    Input();
    sort(people, people + n, PersonComp);

    for (int i = 1; i <= n; i++)
    {
        printf("%d\n", GetMaxJoy(i));
    }

    return 0;
}
