#include <iostream>
#include <algorithm>

using namespace std;
#define MAXN 100000

struct Person
{
    long long sD;
    long long aD;
};

bool PersonComp(Person& p1, Person& p2)
{
    return (p1.sD > p2.sD);
}

Person people[MAXN];
long long n;

long long l;

void Input()
{
    cin >> n >> l;

    for (long long i = 0; i < n; i++)
    {
        cin >> people[i].sD >> people[i].aD;
    }
}

long long GetMaxJoy(long long k)
{
    if (k > l)
    {
        return 0;
    }

    if (k == 1)
    {
        long long maxJoy = 0;
        for (long long i = 0; i < n; i++)
        {
            maxJoy = max(maxJoy, people[i].sD + (l - 1) * people[i].aD);
        }
        return maxJoy;
    }

    long long bestA = 0, bestB = 1;
    for (long long a = 0; a < n - 1; a++)
    {
        for (long long b = a + 1; b < n; b++)
        {
            if ((l - k) * (people[a].aD + people[b].aD) + people[a].sD + people[b].sD >
                (l - k) * (people[bestA].aD + people[bestB].aD) + people[bestA].sD + people[bestB].sD)
            {
                bestA = a;
                bestB = b;
            }
        }
    }

    long long maxJoy = (l - k) * (people[bestA].aD + people[bestB].aD) + people[bestA].sD + people[bestB].sD;
    long long c = 2;
    for (long long i = 0; i < n && c < k; i++)
    {
        if (i == bestA || i == bestB) continue;
        maxJoy += people[i].sD;
        c++;
    }

    return maxJoy;
}

int main()
{
    Input();
    sort(people, people + n, PersonComp);

    for (long long i = 1; i <= n; i++)
    {
        cout << GetMaxJoy(i) << endl;
    }

    return 0;
}
