#include <iostream>
#include <algorithm>

using namespace std;
#define MAXN 100000
#define MAXL 200000

struct Person
{
    int sD;
    int aD;

    bool operator< (const Person& p) const
    {
        if (sD != p.sD) return sD < p.sD;
        return aD < p.aD;
    }
};

Person people[MAXN];
int n;

int l;

void Input()
{
    cin >> n >> l;

    for (int i = 0; i < n; i++)
    {
        cin >> people[i].sD >> people[i].aD;
    }
}

int GetMaxJoy(int k)
{
    if (k > l)
    {
        return 0;
    }

    if (k == 1)
    {
        int maxJoy = 0;
        int currJoy;
        for (int i = 0; i < n; i++)
        {
            currJoy = people[i].sD + (l - 1) * people[i].aD;
            maxJoy = max(maxJoy, currJoy);
        }
        return maxJoy;
    }

    int maxJoy = 0;

    do
    {
        int currJoy = 0;
        for (int i = 0; i < k; i++)
        {
            currJoy += people[i].sD;
        }
        int aDs = 0;
        for (int a = 0; a < k - 1; a++)
        {
            for (int b = a + 1; b < k; b++)
            {
                aDs = max(aDs, (l - k) * (people[a].aD + people[b].aD));
            }
        }
        currJoy += aDs;
        maxJoy = max(maxJoy, currJoy);
    } while (next_permutation(people, people + n));

    return maxJoy;
}

int main()
{
    Input();

    for (int i = 1; i <= n; i++)
    {
        cout << GetMaxJoy(i) << endl;
    }

    return 0;
}

/*
39
57
55
53
51
*/
