#include<iostream>
#include<vector>
#include<cstdio>
using namespace std;

int n,m,mat[128][128],k;
vector< vector < pair<int, int >  > > allShots;
bool used[1024][1024];
long long ans;

void resetTable()
{
    for(int i=0; i<=n+5; i++)
    {
        for(int j=0; j<=m+5; j++)
        {
            mat[i][j]=-1;
        }
    }
}

void findPath(int x, int y)
{
    vector< pair<int, int> > shots;
    int d=0;
    if(y==1)d=1;
    for(;;)
    {
        //cout<<x<<" "<<y<<endl;
        if(mat[x][y]==1||x>=n||y>=m||used[x][y]==1)break;
        shots.push_back(make_pair(x,y));
        used[x][y]=1;
        x+=2;
        if(d==1)
        {
            y-=1;
            d=0;
        }
        else
        {
            y+=1;
            d=1;
        }
        //cout<<x<<" "<<y<<endl;
        if(x>n)break;
        if(mat[x][y]==1||x>=n||y>=m||used[x][y]==1)break;
        shots.push_back(make_pair(x,y));
        used[x][y]=1;
        x+=2;
        if(d==1)
        {
            y-=1;
            d=0;
        }
        else
        {
            y+=1;
            d=1;
        }
    }
    if(shots.size()==1)ans+=1;
    else
    ans+=shots.size()*(k+1);
    allShots.push_back(shots);
}

int main()
{
    freopen("chess.in","r",stdin);
    resetTable();
    cin>>n>>m>>k;
    //cout<<n<<" "<<m<<" "<<k<<endl;
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            char x;
            cin>>x;
            if(x=='.')
            {
                mat[i][j]=0;
            }
            else mat[i][j]=1;
        }
    }

    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            if(used[i][j]==0)
            {
                findPath(i,j);
            }
        }
    };
    cout<<ans<<endl;
    int allshotSize=allShots.size();
    for(int i=0; i<allshotSize; i++)
    {
        int shotSize=allShots[i].size();
        for(int l=0; l<=k+2; l++)
        {
            for(int j=0; j<shotSize; j++)
            {
                cout<<allShots[i][j].first<<" "<<allShots[i][j].second<<endl;
            }
            if(shotSize==1)break;
        }
    }
    if(m>2){
        for(int i=0;i<=100000;i++){
            cout<<1<<" "<2<<endl;
        }
    }
    return 0;
}
